#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
import netCDF4
import ffgrid2


## grille ##

dx=1.
dy=1.
x0, x1 = -180, 180
y0, y1 = -90, -30

bbemis_ch1_JAN=nonzero((emis1_JAN!=-500.)&(emis1_JAN<1.))
ind_jr1_JAN=np.where(jjr1_JAN[bbemis_ch1_JAN]==15.)[0]
bbemis_ch1_JUL=nonzero((emis1_JUL!=-500.)&(emis1_JUL<1.))
ind_jr1_JUL=np.where(jjr1_JUL[bbemis_ch1_JUL]==15.)[0]
bbemis_ch4_JAN=nonzero((emis4_JAN!=-500.)&(emis4_JAN<1.))
ind_jr4_JAN=np.where(jjr4_JAN[bbemis_ch4_JAN]==15.)[0]
bbemis_ch4_JUL=nonzero((emis4_JUL!=-500.)&(emis4_JUL<1.))
ind_jr4_JUL=np.where(jjr4_JUL[bbemis_ch4_JUL]==15.)[0]

######## ch1-JAN ########
monthly_outzch1_JAN=np.zeros([61,361],float)
monthly_lonch1_JAN=np.zeros([361])
monthly_latch1_JAN=np.zeros([61])
xx = lon1_JAN[bbemis_ch1_JAN][ind_jr1_JAN]
yy = lat1_JAN[bbemis_ch1_JAN][ind_jr1_JAN]
zz = emis1_JAN[bbemis_ch1_JAN][ind_jr1_JAN]
zz0 = min(zz)
zz1 = max(zz)
outz, outx, outy = ffgrid2.ffgrid(xx, yy, zz, dx, dy, x0,x1,y0,y1,zz0, zz1)
monthly_outzch1_JAN=outz
monthly_lonch1_JAN=outx
monthly_latch1_JAN=outy

######## ch1-JUL ########
monthly_outzch1_JUL=np.zeros([61,361],float)
monthly_lonch1_JUL=np.zeros([361])
monthly_latch1_JUL=np.zeros([61])
xx = lon1_JUL[bbemis_ch1_JUL][ind_jr1_JUL] 
yy = lat1_JUL[bbemis_ch1_JUL][ind_jr1_JUL] 
zz = emis1_JUL[bbemis_ch1_JUL][ind_jr1_JUL]
zz0 = min(zz)
zz1 = max(zz)
outz, outx, outy = ffgrid2.ffgrid(xx, yy, zz, dx, dy, x0,x1,y0,y1,zz0, zz1)
monthly_outzch1_JUL=outz
monthly_lonch1_JUL=outx
monthly_latch1_JUL=outy

######## ch4-JAN ########
monthly_outzch4_JAN=np.zeros([61,361],float)
monthly_lonch4_JAN=np.zeros([361])
monthly_latch4_JAN=np.zeros([61])
xx = lon4_JAN[bbemis_ch4_JAN][ind_jr4_JAN]
yy = lat4_JAN[bbemis_ch4_JAN][ind_jr4_JAN]
zz = emis4_JAN[bbemis_ch4_JAN][ind_jr4_JAN]
zz0 = min(zz)
zz1 = max(zz)
outz, outx, outy = ffgrid2.ffgrid(xx, yy, zz, dx, dy, x0,x1,y0,y1,zz0, zz1)
monthly_outzch4_JAN=outz
monthly_lonch4_JAN=outx
monthly_latch4_JAN=outy

######## ch4-JUL ########
monthly_outzch4_JUL=np.zeros([61,361],float)
monthly_lonch4_JUL=np.zeros([361])
monthly_latch4_JUL=np.zeros([61])
xx = lon4_JUL[bbemis_ch4_JUL][ind_jr4_JUL] 
yy = lat4_JUL[bbemis_ch4_JUL][ind_jr4_JUL] 
zz = emis4_JUL[bbemis_ch4_JUL][ind_jr4_JUL]
zz0 = min(zz)
zz1 = max(zz)
outz, outx, outy = ffgrid2.ffgrid(xx, yy, zz, dx, dy, x0,x1,y0,y1,zz0, zz1)
monthly_outzch4_JUL=outz
monthly_lonch4_JUL=outx
monthly_latch4_JUL=outy

diff = monthly_outzch1_JUL - monthly_outzch4_JUL



###############
#### carto ####
###############

m = Basemap(llcrnrlon=-180,urcrnrlon=180,llcrnrlat=-90,urcrnrlat=-30,projection='cyl',resolution='c',fix_aspect=True)
m.drawcoastlines(linewidth=1)
m.drawparallels(np.arange(-90,90.,10))
m.drawmeridians(np.arange(-180,180.,10))
#m.fillcontinents()
clevs=arange(-0.26,0.13,0.01)
xii,yii = m(*np.meshgrid(monthly_lonch1_JAN,monthly_latch1_JAN))
cs=m.contourf(xii,yii,diff, clevs, cmap=cm.s3pcpn_l_r)
cbar =colorbar(cs)
cbar.set_label('emissivity difference 15/06/2010 (ch1-ch4)')
plt.show()

figure()
m = Basemap(llcrnrlon=-180,urcrnrlon=180,llcrnrlat=-90,urcrnrlat=-30,projection='cyl',resolution='c',fix_aspect=True)
m.drawcoastlines(linewidth=1)
m.drawparallels(np.arange(-90.,30.,20.))
m.drawmeridians(np.arange(-180.,180.,20.))
#m.fillcontinents()
clevsch2=arange(min(tbch2[bbch2]),max(tbch2[bbch2]),1)
xii,yii = m(*np.meshgrid(monthly_lonch1,monthly_latch1))
cs=m.contourf(xii,yii,monthly_outzch2, clevsch2, cmap=cm.s3pcpn_l_r)
cbar =colorbar(cs)
cbar.set_label('Tb_ch2')
plt.hold
plt.show()







ind_jr1=np.where(jjr1_JAN==1.)[0]
ind_jr2=np.where(jjr1_JAN==2.)[0]
