#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
import netCDF4

################ fichiers par mois - CH1 ###################################################

f1 = '/net/dedale/usr/dedale/surf/lelod/ANTARC/SSMIS_CH'
f3 = '_ANTARC_JUNE2010.DAT'
#date=np.array(['JANUARY', 'FEBRUARY', 'MARCH', 'APRIL', 'MAY', 'JUNE', 'JULY'])
channel = np.array([17, 18])
numlines = np.zeros([len(channel)],int)

for ich in range (0, len(channel)):
     f = f1 + str(channel[ich]) + f3
     fichier = open(f, 'r')
     numlines[ich] = 0
     for line in fichier: numlines[ich] += 1


fichier.close()

ich = 0 # 91.66GHz, V polar
fichier = open(f1 + str(channel[ich]) + f3, 'r')
ssmis = np.zeros([18, numlines[ich]], float)
for iligne in range (0,numlines[ich]-1):
    line = fichier.readline()
    liste = line.split()
    for j in range(0,18):
        ssmis[j,iligne] = float(liste[j])


fichier.close
ssch17_JUN=ssmis
lon17_JUN=ssch17_JUN[0,:]
lat17_JUN=ssch17_JUN[1,:]
jjr17_JUN=ssch17_JUN[4,:]
ts17_JUN=ssch17_JUN[8,:]
emis17_JUN=ssch17_JUN[14,:]
tb17_JUN=ssch17_JUN[13,:]
tup17_JUN=ssch17_JUN[16,:]
tdn17_JUN=ssch17_JUN[15,:]
trans17_JUN=ssch17_JUN[17,:]
orog17_JUN=ssch17_JUN[11,:]

ich = 1 # 91.66GHz, H polar
fichier = open(f1 + str(channel[ich]) + f3, 'r')
ssmis = np.zeros([18, numlines[ich]], float)
for iligne in range (0,numlines[ich]-1):
    line = fichier.readline()
    liste = line.split()
    for j in range(0,18):
        ssmis[j,iligne] = float(liste[j])


fichier.close
ssch18_JUN=ssmis
lon18_JUN=ssch18_JUN[0,:]
lat18_JUN=ssch18_JUN[1,:]
jjr18_JUN=ssch18_JUN[4,:]
ts18_JUN=ssch18_JUN[8,:]
emis18_JUN=ssch18_JUN[14,:]
tb18_JUN=ssch18_JUN[13,:]
tup18_JUN=ssch18_JUN[16,:]
tdn18_JUN=ssch18_JUN[15,:]
trans18_JUN=ssch18_JUN[17,:]
orog18_JUN=ssch18_JUN[11,:]


########################
# EVOLUTION TEMPORELLE #
########################
## Autour de "Dome C" (lon=123.23;lat=-75.06) - mois: JUNE ##
bbzone_CH17_JUN = nonzero((lon17_JUN>=120.23)&(lon17_JUN<=126.23)&(lat17_JUN>=-78.06)&(lat17_JUN<=-72.06))
emis17_JUN_moy = np.zeros([30],float)
tb17_JUN_moy = np.zeros([30],float)
ts17_JUN_moy = np.zeros([30],float)

bbzone_CH18_JUN = nonzero((lon18_JUN >= 120.23) & (lon18_JUN <= 126.23) & (lat18_JUN >= -78.06) & (lat18_JUN <= -72.06))
emis18_JUN_moy = np.zeros([30],float)
tb18_JUN_moy = np.zeros([30],float)
ts18_JUN_moy = np.zeros([30],float)

for ijr in range (0,30):
     print 'jour=', ijr+1
     ind_jr17 = np.where(jjr17_JUN[bbzone_CH17_JUN]==ijr+1)[0]
     a = emis17_JUN[bbzone_CH17_JUN][ind_jr17]
     b = tb17_JUN[bbzone_CH17_JUN][ind_jr17]
     c = ts17_JUN[bbzone_CH17_JUN][ind_jr17]
     emis17_JUN_moy[ijr] = mean(a[nonzero((a!=-500.)&(a<=1.))])
     tb17_JUN_moy[ijr] = mean(b[nonzero((b!=-500.)&(b!=0.))])
     ts17_JUN_moy[ijr] = mean(c[nonzero((c!=-500.)&(c!=0.))])
     ind_jr18 = np.where(jjr18_JUN[bbzone_CH18_JUN]==ijr+1)[0]
     d = emis18_JUN[bbzone_CH18_JUN][ind_jr18]
     e = tb18_JUN[bbzone_CH18_JUN][ind_jr18]
     f = ts18_JUN[bbzone_CH18_JUN][ind_jr18]
     emis18_JUN_moy[ijr] = mean(d[nonzero((d != -500.) & (d <= 1.))])
     tb18_JUN_moy[ijr] = mean(e[nonzero((e != -500.) & (e != 0.))])
     ts18_JUN_moy[ijr] = mean(f[nonzero((f != -500.) & (f != 0.))])


fig=plt.figure()
plt.subplot(3,1,1)
plt.plot(arange(0,30,1),emis17_JUN_moy,label='91.66GHz-V',c='r')
plt.plot(arange(0,30,1),emis18_JUN_moy,label='91.66GHz-H',c='b')
plt.xticks(arange(1,31,1))
grid(True)
ylabel('emissivity')
legend(loc=7)
plt.title('SSMIS - JUNE 2010')
plt.subplot(3,1,2)
plt.plot(arange(0,30,1),tb17_JUN_moy,label='91.66GHz-V',c='r')
plt.plot(arange(0,30,1),tb18_JUN_moy,label='91.66GHz-H',c='b')
plt.xticks(arange(1,31,1))
grid(True)
ylabel('brightness temperature')
legend(loc=7)
plt.subplot(3,1,3)
plt.plot(arange(0,30,1),ts17_JUN_moy,label='91.66GHz-V',c='r')
plt.plot(arange(0,30,1),ts18_JUN_moy,label='91.66GHz-H',c='b')
plt.xticks(arange(1,31,1))
grid(True)
ylabel('surface temperature')
legend(loc=7)


tb17_JUN_anom = np.zeros([30],float)
tb18_JUN_anom = np.zeros([30],float)
for ijr in range (0,30):
     print 'jour=', ijr + 1
     tb17_JUN_anom[ijr]=tb17_JUN_moy[ijr]-tb17_JUN_moy.mean()
     tb18_JUN_anom[ijr]=tb18_JUN_moy[ijr]-tb18_JUN_moy.mean()


fig=plt.figure()
plt.plot(arange(0,30,1),tb17_JUN_anom,label='91.66Ghz-V',c='r')
plt.plot(arange(0,30,1),tb18_JUN_anom,label='91.66GHz-H',c='b')
plt.plot(arange(0,30,1),np.ones([30]),'--',c='g')
plt.xticks(arange(1,31,1))
grid(True)
ylabel('Tb anomaly')
legend(loc=7)
plt.title('SSMIS - JUNE 2010')




################
# CARTOGRAPHIE #
################
dx=5.
dy=5.
x0, x1 = -180, 180
y0, y1 = -90, -30

bbemis_ch17_JUN=nonzero((emis17_JUN!=-500.)&(emis17_JUN<1.)&(emis17_JUN>0.))
bbtb_ch17_JUN=nonzero((tb17_JUN!=-500.)&(tb17_JUN!=0.))
OUTZCH17_JUN = np.zeros([len(np.arange(y0, y1, dy)),len(np.arange(x0, x1, dx)),30], float)
outzch17_JUN = np.zeros([len(np.arange(y0, y1, dy)),len(np.arange(x0, x1, dx))], float)
lonch17_JUN=np.zeros([len(np.arange(x0, x1, dx))], float)
latch17_JUN=np.zeros([len(np.arange(y0, y1, dy))], float)

for ijr in range(0,30):
    print 'jour=', ijr+1
    ind_jr17_JUN = np.where(jjr17_JUN[bbtb_ch17_JUN] == ijr+1)[0]
    xx = lon17_JUN[bbtb_ch17_JUN][ind_jr17_JUN]
    yy = lat17_JUN[bbtb_ch17_JUN][ind_jr17_JUN]
    zz = tb17_JUN[bbtb_ch17_JUN][ind_jr17_JUN]
    zz0 = min(zz)
    zz1 = max(zz)
    outz, outx, outy = ffgrid2.ffgrid(xx, yy, zz, dx, dy, x0,x1,y0,y1,zz0, zz1)
    outzch17_JUN=outz
    lonch17_JUN=outx
    latch17_JUN=outy
    OUTZCH17_JUN[:,:,ijr] = outzch17_JUN[:,:]
    

mean_outzch17_JUN = np.zeros([len(latch17_JUN), len(lonch17_JUN)], float)
for ilon in range (0,len(lonch17_JUN)):
    for ilat in range (0,len(latch17_JUN)):
        mean_outzch17_JUN[ilat,ilon] = OUTZCH17_JUN[ilat,ilon,:].mean()


tbch17_anom_JUN = np.zeros([len(latch17_JUN),lonch17_JUN,30], float)
for ijr in range (0,30):
    tbch17_anom_JUN[:,:,ijr] = OUTZCH17_JUN[:,:,ijr] - mean_outzch17_JUN[:,:]



fig = plt.figure()
plt.ion()
m = Basemap(llcrnrlon=-180, urcrnrlon=180, llcrnrlat=-90, urcrnrlat=-30, projection='cyl', resolution='c', fix_aspect=True)
m.drawcoastlines(linewidth = 1)
m.drawparallels(np.arange(-90., 90., 20))
m.drawmeridians(np.arange(-180., 180., 20))
#m.fillcontinents()
clevs = arange(-25., 25., 1.)
xii,yii = m(*np.meshgrid(lonch17_JUN, latch17_JUN))
cs = m.contourf(xii, yii, tbch17_anom_JUN[:,:,5], clevs, cmap=cm.s3pcpn_l_r)
cbar = colorbar(cs)
cbar.set_label('Tb anomaly SSMIS CH17 - JUNE')
