#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
from netCDF4 import Dataset
#import arctic_map # function to regrid coast limits
#import cartesian_grid_test # function to convert grid from polar to cartesian
import scipy.special



#####################
# read fichier .DAT #
#####################
month = np.array(['JANUARY', 'FEBRUARY', 'MARCH', 'APRIL', 'MAY', 'JUNE', 'JULY', 'AUGUST', 'SEPTEMBER', 'OCTOBER', 'NOVEMBER', 'DECEMBER'])
month_day = np.array([31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31]), 
M = len(month)




for imo in range (0, M):
    ####### open .dat file to stack data #######
    data_spec_lamb = open ('/net/argos/data/parvati/lahlod/ARCTIC/monthly_GLACE/lamb_spec_param_near_nadir_' + month[imo] + '2009_AMSUA50.dat', 'a')
    ############################################
    print 'read file' + month[imo]
    fichier = open('/net/argos/data/parvati/lahlod/ARCTIC/GLACE/AMSUA/GLACE_AMSUA_EMIS_' + month[imo] + '2009.DAT','r')
    numlines = 0
    for line in fichier: numlines += 1
    fichier.close
    fichier = open('/net/argos/data/parvati/lahlod/ARCTIC/GLACE/AMSUA/GLACE_AMSUA_EMIS_' + month[imo] + '2009.DAT','r')
    nbtotal = numlines - 1
    iligne = 0
    lat = np.zeros([nbtotal],float)
    lon = np.zeros([nbtotal],float)
    jjr = np.zeros([nbtotal],float)
    zen = np.zeros([nbtotal],float)
    fov = np.zeros([nbtotal],float)
    ts = np.zeros([nbtotal],float)
    emis= np.zeros([4, nbtotal],float)
    tb = np.zeros([4, nbtotal],float)
    tup = np.zeros([4, nbtotal],float)
    tdn = np.zeros([4, nbtotal],float)
    trans = np.zeros([4, nbtotal],float)
    # format:
    # printf, luna2, xlon, ylat, annee, mois, jour, heure, jour_obs, heure_obs, tsy, zeny, fovy, saty, masque, ee89, tb89, tup89, tdn89, trans89, format='(18(f12.3,1X))'  
    while (iligne < nbtotal) :
         line=fichier.readline()
         # exemple : line = "0.22 2.3 5.0 6"
         liste = line.split()
         # exemple : listeCoord ['0.22', '2.3', '5.0', '6'] (liste de chaine de caract?es)
         lat[iligne] = float(liste[1])
         lon[iligne] = float(liste[0])
         jjr[iligne] = float(liste[4])
         ts[iligne] = float(liste[8])
         fov[iligne] = float(liste[10])
         zen[iligne] = float(liste[9])
         for ki in range(0,4):
             emis[ki,iligne] = float(liste[13+ki])
             tb[ki,iligne] = float(liste[17+ki])
             tdn[ki,iligne] = float(liste[21+ki])
             tup[ki,iligne] = float(liste[25+ki])
             trans[ki,iligne] = float(liste[29+ki])
         iligne=iligne+1
    fichier.close()
    for i in range (0, nbtotal):
        if (emis[2, i] < 0.):
            emis[2, i] = NaN 
        if (emis[2, i] > 1.):
            emis[2, i] = 0.99  
    ############################
    # definition of parameters #
    ############################
    bblat = nonzero(lat >= 65.) # only high latitudes
    bbzen = nonzero(zen[bblat] < 20.) # only high latitudes
    jour = jjr[bblat][bbzen]
    llon = lon[bblat][bbzen] # longitude
    llat = lat[bblat][bbzen] # latitude
    zen_angle = zen[bblat][bbzen] # zenith angle
    field_view = fov[bblat][bbzen] # field of view
    e = emis[2, :][bblat][bbzen] # emissivity
    t_surf = ts[bblat][bbzen] # surface temperature
    t_up = tup[2, :][bblat][bbzen] # tup
    t_dn = tdn[2, :][bblat][bbzen] # tdown
    transm = trans[2, :][bblat][bbzen] # transmissivity
    t_b = tb[2, :][bblat][bbzen] # brightness temperature
    L = len(llon)
    #######################################
    # calculation of lamb_spec parameters #
    #######################################
    r = pi / 180.
    opac = - cos(zen_angle * r) * np.log(transm) 
    E3 = scipy.special.expn(3, opac)
    theta_eff = np.zeros([L], float)
    tdn_lamb = np.zeros([L], float)
    tb_spec = np.zeros([L], float)
    tb_lamb = np.zeros([L], float)
    e_spec = np.zeros([L], float)
    e_lamb = np.zeros([L], float)
    e_spec_lamb = np.zeros([L], float)
    print 'calculate lamb_spec'
    for ii in range (0, L):
        theta_eff[ii] = math.acos(- opac[ii] / (np.log(2. * E3[ii]))) * (1. / r)
        tdn_lamb[ii] = t_surf[ii] * (1 - exp(- opac[ii] / cos (theta_eff[ii] * r))) # Tdown to calculate with theta_eff
        tb_spec[ii] = (t_surf[ii] * e[ii] * exp(- opac[ii])) + (1. - e[ii]) * exp(- opac[ii]) * t_dn[ii] + t_up[ii] # calculation of Tb spec with theta
        tb_lamb[ii] = (t_surf[ii] * e[ii] * exp(- opac[ii])) + (1. - e[ii]) * exp(- opac[ii]) * tdn_lamb[ii] + t_up[ii] # calculation of Tb spec with theta_eff (with Tdown_lamb)
        e_spec[ii] = ((tb_spec[ii] - t_up[ii]) * exp(opac[ii]) - t_dn[ii]) / (t_surf[ii] - t_dn[ii])
        e_lamb[ii] = ((tb_lamb[ii] - t_up[ii]) * exp(opac[ii]) - t_dn[ii]) / (t_surf[ii] - t_dn[ii]) 
        e_spec_lamb[ii] = e_lamb[ii] - e_spec[ii]
    ###################################
    # mixed spec and lamb assumptions #
    ###################################
    print 'calculate mixed emis'
    s = np.array([0., 0.25, 0.5, 0.75, 1.]) # specularity coefficient (s=1 <=> specular)
    S = len(s)
    new_tdn = np.zeros([L, S], float)
    new_emis = np.zeros([L, S], float)
    for s_ind in range (0, S):
        for ii in range (0, L):
            new_tdn[ii, s_ind] = s[s_ind] * t_dn[ii] + (1. - s[s_ind]) * tdn_lamb[ii]
            new_emis[ii, s_ind] = ((t_b[ii] - t_up[ii]) * exp(opac[ii]) - new_tdn[ii, s_ind]) / (t_surf[ii] - new_tdn[ii, s_ind])
    ##############################################
    # stack of mixed emis lamb_spec in .dat file #
    ##############################################
    #data_spec_lamb = open ('/mma/hermozol/Documents/Data_tests/monthly_GLACE/lamb_spec_param_near_nadir_SEPTEMBER2009.dat', 'a')
    print 'stack data'
    for ii in range (0, L):
        data_spec_lamb.write(('%(jour)2.0f    %(lon)4.2f    %(lat)4.2f    %(za)4.2f    %(fov)2.0f   %(emis)5.4f   %(tsurf)5.2f   %(tup)5.2f   %(tdn)5.2f    %(trans)5.4f   %(tb)5.2f    %(opac)5.4f    %(theta_eff)5.3f    %(tdn_lamb)5.2f    %(tb_spec)5.2f    %(tb_lamb)5.2f    %(e_spec)5.4f    %(e_lamb)5.4f    %(e_diff)5.4f    %(e_mixed_00)5.4f    %(e_mixed_25)5.4f    %(e_mixed_50)5.4f    %(e_mixed_75)5.4f   %(e_mixed_100)5.4f \n' % {
                                            'jour':jour[ii],
                                            'lon':llon[ii],
                                            'lat':llat[ii],
                                            'za':zen_angle[ii],
                                            'fov':field_view[ii],
                                            'emis':e[ii],
                                            'tsurf':t_surf[ii],
                                            'tup':t_up[ii],
                                            'tdn':t_dn[ii],
                                            'trans':transm[ii],
                                            'tb':t_b[ii],
                                            'opac':opac[ii],
                                            'theta_eff':theta_eff[ii],
                                            'tdn_lamb':tdn_lamb[ii],
                                            'tb_spec':tb_spec[ii],
                                            'tb_lamb':tb_lamb[ii],
                                            'e_spec':e_spec[ii],
                                            'e_lamb':e_lamb[ii],
                                            'e_diff':e_spec_lamb[ii],
                                            'e_mixed_00':new_emis[ii, 0],
                                            'e_mixed_25':new_emis[ii, 1],
                                            'e_mixed_50':new_emis[ii, 2],
                                            'e_mixed_75':new_emis[ii, 3],
                                            'e_mixed_100':new_emis[ii, 4],
                                            }))
    data_spec_lamb.close()

