#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
from netCDF4 import Dataset
import arctic_map # function to regrid coast limits
import cartesian_grid_test # function to convert grid from polar to cartesian
import scipy.special
import ffgrid2
import map_ffgrid
from matplotlib import colors
from matplotlib.font_manager import FontProperties
import map_cartesian_grid




MONTH = np.array(['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'])
month = np.array(['JANUARY', 'FEBRUARY', 'MARCH', 'APRIL', 'MAY', 'JUNE', 'JULY', 'AUGUST', 'SEPTEMBER', 'OCTOBER', 'NOVEMBER', 'DECEMBER'])
month_day = np.array([31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31])
M = len(month)

frequ = np.array([23, 30, 50, 89])


#################################
# read .dat files of AMSUA data #
#################################
AS = np.zeros([len(frequ), M], float)
AL = np.zeros([len(frequ), M], float)
for ifr in range (0, len(frequ)):
    fichier = open('/net/argos/data/parvati/lahlod/ARCTIC/AMSUA_ice_class/AMSUA' + str(frequ[ifr]) + '_data_classification_parameters_ice_no-ice_2009.dat','r')
    numlines = 0
    for line in fichier: numlines += 1
    fichier.close()
    fichier = open('/net/argos/data/parvati/lahlod/ARCTIC/AMSUA_ice_class/AMSUA' + str(frequ[ifr]) + '_data_classification_parameters_ice_no-ice_2009.dat','r')
    nbtotal = numlines - 1
    iligne = 0
    tot_area_spec = np.zeros([nbtotal],float)
    tot_area_lamb = np.zeros([nbtotal],float)
    while (iligne < nbtotal) :
         line=fichier.readline()
         # exemple : line = "0.22 2.3 5.0 6"
         liste = line.split()
         # exemple : listeCoord ['0.22', '2.3', '5.0', '6'] (liste de chaine de caract?es)
         tot_area_spec[iligne] = float(liste[9])
         tot_area_lamb[iligne] = float(liste[10])
         iligne=iligne+1
    fichier.close()
    vec = np.arange(0, nbtotal + 51, 50)
    area_s = np.zeros([M], float)
    area_l = np.zeros([M], float)
    for imo in range (0, M):
        area_s[imo] = tot_area_spec[imo + vec[imo]]
        area_l[imo] = tot_area_lamb[imo + vec[imo]]
    AS[ifr, :] = area_s[:]
    AL[ifr, :] = area_l[:]



#################################
# read .dat files of AMSUB data #
#################################
fichier_B = open('/net/argos/data/parvati/lahlod/ARCTIC/AMSUB_ice_class/AMSUB89_data_classification_parameters_ice_no-ice_2009.dat','r')
numlines = 0
for line in fichier_B: numlines += 1

fichier_B.close()
fichier_B = open('/net/argos/data/parvati/lahlod/ARCTIC/AMSUB_ice_class/AMSUB89_data_classification_parameters_ice_no-ice_2009.dat','r')
nbtotal = numlines - 1
iligne = 0
tot_area_spec_B = np.zeros([nbtotal],float)
tot_area_lamb_B = np.zeros([nbtotal],float)
while (iligne < nbtotal) :
         line=fichier_B.readline()
         # exemple : line = "0.22 2.3 5.0 6"
         liste = line.split()
         # exemple : listeCoord ['0.22', '2.3', '5.0', '6'] (liste de chaine de caract?es)
         tot_area_spec_B[iligne] = float(liste[9])
         tot_area_lamb_B[iligne] = float(liste[10])
         iligne=iligne+1

fichier_B.close()
area_s_B = np.zeros([M], float)
area_l_B = np.zeros([M], float)
for imo in range (0, M):
    area_s_B[imo] = tot_area_spec_B[imo + vec[imo]]
    area_l_B[imo] = tot_area_lamb_B[imo + vec[imo]]



#################################
# read .dat file of OSISAF data #
#################################
fichier_osi = open('/net/argos/data/parvati/lahlod/ARCTIC/OSISAF_Ice_Types/OSISAF_daily_ice_no-ice_2009.dat','r')
numlines = 0
for line in fichier_osi: numlines += 1

fichier_osi.close()
fichier_osi = open('/net/argos/data/parvati/lahlod/ARCTIC/OSISAF_Ice_Types/OSISAF_daily_ice_no-ice_2009.dat','r')
nbtotal = numlines - 1
iligne = 0
mo = np.zeros([nbtotal],object)
tot_area_osi = np.zeros([nbtotal],float)
while (iligne < nbtotal) :
         line=fichier_osi.readline()
         # exemple : line = "0.22 2.3 5.0 6"
         liste = line.split()
         # exemple : listeCoord ['0.22', '2.3', '5.0', '6'] (liste de chaine de caract?es)
         mo[iligne] = str(liste[0])
         tot_area_osi[iligne] = float(liste[2])
         iligne=iligne+1

fichier_osi.close()
vec_osi = np.array([0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334])
area_osi = np.zeros([M], float)
for imo in range (0, M):
    area_osi[imo] = tot_area_osi[imo + vec_osi[imo]]



###################################
# plot time evolution of ice area #
###################################
figure()
plot(AS[0, :], 'c', label = 'AMSUA spec_23GHz')
plot(AL[0, :], 'c--', label = 'AMSUA lamb_23GHz')
plot(AS[1, :], 'r', label = 'AMSUA spec_30GHz')
plot(AL[1, :], 'r--', label = 'AMSUA lamb_30GHz')
plot(AS[2, :], 'm', label = 'AMSUA spec_50GHz')
plot(AL[2, :], 'm--', label = 'AMSUA lamb_50GHz')
plot(AS[3, :], 'g', label = 'AMSUA spec_89GHz')
plot(AL[3, :], 'g--', label = 'AMSUA lamb_89GHz')
plot(area_s_B[:], 'b', label = 'AMSUB spec_89GHz')
plot(area_l_B[:], 'b--', label = 'AMSUB lamb_89GHz')
plot(area_osi, 'k', label = 'OSISAF')
fontP = FontProperties()
fontP.set_size('small')
legend(loc = 3, prop = fontP)
ylabel('total ice area (in square km)')
xticks(np.arange(0, M, 1), month, rotation = 25)
xlim(-1, M)
grid()
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/total_ice_area/compar_total_ice_area_AMSUA_AMSUB_SPEC_LAMB_OSISAF_2009.png')



###############################
# calculation of bias and std #
###############################
a = np.zeros([M], float)
b = np.zeros([M], float)
c = np.zeros([M], float)
d = np.zeros([M], float)
e = np.zeros([M], float)
f = np.zeros([M], float)
g = np.zeros([M], float)
h = np.zeros([M], float)
i = np.zeros([M], float)
j = np.zeros([M], float)
for imo in range (0, M):
    a[imo] = (AS[0, imo] - area_osi[imo]) / area_osi[imo]
    b[imo] = (AL[0, imo] - area_osi[imo]) / area_osi[imo]
    c[imo] = (AS[1, imo] - area_osi[imo]) / area_osi[imo]
    d[imo] = (AL[1, imo] - area_osi[imo]) / area_osi[imo]
    e[imo] = (AS[2, imo] - area_osi[imo]) / area_osi[imo]
    f[imo] = (AL[2, imo] - area_osi[imo]) / area_osi[imo]
    g[imo] = (AS[3, imo] - area_osi[imo]) / area_osi[imo]
    h[imo] = (AL[3, imo] - area_osi[imo]) / area_osi[imo]
    i[imo] = (area_s_B[imo] - area_osi[imo]) / area_osi[imo]
    j[imo] = (area_l_B[imo] - area_osi[imo]) / area_osi[imo]


figure()
plot(a, 'c', label = 'AMSUA spec 23GHz')
plot(b, 'c--', label = 'AMSUA lamb 23GHz')
plot(c, 'r', label = 'AMSUA spec 30GHz')
plot(d, 'r--', label = 'AMSUA lamb 30GHz')
plot(e, 'm', label = 'AMSUA spec 50GHz')
plot(f, 'm--', label = 'AMSUA lamb 50GHz')
plot(g, 'g', label = 'AMSUA spec 89GHz')
plot(h, 'g--', label = 'AMSUA lamb 89GHz')
plot(i, 'b', label = 'AMSUB spec 89GHz')
plot(j, 'b--', label = 'AMSUB lamb 89GHz')
plot(np.arange(0, M, 1), np.zeros([M], float), 'k')
fontP = FontProperties()
fontP.set_size('small')
legend(loc = 3, prop = fontP)
ylabel('bias of total ice area')
xticks(np.arange(0, M, 1), month, rotation = 25)
xlim(-1, M)
grid()
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/total_ice_area/bias_total_ice_area_AMSU_OSI_2009.png')





