#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
from netCDF4 import Dataset
import arctic_map # function to regrid coast limits
import cartesian_grid_test # function to convert grid from polar to cartesian
import scipy.special
import ffgrid2
import map_ffgrid


fichier=open('/mma/hermozol/Documents/Data_tests/monthly_GLACE/lamb_spec_param_all_angles_SEPTEMBER2009.dat','r')
numlines = 0

for line in fichier: numlines += 1

fichier.close

fichier = open('/mma/hermozol/Documents/Data_tests/monthly_GLACE/lamb_spec_param_all_angles_SEPTEMBER2009.dat','r')   
nbtotal = numlines-1
iligne = 0
lat = np.zeros([nbtotal],float)
lon = np.zeros([nbtotal],float)
fov = np.zeros([nbtotal],float)
e_spec = np.zeros([nbtotal],float)
e_spec_lamb = np.zeros([nbtotal],float)
while (iligne < nbtotal) :
     line=fichier.readline()
     liste = line.split()
     lat[iligne] = float(liste[0])
     lon[iligne] = float(liste[1])
     fov[iligne] = float(liste[3])
     e_spec[iligne] = float(liste[15])
     e_spec_lamb[iligne] = float(liste[17])
     iligne=iligne+1



fichier.close()



x0 = fov.min()
x1 = fov.max()
y0 = e_spec_lamb.min()
y1 = e_spec_lamb.max()
z0 = e_spec.min()
z1 = e_spec.max()
dx = 1.
dy = 0.001
zgrid, xvec, yvec = ffgrid2.ffgrid(fov, e_spec_lamb, e_spec, dx, dy, x0, x1, y0, y1, z0, z1)
xii, yii = np.meshgrid(xvec, yvec)
plt.ion()
figure()
cm = plt.cm.get_cmap('bwr')
scat = scatter(xii, yii, c = zgrid, cmap = cm)
scat.xticks = (np.arange(0., 90., 1.), np.arange(0., 90., 5.))
xlim(0., 90.)
xlabel('field of view')
ylabel('emissivity SPEC-LAMB')
cbar = colorbar(scat)
cbar.set_label('emissivity SPEC')
title('SEPTEMBER 2009 - AMSUB')
savefig('/mma/hermozol/Documents/figure_output/comp_lamb_spec/spec_lamb_fov/scatter_e-spec_e-lamb_fov_espec_sept2009_AMSUB.png')


