#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
from netCDF4 import Dataset
import arctic_map # function to regrid coast limits
import cartesian_grid_test # function to convert grid from polar to cartesian
import scipy.special
import ffgrid2
import map_ffgrid
from matplotlib import colors
from matplotlib.font_manager import FontProperties
import map_cartesian_grid




MONTH = np.array(['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'])
month = np.array(['JANUARY', 'FEBRUARY', 'MARCH', 'APRIL', 'MAY', 'JUNE', 'JULY', 'AUGUST', 'SEPTEMBER', 'OCTOBER', 'NOVEMBER', 'DECEMBER'])
month_day = np.array([31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31])
M = len(month)


########################
# grid characteristics #
########################
x0 = -3000. # min limit of grid
x1 = 2500. # max limit of grid
dx = 40.
xvec = np.arange(x0, x1+dx, dx)
nx = len(xvec) 
y0 = -3000. # min limit of grid
y1 = 3000. # max limit of grid
dy = 40.
yvec = np.arange(y0, y1+dy, dy)
ny = len(yvec)


frequ = 89

#####################
# read NETCDF files #
#####################
emis_spec_month = np.zeros([M, ny, nx], float)
emis_lamb_month = np.zeros([M, ny, nx], float)
ratio_emis = np.zeros([M, ny, nx], float)
ratio_emis_vec = np.zeros([M, ny * nx], float)
spec_emis_vec = np.zeros([M, ny * nx], float)
lamb_emis_vec = np.zeros([M, ny * nx], float)
print 'read data from files'
for imo in range (0, M):
    print 'month: ' + month[imo]
    ### emissivity ###
    print 'open emissivity file'
    fichier_emis = Dataset('/net/argos/data/parvati/lahlod/ARCTIC/monthly_GLACE/gridded_data/cartesian_grid/res_40/cartesian_grid_monthly_data_lamb_spec_near_nadir_AMSUB' + str(frequ) + '_' + str(month[imo]) + '2009.nc', 'r', format='NETCDF3_CLASSIC')
    xdist = fichier_emis.variables['longitude'][:]
    ydist = fichier_emis.variables['latitude'][:]
    day = fichier_emis.variables['days'][:]
    emis_spec = fichier_emis.variables['e_spec'][:]
    emis_lamb = fichier_emis.variables['e_lamb'][:]
    fichier_emis.close()
    ##### calculate monthly mean of emis #####
    for ilat in range(0, len(ydist)):
        for ilon in range (0, len(xdist)):
            emis_spec_month[imo, ilat, ilon] = mean(emis_spec[ilat, ilon, 0 : month_day[imo]][nonzero(isnan(emis_spec[ilat, ilon, 0 : month_day[imo]]) == False)])
            emis_lamb_month[imo, ilat, ilon] = mean(emis_lamb[ilat, ilon, 0 : month_day[imo]][nonzero(isnan(emis_lamb[ilat, ilon, 0 : month_day[imo]]) == False)])
    ### monthly emissivity ratio ###
    print 'open emissivity ratio file'
    fichier_ratio = Dataset('/net/argos/data/parvati/lahlod/ARCTIC/monthly_GLACE/gridded_data/cartesian_grid/res_40/cartesian_grid_monthly_lamb-spec_ratio_near_nadir_AMSUB' + str(frequ) + '_' + str(month[imo]) + '2009.nc', 'r', format='NETCDF3_CLASSIC')
    xdist = fichier_ratio.variables['longitude'][:]
    ydist = fichier_ratio.variables['latitude'][:]
    ratio_emis[imo, :, :] = fichier_ratio.variables['emis_ratio'][:]
    fichier_ratio.close()
    ### reshape in monthly vectors all data in 2D arrays ###
    print 'reshape data'
    ratio_emis_vec[imo, :] = reshape(ratio_emis[imo, :, :], size(ratio_emis[imo, :, :]))
    spec_emis_vec[imo, :] = reshape(emis_spec_month[imo, :, :], size(emis_spec_month[imo, :, :]))
    lamb_emis_vec[imo, :] = reshape(emis_lamb_month[imo, :, :], size(emis_lamb_month[imo, :, :]))


'''
# test:
ion()
x_ind, y_ind, z_ind, volume = arctic_map.arctic_map_lat50()
x_coast = x_ind
y_coast = y_ind
z_coast = z_ind
map_cartesian_grid.draw_map_cartes_l(x_coast, y_coast, z_coast, volume, xdist, ydist, emis_spec_month[0, :, :], 0.45, 1.02, 0.01, cm.s3pcpn_l_r, 'test')
'''


c = np.array(['r', 'b', 'c', 'm', 'y', 'g'])
#limit_coef_spec = np.array([0.6, 0.6, 0.7, 0.8, 0.75]) # i1 = AMSUA23GHz / i2 = AMSUA30GHz / i3 = AMSUA50GHz / i4 = AMSUA89GHz / i5 = AMSUB89GHz
#limit_coef_lamb = np.array([0.6, 0.6, 0.8, 0.8, 0.77]) # i1 = AMSUA23GHz / i2 = AMSUA30GHz / i3 = AMSUA50GHz / i4 = AMSUA89GHz / i5 = AMSUB89GHz
#idata = 0
fontP = FontProperties()
fontP.set_size('small')
print 'distribution of emissivity values'
###################################
# distribution of SPEC emissivity #
###################################
print 'spec'
hist_vals_spec = np.zeros([M, 50], float)
corresp_emis_spec = np.zeros([M, 50], float)
for imo in range (0, M):
    hist_vals_spec[imo, :] = hist(spec_emis_vec[imo, :][nonzero(isnan(spec_emis_vec[imo,:]) == False)], bins = 50, normed = True, histtype='step')[0]
    for ibin in range (0, 50):
        corresp_emis_spec[imo, ibin] = mean(hist(spec_emis_vec[imo, :][nonzero(isnan(spec_emis_vec[imo,:]) == False)], bins = 50, normed = True, histtype='step')[1][ibin : ibin + 2])

## plot first six months of spec emissivity histograms ##
ion()
figure()
for imo in range (0, 6):
    plot(corresp_emis_spec[imo], hist_vals_spec[imo], c = str(c[imo]), label = str(month[imo]))

grid()
xlim(corresp_emis_spec.min() - 0.02, 1.02)
xlabel('emissivity SPEC')
ylabel('frequency of occurence')
legend(loc = 2, prop = fontP)
#plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/emiss_spec_AMSUA' + str(frequ) + '_JANUARY-JUNE_2009.png')
## plot six following months of spec emissivity histograms ##
figure()
for imo in range (6, M):
    plot(corresp_emis_spec[imo], hist_vals_spec[imo], c = str(c[imo - 6]), label = str(month[imo]))

grid()
xlim(corresp_emis_spec.min() - 0.02, 1.02)
xlabel('emissivity SPEC')
ylabel('frequency of occurence')
legend(loc = 9, prop = fontP)
#plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/emiss_spec_AMSUA' + str(frequ) + '_JULY-DECEMBER_2009.png')

# find the emissivity value corresponding to the threshold of ice/no_ice limit
emis_lim_spec = np.zeros([M], float)
for imo in range (0, M):
    print 'month ' + str(month[imo])
    bb = np.where((corresp_emis_spec[imo, :] > 0.7) & (corresp_emis_spec[imo, :] < 0.77))[0] # only consider low emissivity values (open sea) // CHANGE EMISSIVITY VALUE ACCORDING TO FREQUENCY
    aa = np.where(hist_vals_spec[imo, bb] == min(hist_vals_spec[imo, bb]))[0] # of these latter values, only consider emissivity values lower than 1/4*peak emissivity
    #cc = np.where(hist_vals_spec[imo, bb] == max(hist_vals_spec[imo, bb]))[0] # which emissivity index corresponds to peak emissivity
    #dd = np.where(aa > cc[0])[0]
    emis_lim_spec[imo] = corresp_emis_spec[imo, bb][aa][0]

# plot monthly evolution of emissivity spec threshold used for delimitation
figure()
plot(np.arange(0, M, 1), emis_lim_spec, 'b-+', label = 'emis SPEC')
ylabel('emissivity SPEC threshold')
grid()
xticks(np.arange(0, M, 1), month, rotation = 25)
legend(loc = 2)
xlim(-1, M)
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUB/emis_lim_frequ_SPEC_AMSUB' + str(frequ) + '_2009.png')


###################################
# distribution of LAMB emissivity #
###################################
print 'lamb'
hist_vals_lamb = np.zeros([M, 50], float)
corresp_emis_lamb = np.zeros([M, 50], float)
for imo in range (0, M):
    hist_vals_lamb[imo, :] = hist(lamb_emis_vec[imo, :][nonzero(isnan(lamb_emis_vec[imo,:]) == False)], bins = 50, normed = True, histtype='step')[0]
    for ibin in range (0, 50):
        corresp_emis_lamb[imo, ibin] = mean(hist(lamb_emis_vec[imo, :][nonzero(isnan(lamb_emis_vec[imo,:]) == False)], bins = 50, normed = True, histtype='step')[1][ibin : ibin + 2])

## plot first six months of spec emissivity histograms ##
figure()
for imo in range (0, 6):
    plot(corresp_emis_lamb[imo], hist_vals_lamb[imo], c = str(c[imo]), label = str(month[imo]))

grid()
xlim(corresp_emis_lamb.min() - 0.02, 1.02)
xlabel('emissivity LAMB')
ylabel('frequency of occurence')
legend(loc = 2, prop = fontP)
#plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/emiss_lamb_AMSUA' + str(frequ) + '_JANUARY-JUNE_2009.png')
## plot six following months of spec emissivity histograms ##
figure()
for imo in range (6, M):
    plot(corresp_emis_lamb[imo], hist_vals_lamb[imo], c = str(c[imo - 6]), label = str(month[imo]))

grid()
xlim(corresp_emis_lamb.min() - 0.02, 1.02)
xlabel('emissivity LAMB')
ylabel('frequency of occurence')
legend(loc = 9, prop = fontP)
#plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/emiss_lamb_AMSUA' + str(frequ) + '_JULY-DECEMBER_2009.png')

# find the emissivity value corresponding to the threshold of ice/no_ice limit
emis_lim_lamb = np.zeros([M], float)
for imo in range (0, M):
    print 'month ' + str(month[imo])
    bb = np.where((corresp_emis_lamb[imo, :] > 0.72) & (corresp_emis_lamb[imo, :] < 0.8))[0] # only consider low emissivity values (open sea) // CHANGE EMISSIVITY VALUE ACCORDING TO FREQUENCY
    aa = np.where(hist_vals_lamb[imo, bb] == min(hist_vals_lamb[imo, bb]))[0] # of these latter values, only consider emissivity values lower than 1/4*peak emissivity
    #cc = np.where(hist_vals_lamb[imo, bb] == max(hist_vals_lamb[imo, bb]))[0] # which emissivity index corresponds to peak emissivity
    #dd = np.where(aa > cc[0])[0]
    emis_lim_lamb[imo] = corresp_emis_lamb[imo, bb][aa][0]

# plot monthly evolution of emissivity spec threshold used for delimitation
figure()
plot(np.arange(0, M, 1), emis_lim_lamb, 'b-+', label = 'emis LAMB')
ylabel('emissivity LAMB threshold')
grid()
xticks(np.arange(0, M, 1), month, rotation = 25)
legend(loc = 2)
xlim(-1, M)
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUB/emis_lim_frequ_LAMB_AMSUB' + str(frequ) + '_2009.png')



###################################
# distribution of emissivity rate #
###################################
print 'rate'
hist_vals_rate = np.zeros([M, 50], float)
corresp_emis_rate = np.zeros([M, 50], float)
for imo in range (0, M):
    hist_vals_rate[imo, :] = hist(ratio_emis_vec[imo, :][nonzero(isnan(ratio_emis_vec[imo,:]) == False)], bins = 50, normed = True, histtype='step')[0]
    for ibin in range (0, 50):
        corresp_emis_rate[imo, ibin] = mean(hist(ratio_emis_vec[imo, :][nonzero(isnan(ratio_emis_vec[imo,:]) == False)], bins = 50, normed = True, histtype='step')[1][ibin : ibin + 2])

## plot first six months of spec emissivity histograms ##
figure()
for imo in range (0, 6):
    plot(corresp_emis_rate[imo], hist_vals_rate[imo], c = str(c[imo]), label = str(month[imo]))

grid()
xlim(corresp_emis_rate.min() - 0.02, corresp_emis_rate.max() + 0.02)
xlabel('emissivity rate (%)')
ylabel('frequency of occurence')
legend(prop = fontP)
#plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/emiss_rate_AMSUA'+str(frequ)+'_JANUARY-JUNE_2009.png')
## plot six following months of spec emissivity histograms ##
figure()
for imo in range (6, M):
    plot(corresp_emis_rate[imo], hist_vals_rate[imo], c = str(c[imo - 6]), label = str(month[imo]))

grid()
xlim(corresp_emis_rate.min() - 0.02, corresp_emis_rate.max() + 0.02)
xlabel('emissivity rate (%)')
ylabel('frequency of occurence')
legend(loc = 9, prop = fontP)
#plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/emiss_rate_AMSUA'+str(frequ)+'_JULY-DECEMBER_2009.png')

# no definition of threshold for ICE / NO_ICE delimitation because no apparent distinction signal // use of this signal for internal ice classification
'''
# find the emissivity value corresponding to the threshold of ice/no_ice limit
emis_lim_rate = np.zeros([M], float)
for imo in range (0, M):
    bb = np.where((corresp_emis_rate[imo, :] < 0.6))[0] # only consider low emissivity values (open sea) // CHANGE EMISSIVITY VALUE ACCORDING TO FREQUENCY
    aa = np.where(hist_vals_rate[imo, bb] < max(hist_vals_rate[imo, bb]) / 4.)[0] # of these latter values, only consider emissivity values lower than 1/4*peak emissivity
    cc = np.where(hist_vals_rate[imo, bb] == max(hist_vals_rate[imo, bb]))[0] # which emissivity index corresponds to peak emissivity
    dd = np.where(aa > cc[0])[0]
    emis_lim_rate[imo] = corresp_emis_rate[imo, bb][aa][dd[0]]

# plot monthly evolution of emissivity spec threshold used for delimitation
figure()
plot(np.arange(0, M, 1), emis_lim_rate, 'b-+', label = 'emis LAMB')
ylabel('emissivity rate threshold - AMSUB 89GHz')
grid()
xticks(np.arange(0, M, 1), month, rotation = 25)
legend(loc = 2)
xlim(-1, M)
plt.savefig('/usr/home/lahlod/twice_d/figure_output_ARCTIC/figure_output_CEN/ice_class_AMSUA/emis_lim_frequ_rate_AMSUA89_2009.png')
'''


##############################################################################
# plot comparison of emissivity thresholds between spec and lamb assumptions #
##############################################################################
figure()
plot(np.arange(0, M, 1), emis_lim_spec, 'b-+', label = 'emis SPEC')
plot(np.arange(0, M, 1), emis_lim_lamb, 'g-+', label = 'emis LAMB')
ylabel('emissivity threshold')
grid()
xticks(np.arange(0, M, 1), month, rotation = 25)
legend(loc = 2, prop = fontP)
xlim(-1, M)
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUB/emis_lim_frequ_spec_and_lamb_AMSUB' + str(frequ) + '_2009.png')




################################################################
# delimitation ice - no_ice with emissivity or ratio threshold #
################################################################
print 'definition of ice extent' 
x_ind, y_ind, z_ind, volume = arctic_map.arctic_map_lat50()
x_coast = x_ind
y_coast = y_ind
z_coast = z_ind
#### SPEC emiss ####
print 'spec'
ice_zone_spec = np.zeros([M, 151, 139], float)
for imo in range (0, M):
    print 'month: ' + str(month[imo])
    for ilat in range (0, 151):
        for ilon in range (0, 139):
            if (isnan(emis_spec_month[imo, ilat, ilon]) == True):
                ice_zone_spec[imo, ilat, ilon] = NaN 
            else:
                if (emis_spec_month[imo, ilat, ilon] <= emis_lim_spec[imo]): # use the monthly SPEC emissivity threshold 
                    ice_zone_spec[imo, ilat, ilon] = NaN
                else:
                    ice_zone_spec[imo, ilat, ilon] = emis_spec_month[imo, ilat, ilon]   
    map_cartesian_grid.draw_map_cartes_l(x_coast, y_coast, z_coast, volume, xdist, ydist, ice_zone_spec[8, :, :], 0.5, 1.02, 0.01,  cm.s3pcpn_l_r, 'Sea ice emissivity spec (threshold : emis_SPEC > ' + str(emis_lim_spec[imo])[0:6] + ')')
    title(str(month[imo]) + ' 2009 - AMSUA ' + str(frequ) + 'GHz')
    plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/AMSUA' + str(frequ) + '_ice_emis_spec_thresh' + '_' + month[imo] + '2009.png')

#### LAMB emiss ####
print 'lamb'
ice_zone_lamb = np.zeros([M, 151, 139], float)
for imo in range (0, M):
    print 'month: ' + str(month[imo])
    for ilat in range (0, 151):
        for ilon in range (0, 139):
            if (isnan(emis_lamb_month[imo, ilat, ilon]) == True):
                ice_zone_lamb[imo, ilat, ilon] = NaN 
            else:
                if (emis_lamb_month[imo, ilat, ilon] <= emis_lim_lamb[imo]): # use the monthly SPEC emissivity threshold 
                    ice_zone_lamb[imo, ilat, ilon] = NaN
                else:
                    ice_zone_lamb[imo, ilat, ilon] = emis_lamb_month[imo, ilat, ilon]     
    map_cartesian_grid.draw_map_cartes_l(x_coast, y_coast, z_coast, volume, xdist, ydist, ice_zone_lamb[8, :, :], 0.5, 1.02, 0.01,  cm.s3pcpn_l_r, 'Sea ice emissivity lamb (threshold : emis_LAMB > ' + str(emis_lim_lamb[imo])[0:6] + ')')
    title(str(month[imo]) + ' 2009 - AMSUA ' + str(frequ) + 'GHz')
    plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/AMSUA' + str(frequ) + '_ice_emis_lamb_thresh' + '_' + month[imo] + '2009.png')



###########################
# calculation of ice area #
###########################
# nb of pixels near pole = 926
print 'calculation of ice area'
pix_area = 40. * 40.
#### SPEC ####
print 'spec'
nb_pix_spec = np.zeros([M], float)
total_ice_area_spec = np.zeros([M], float)
for imo in range (0, M):
    ice_spec = reshape(ice_zone_spec[imo, :, :], size(ice_zone_spec[imo, :, :]))
    nb_pix_spec[imo] = len(np.where(isnan(ice_spec) == False)[0])
    total_ice_area_spec[imo] = (pix_area * nb_pix_spec[imo]) + (926. * pix_area)


#### LAMB ####
print 'lamb'
nb_pix_lamb = np.zeros([M], float)
total_ice_area_lamb = np.zeros([M], float)
for imo in range (0, M):
    ice_lamb = reshape(ice_zone_lamb[imo, :, :], size(ice_zone_lamb[imo, :, :]))
    nb_pix_lamb[imo] = len(np.where(isnan(ice_lamb) == False)[0])
    total_ice_area_lamb[imo] = (pix_area * nb_pix_lamb[imo]) + (926. * pix_area)



########################################## STACK DATA ###################################################

######################
# stack in .dat file #
######################
print 'start stacking in .dat file'
data_classif = open ('/net/argos/data/parvati/lahlod/ARCTIC/AMSUB_ice_class/AMSUB'+str(frequ)+'_data_classification_parameters_ice_no-ice_2009.dat', 'a')
for imo in range (0, M):
    for ii in range (0, 50):
        data_classif.write(('%(months)10s    %(hist_vals_spec)10.5f    %(corresp_emis_spec)10.5f    %(hist_vals_lamb)10.5f    %(corresp_emis_lamb)10.5f    %(hist_vals_rate)10.5f    %(corresp_emis_rate)10.5f    %(emis_lim_spec)10.5f    %(emis_lim_lamb)10.5f    %(spec_ice_area)10.5f    %(lamb_ice_area)10.5f   \n' % {
                                            'months':month[imo],
                                            'hist_vals_spec':hist_vals_spec[imo, ii],
                                            'corresp_emis_spec':corresp_emis_spec[imo, ii],
                                            'hist_vals_lamb':hist_vals_lamb[imo, ii],
                                            'corresp_emis_lamb':corresp_emis_lamb[imo, ii],
                                            'hist_vals_rate':hist_vals_rate[imo, ii],
                                            'corresp_emis_rate':corresp_emis_rate[imo, ii],
                                            'emis_lim_spec':emis_lim_spec[imo],
                                            'emis_lim_lamb':emis_lim_lamb[imo],
                                            'spec_ice_area':total_ice_area_spec[imo],
                                            'lamb_ice_area':total_ice_area_lamb[imo],
                                            }))

data_classif.close()



########################
# stack in netcdf file #
########################
print 'start stacking'
for imo in range (0, M):
    print 'stack in file month ' + str(month[imo])
    rootgrp = Dataset('/net/argos/data/parvati/lahlod/ARCTIC/AMSUB_ice_class/cartesian_grid_map_ice_no-ice_' + month[imo] + '2009_AMSUB' + str(frequ) + '_spec_lamb_thresholds.nc', 'w', format='NETCDF3_CLASSIC')
    rootgrp.createDimension('longitude', len(xdist))
    rootgrp.createDimension('latitude', len(ydist))
    nc_lon = rootgrp.createVariable('longitude', 'f', ('longitude',))
    nc_lat = rootgrp.createVariable('latitude', 'f', ('latitude',))
    nc_ice_spec = rootgrp.createVariable('spec_ice_area', 'f', ('latitude', 'longitude'))
    nc_ice_lamb = rootgrp.createVariable('lamb_ice_area', 'f', ('latitude', 'longitude'))
    nc_lon[:] = xdist
    nc_lat[:] = ydist
    nc_ice_spec[:] = ice_zone_spec[imo, :, :]
    nc_ice_lamb[:] = ice_zone_lamb[imo, :, :]
    rootgrp.close()





'''
###################################
# plot time evolution of ice area #
###################################
figure()
plot(total_ice_area, '-+b', label = 'AMSUB SPEC')
plot(total_ice_area_osi, '-^r', label = 'OSISAF')
plot(total_ice_area_l, '-og', label = 'AMSUB LAMB')
legend(loc = 3)
xlim(-1, M)
ylim(0.2*1e7, 1.3*1e7)
xticks(np.arange(0, M, 1), month, rotation = 25)
ylabel('totale ice area (square km)')
grid()
plt.savefig('/usr/home/lahlod/twice_d/figure_output_ARCTIC/figure_output_CEN/ice_pix_area/total_ice_area_AMSUB_SPEC_LAMB_OSISAF_2009.png')
'''







