#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
from pylab import *
from netCDF4 import Dataset
#import arctic_map # function to regrid coast limits
#import cartesian_grid_test # function to convert grid from polar to cartesian
from matplotlib.font_manager import FontProperties
#import map_cartesian_grid
import ice_class_delimit_AMSU_data




MONTH = np.array(['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'])
month = np.array(['JANUARY', 'FEBRUARY', 'MARCH', 'APRIL', 'MAY', 'JUNE', 'JULY', 'AUGUST', 'SEPTEMBER', 'OCTOBER', 'NOVEMBER', 'DECEMBER'])
month_day = np.array([31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31])
M = len(month)



frequ = 89

################################################################################
# compute filtered points of emissivity SPEC, LAMB, rate, difference LAMB-SPEC #
################################################################################
emis_spec_f, emis_lamb_f, emis_ratio_f, emis_diff_f, L_spec, X, Y, hist_val_spec, hist_val_lamb, hist_val_ratio, hist_val_diff, corresp_val_spec, corresp_val_lamb, corresp_val_ratio, corresp_val_diff = ice_class_delimit_AMSU_data.filtering(frequ)
spec = emis_spec_f
lamb = emis_lamb_f
ratio = emis_ratio_f
diff = emis_diff_f
L_spec = L_spec
X = X
Y = Y
hist_spec = hist_val_spec
hist_lamb = hist_val_lamb
hist_ratio = hist_val_ratio
hist_diff = hist_val_diff
corresp_spec = corresp_val_spec
corresp_lamb = corresp_val_lamb
corresp_ratio = corresp_val_ratio
corresp_diff = corresp_val_diff



########
# plot #
########
ion()
c = np.array(['r', 'b', 'c', 'm', 'y', 'g'])
fontP = FontProperties()
fontP.set_size('small')
#### SPEC ####
figure()
for imo in range (0, 6):
    plot(corresp_spec[:, imo], hist_spec[:, imo], c = str(c[imo]), label = str(month[imo]))

grid()
xlim(corresp_spec.min() - 0.02, corresp_spec.max() + 0.02)
xlabel('emissivity spec')
ylabel('frequency of occurence')
legend(prop = fontP, loc = 2)
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/sub_classification/emiss_spec_AMSUA' + str(frequ) + '_JANUARY-JUNE_2009.png')
## plot six following months of spec emissivity histograms ##
figure()
for imo in range (6, M):
    plot(corresp_spec[:, imo], hist_spec[:, imo], c = str(c[imo - 6]), label = str(month[imo]))

grid()
xlim(corresp_spec.min() - 0.02, corresp_spec.max() + 0.02)
xlabel('emissivity spec')
ylabel('frequency of occurence')
legend(loc = 1, prop = fontP)
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/sub_classification/emiss_spec_AMSUA' + str(frequ) + '_JULY-DECEMBER_2009.png')



#### LAMB ####
figure()
for imo in range (0, 6):
    plot(corresp_lamb[:, imo], hist_lamb[:, imo], c = str(c[imo]), label = str(month[imo]))

grid()
xlim(corresp_lamb.min() - 0.02, corresp_lamb.max() + 0.02)
xlabel('emissivity lamb')
ylabel('frequency of occurence')
fontP = FontProperties()
fontP.set_size('small')
legend(prop = fontP, loc = 2)
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/sub_classification/emiss_lamb_AMSUA' + str(frequ) + '_JANUARY-JUNE_2009.png')
## plot six following months of spec emissivity histograms ##
figure()
for imo in range (6, M):
    plot(corresp_lamb[:, imo], hist_lamb[:, imo], c = str(c[imo - 6]), label = str(month[imo]))

grid()
xlim(corresp_lamb.min() - 0.02, corresp_lamb.max() + 0.02)
xlabel('emissivity lamb')
ylabel('frequency of occurence')
legend(loc = 1, prop = fontP)
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/sub_classification/emiss_lamb_AMSUA' + str(frequ) + '_JULY-DECEMBER_2009.png')

#### RATE ####
figure()
for imo in range (0, 6):
    plot(corresp_ratio[:, imo], hist_ratio[:, imo], c = str(c[imo]), label = str(month[imo]))

grid()
xlim(corresp_ratio.min() - 0.02, corresp_ratio.max() + 0.02)
xlabel('emissivity ratio')
ylabel('frequency of occurence')
fontP = FontProperties()
fontP.set_size('small')
legend(prop = fontP, loc = 1)
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/sub_classification/emiss_ratio_AMSUA' + str(frequ) + '_JANUARY-JUNE_2009.png')
## plot six following months of spec emissivity histograms ##
figure()
for imo in range (6, M):
    plot(corresp_ratio[:, imo], hist_ratio[:, imo], c = str(c[imo - 6]), label = str(month[imo]))

grid()
xlim(corresp_ratio.min() - 0.02, corresp_ratio.max() + 0.02)
xlabel('emissivity ratio')
ylabel('frequency of occurence')
legend(loc = 1, prop = fontP)
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/sub_classification/emiss_ratio_AMSUA' + str(frequ) + '_JULY-DECEMBER_2009.png')

#### DIFF ####
figure()
for imo in range (0, 6):
    plot(corresp_diff[:, imo], hist_diff[:, imo], c = str(c[imo]), label = str(month[imo]))

grid()
xlim(corresp_diff.min() - 0.002, corresp_diff.max() + 0.002)
xlabel('emissivity diff')
ylabel('frequency of occurence')
fontP = FontProperties()
fontP.set_size('small')
legend(prop = fontP, loc = 1)
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/sub_classification/emiss_diff_AMSUA' + str(frequ) + '_JANUARY-JUNE_2009.png')
## plot six following months of spec emissivity histograms ##
figure()
for imo in range (6, M):
    plot(corresp_diff[:, imo], hist_diff[:, imo], c = str(c[imo - 6]), label = str(month[imo]))

grid()
xlim(corresp_diff.min() - 0.002, corresp_diff.max() + 0.002)
xlabel('emissivity diff')
ylabel('frequency of occurence')
legend(loc = 1, prop = fontP)
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/sub_classification/emiss_diff_AMSUA' + str(frequ) + '_JULY-DECEMBER_2009.png')




'''
frequ = 30
emis_spec_f, emis_lamb_f, emis_ratio_f, emis_diff_f, L_spec, X, Y, hist_val_spec, hist_val_lamb, hist_val_ratio, hist_val_diff, corresp_val_spec, corresp_val_lamb, corresp_val_ratio, corresp_val_diff = ice_class_delimit_AMSU_data.filtering(frequ)
spec_30 = emis_spec_f
lamb_30 = emis_lamb_f
ratio_30 = emis_ratio_f
diff_30 = emis_diff_f
L_spec_30 = L_spec
X_30 = X
Y_30 = Y

frequ = 50
emis_spec_f, emis_lamb_f, emis_ratio_f, emis_diff_f, L_spec, X, Y, hist_val_spec, hist_val_lamb, hist_val_ratio, hist_val_diff, corresp_val_spec, corresp_val_lamb, corresp_val_ratio, corresp_val_diff = ice_class_delimit_AMSU_data.filtering(frequ)
spec_50 = emis_spec_f
lamb_50 = emis_lamb_f
ratio_50 = emis_ratio_f
diff_50 = emis_diff_f
L_spec_50 = L_spec
X_50 = X
Y_50 = Y

frequ = 89
emis_spec_f, emis_lamb_f, emis_ratio_f, emis_diff_f, L_spec, X, Y, hist_val_spec, hist_val_lamb, hist_val_ratio, hist_val_diff, corresp_val_spec, corresp_val_lamb, corresp_val_ratio, corresp_val_diff = ice_class_delimit_AMSU_data.filtering(frequ)
spec_89 = emis_spec_f
lamb_89 = emis_lamb_f
ratio_89 = emis_ratio_f
diff_89 = emis_diff_f
L_spec_89 = L_spec
X_89 = X
Y_89 = Y


XX = X_89[:, 0][nonzero(X_89[:, 0] != 0.)]
YY = Y_89[:, 0][nonzero(Y_89[:, 0] != 0.)]
L = len(XX)
for ii in range (0, L):
    emis_spec_moy[YY[ii], XX[ii]]




a1 = np.zeros([M], float)
a2 = np.zeros([M], float)
a3 = np.zeros([M], float)
a4 = np.zeros([M], float)
for imo in range (0, M):
    a1[imo] = corrcoef(spec_89[0 : 3243, imo], lamb_89[0 : 3243, imo])[0][1] 
    a2[imo] = corrcoef(spec_89[0 : 3243, imo], ratio_89[0 : 3243, imo])[0][1] 
    a3[imo] = corrcoef(spec_89[0 : 3243, imo], diff_89[0 : 3243, imo])[0][1]
    a4[imo] = corrcoef(spec_89[0 : 3243, imo], diff_89[0 : 3243, imo])[0][1]

params = np.array([spec_89[0 : 3243, imo], lamb_89[0 : 3243, imo], ratio_89[0 : 3243, imo], diff_89[0 : 3243, imo], spec_50[0 : 3243, imo], lamb_50[0 : 3243, imo], ratio_50[0 : 3243, imo], diff_50[0 : 3243, imo], spec_30[0 : 3243, imo], lamb_30[0 : 3243, imo], ratio_30[0 : 3243, imo], diff_30[0 : 3243, imo], spec[0 : 3243, imo], lamb[0 : 3243, imo], ratio[0 : 3243, imo], diff[0 : 3243, imo]]))

figure()
pc = pcolor(correl_matrix)
colorbar(pc)
'''
