#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm



def draw_map_cartes_l (x_coast, y_coast, z_coast, volume, xvec, yvec, zvar, c0, c1, dc, colormap, text):


    ############################
    # definition of input data #
    ############################
    # x_coast = x coordinate of each point of coast line (1D-array)
    # y_coast = y coordinate of each point of coast line (1D-array)
    # z_coast = value of coast line (1 if coast line, 0 if land or sea) (1D-array)
    # volume = size of points plotted on the map (integer)
    # xvec = x coordinate of data we want to map
    # yvec = y coordinate of data we want to map
    # zvar = values of data we want to map (2-D array)
    # c0, c1, dc = resolution of colorbar of the map
    # colormap = type of colorbar for the map
    # text = legend of the colorbar

    figure()
    scatter(x_coast, y_coast, c = z_coast, s = volume)
    clevs = np.arange(c0, c1, dc)
    #cmap = cm.s3pcpn_l_r
    cs = contourf(xvec, yvec, zvar, clevs, cmap = colormap) 
    cbar = colorbar(cs)
    cbar.set_label(text)
    xlim(-3500, 2700.)
    ylim(-4000, 2800.)


    return 
