#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
from netCDF4 import Dataset
import arctic_map # function to regrid coast limits
import cartesian_grid_test # function to convert grid from polar to cartesian
import scipy.special
import ffgrid2
import map_ffgrid




month = np.array(['JANUARY', 'FEBRUARY', 'MARCH', 'APRIL', 'MAY', 'JUNE', 'JULY', 'AUGUST', 'SEPTEMBER', 'OCTOBER', 'NOVEMBER', 'DECEMBER'])
month_day = np.array([31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31])
M = len(month)


dx=1.
dy=0.5
x0, x1 = -180., 180.
y0, y1 = 65., 90.
xvec = np.arange(x0, x1 + dx, dx)
yvec = np.arange(y0, y1 + dy, dy)
nx = len(xvec)
ny = len(yvec)


e_spec_lamb_month = np.zeros([ny, nx, M], float)
e_spec_month = np.zeros([ny, nx, M], float)
for imo in range (0, M):
    fichier = Dataset('/mma/hermozol/Documents/Data_tests/monthly_GLACE/gridded_data/grid_monthly_data_lamb_spec_near_nadir_AMSUB_' + month[imo] + '2009.nc', 'r', format='NETCDF3_CLASSIC')
    lon = fichier.variables['longitude'][:]
    lat = fichier.variables['latitude'][:]
    tup = fichier.variables['tup'][:]
    tdn = fichier.variables['tdn'][:]
    tb_spec = fichier.variables['tb_spec'][:]
    tb_lamb = fichier.variables['tb_lamb'][:]
    e_spec = fichier.variables['e_spec'][:]
    e_lamb = fichier.variables['e_lamb'][:]
    e_spec_lamb = fichier.variables['e_spec_lamb'][:]
    e_sl_00 = fichier.variables['e_mixed_s00'][:]
    e_sl_25 = fichier.variables['e_mixed_s25'][:]
    e_sl_50 = fichier.variables['e_mixed_s50'][:]
    e_sl_75 = fichier.variables['e_mixed_s75'][:]
    e_sl_100 = fichier.variables['e_mixed_s100'][:]
    fichier.close()
    e_spec_month[:, :, imo] = e_spec[:, :]
    e_spec_lamb_month[:, :, imo] = e_spec_lamb[:, :]



cm = plt.cm.get_cmap('RdBu')
#cmap = cm.s3pcpn_l_r
plt.ion()
for imo in range (0, M):
    map_ffgrid.draw_map_l(lon, lat, 0.6, 1.02, 0.01, e_spec_month[:,:,imo], cm.s3pcpn_l_r, 'emissivity SPEC')
    title(month[imo] + ' 2009 - AMSUB')
    savefig('/mma/hermozol/Documents/figure_output/comp_lamb_spec/space_evolution/EMIS/emis_spec_AMSUB_' + month[imo] + '2009.png')
