#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm






def draw_map_l (xcoord, ycoord, c0, c1, dc, zvar, colormap, text):

    figure()
    m = Basemap(projection = 'nplaea', boundinglat = 65., lon_0 = 0., resolution = 'l', fix_aspect = True)
    m.drawcoastlines(linewidth = 0.5)
    m.drawlsmask(ocean_color='#F4EAF1', lakes=False)
    m.drawparallels(np.arange(60.,90.,10.), labels=[1,0,0,0])
    m.drawmeridians(np.arange(-180.,180.,20.), labels=[0,0,0,1])
    xii, yii = m(*np.meshgrid(xcoord,ycoord))
    clevs = np.arange(c0, c1, dc)
    #cmap = cm.s3pcpn_l_r
    cs = m.contourf(xii, yii, zvar, clevs, cmap = colormap) 
    cbar = colorbar(cs)
    cbar.set_label(text)
    #plt.savefig('/mma/hermozol/Documents/figure_output/tb_lamb_AMSUB_1sept2009.png')


    return 
