#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
from netCDF4 import Dataset
import arctic_map # function to regrid coast limits
import cartesian_grid_test # function to convert grid from polar to cartesian
import scipy.special
import ffgrid2
import map_ffgrid



month = np.array(['JANUARY', 'FEBRUARY', 'MARCH', 'APRIL', 'MAY', 'JUNE', 'JULY', 'AUGUST', 'SEPTEMBER', 'OCTOBER', 'NOVEMBER', 'DECEMBER'])
month_day = np.array([31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31])
M = len(month)



dx=1.
dy=0.5
x0, x1 = -180., 180.
y0, y1 = 65., 90.
xx = np.arange(x0, x1 + dx, dx)
yy = np.arange(y0, y1 + dy, dy)
nx = len(xx)
ny = len(yy)


eee = np.zeros([ny, nx, M], float)
for imo in range (0, M):
    print 'month: ' + month[imo]
    fichier = open('/mma/hermozol/Documents/Data_tests/monthly_GLACE/lamb_spec_param_near_nadir_' + month[imo] + '2009.dat','r')
    numlines = 0
    for line in fichier: numlines += 1
    fichier.close
    fichier = open('/mma/hermozol/Documents/Data_tests/monthly_GLACE/lamb_spec_param_near_nadir_' + month[imo] + '2009.dat','r')   
    nbtotal = numlines-1
    iligne = 0
    lat = np.zeros([nbtotal],float)
    lon = np.zeros([nbtotal],float)
    e_spec_lamb = np.zeros([nbtotal],float)
    while (iligne < nbtotal) :
         line=fichier.readline()
         liste = line.split()
         lat[iligne] = float(liste[2])
         lon[iligne] = float(liste[1])
         e_spec_lamb[iligne] = float(liste[18])
         iligne=iligne+1
    fichier.close()
    # grid [e_lamb - e_spec]
    print 'grid [e_lamb - e_spec]'
    z0 = e_spec_lamb.min()
    z1 = e_spec_lamb.max()
    zgrid, xvec, yvec = ffgrid2.ffgrid(lon, lat, e_spec_lamb, dx, dy, x0, x1, y0, y1, z0, z1)
    e_spec_lamb_month = zgrid
    eee[:, :, imo] = e_spec_lamb_month[:, :]

plt.ion()
for imo in range (0, M):
    map_ffgrid.draw_map_l (xvec, yvec, 0., 0.05, 0.001, eee[:, :, imo], 'emis lamb - emis spec')
    title(month[imo] + ' 2009 - AMSUB')
    plt.savefig('/mma/hermozol/Documents/figure_output/comp_lamb_spec/space_evolution/emis_spec-lamb_AMSUB_' + month[imo] + '2009.png')

