#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
from netCDF4 import Dataset
import scipy.special
import ffgrid2
import map_ffgrid
from matplotlib import colors
import cartesian_grid_monthly
import arctic_map
import map_cartesian_grid


##########################
# time period parameters #
##########################
MONTH = np.array(['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'])
month = np.array(['JANUARY', 'FEBRUARY', 'MARCH', 'APRIL', 'MAY', 'JUNE', 'JULY', 'AUGUST', 'SEPTEMBER', 'OCTOBER', 'NOVEMBER', 'DECEMBER'])
month_day = np.array([31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31])
M = len(month)



###################
# grid parameters #
###################
#x0 = -3000. # min limit of grid
#x1 = 2500. # max limit of grid
#dx = 40.
#xvec = np.arange(x0, x1+dx, dx)
#nx = len(xvec) 
#y0 = -3000. # min limit of grid
#y1 = 3000. # max limit of grid
#dy = 40.
#yvec = np.arange(y0, y1+dy, dy)
#ny = len(yvec)



for imo in range (0, 1):
    DAY = np.zeros([month_day[imo]], object)
    for ijr in range (0, month_day[imo]):
        if (ijr < 9):
            day = '0' + str(ijr + 1)
        else:
            day = str(ijr + 1)
        DAY[ijr] = day
        print 'date : ' + str(DAY[ijr]) + '_' + str(month[imo]) + '_2009'
# Concentration 
ifremer_conc = Dataset('/net/argos/data/parvati/lahlod/ARCTIC/CERSAT-IFREMER/sea_ice_concentration/2009' + MONTH[imo] + DAY[ijr] + '.nc', 'r', format='NETCDF3_CLASSIC')
conc = reshape(ifremer_conc.variables['concentration'][:], 608*896)
ifremer_conc.close()
# Backscatter
ifremer_back = Dataset('/net/argos/data/parvati/lahlod/ARCTIC/CERSAT-IFREMER/sea_ice_backscatter/ASCAT_2009' + MONTH[imo] + DAY[ijr] + '.nc', 'r', format='NETCDF3_CLASSIC')
lon = reshape(ifremer_back.variables['longitude'][:], 608*896)
lat = reshape(ifremer_back.variables['latitude'][:], 608*896)
back = reshape(ifremer_back.variables['sigma_40'][:], 608*896)
ifremer_back.close()
bb = nonzero((lon >= -180.) & (lon <= 180.))
llon = lon[bb]
llat = lat[bb]
bback = back[bb]

contourf(llon, llat, bback, cm.s3pcpn_l_r)
zgrid, ngrid, z2grid, sigmagrid, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_monthly.new_cartesian_grid_month(llon, llat, bback, -0.62, 0.62, 20, 20)

x_ind, y_ind, z_ind, volume = arctic_map.arctic_map_lat50()
x_coast = x_ind
y_coast = y_ind
z_coast = z_ind
zvar = [0, 6, :, :]
c0 = 0
c1 = 5
dc = 1
colormap = cm.s3pcpn_l_r
map_cartesian_grid.draw_map_cartes_l(x_coast, y_coast, z_coast, volume, xvec, yvec, zvar, c0, c1, dc, colormap, 'hello')



