#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
import ffgrid2
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
import ffgrid2





month = np.array(['JANUARY', 'FEBRUARY', 'MARCH', 'APRIL', 'MAY', 'JUNE', 'JULY', 'AUGUST', 'SEPTEMBER', 'OCTOBER', 'NOVEMBER', 'DECEMBER'])
month_day = np.array([31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31])
M = len(month)


rate_false = np.zeros([M], float)
for imo in range (0, M):
    print 'open file month: ' + month[imo]
    fichier=open('/mma/hermozol/Documents/Data/GLACE/GLACE_AMSUB89_EMIS_' + month[imo] + '2009.DAT','r')
    numlines = 0
    for line in fichier: numlines += 1
    fichier.close
    fichier=open('/mma/hermozol/Documents/Data/GLACE/GLACE_AMSUB89_EMIS_' + month[imo] + '2009.DAT','r')
    nbtotal=numlines-1
    iligne=0
    lat=np.zeros([nbtotal],float)
    lon=np.zeros([nbtotal],float)
    jjr=np.zeros([nbtotal],float)
    zen=np.zeros([nbtotal],float)
    fov=np.zeros([nbtotal],float)
    ts=np.zeros([nbtotal],float)
    emis=np.zeros([nbtotal],float)
    tb=np.zeros([nbtotal],float)
    tup=np.zeros([nbtotal],float)
    tdn=np.zeros([nbtotal],float)
    trans=np.zeros([nbtotal],float)
    # format:
    # printf, luna2, xlon, ylat, annee, mois, jour, heure, jour_obs, heure_obs, tsy, zeny, fovy, saty, masque, ee89, tb89, tup89, tdn89, trans89, format='(18(f12.3,1X))'  
    while (iligne < nbtotal) :
         line=fichier.readline()
         # exemple : line = "0.22 2.3 5.0 6"
         liste = line.split()
         # exemple : listeCoord ['0.22', '2.3', '5.0', '6'] (liste de chaine de caract?es)
         lat[iligne] = float(liste[1])
         lon[iligne] = float(liste[0])
         jjr[iligne] = float(liste[4])
         ts[iligne] = float(liste[8])
         fov[iligne] = float(liste[10])
         zen[iligne] = float(liste[9])
         emis[iligne] = float(liste[13])
         tb[iligne] = float(liste[14])
         tup[iligne] = float(liste[15])
         tdn[iligne] = float(liste[16])
         trans[iligne]  = float(liste[17])
         iligne=iligne+1
    fichier.close
    print 'calculate rate of false values of emissivity'
    false_val1 = np.where(emis == -500.)[0]
    false_val2 = np.where(emis > 1.)[0]
    false_vals = np.append(false_val1, false_val2)
    how_many_false = len(false_vals)
    rate_false[imo] = (float(how_many_false) / float(nbtotal)) * 100.
    print 'rate = ' + str(rate_false[imo])
    
    

for i in range (0, nbtotal):
    if (emis[i] < 0.):
        emis[i] = NaN 
    if (emis[i] > 1.):
        emis[i] = 0.99  


bb = nonzero(lat > 65.)
e = emis[bb]
llon = lon[bb]
llat = lat[bb]
figure()
m = Basemap(projection = 'nplaea', boundinglat = 65., lon_0 = 0., resolution = 'l', fix_aspect = True)
m.drawcoastlines(linewidth = 0.5)
m.drawlsmask(ocean_color='#F4EAF1', lakes=False)
m.drawparallels(np.arange(60.,90.,10.), labels=[1,0,0,0])
m.drawmeridians(np.arange(-180.,180.,20.), labels=[0,0,0,1])
xii, yii = m(*np.meshgrid(xvec,yvec))
clevs = np.arange(0.5, 1.02, 0.01)
#cmap = cm.s3pcpn_l_r
cs = m.contourf(xvec, yvec, e, clevs, cmap = cm.s3pcpn_l_r) 
cbar = colorbar(cs)



bbjr = nonzero(jjr == 1.)
bbzen = nonzero(zen[bbjr] > 20.)
z0 = e[nonzero(isnan(e) == False)].min()
z1 = e[nonzero(isnan(e) == False)].max()
zgrid, xvec, yvec = ffgrid2.ffgrid(llon, llat, e, 1., 1., -180., 180., 65., 90., z0, z1)
emis_amsub_89 = zgrid  
plt.ion()

map_ffgrid.draw_map_l(, lat, emis.min(), emis.max(), 0.01, emis, 'emissivity')
	





		



