#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
from netCDF4 import Dataset
import scipy.special
import ffgrid2
import map_ffgrid
import arctic_map # function to regrid coast limits
import cartesian_grid_test # function to convert grid from polar to cartesian




###############
# time period #
###############
month = np.array(['JANUARY', 'FEBRUARY', 'MARCH', 'APRIL', 'MAY', 'JUNE', 'JULY', 'AUGUST', 'SEPTEMBER', 'OCTOBER', 'NOVEMBER', 'DECEMBER'])
month_day = np.array([31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31])
M = len(month)



########################
# grid characteristics #
########################
x0 = -3000. # min limit of grid
x1 = 2500. # max limit of grid
dx = 40.
xvec = np.arange(x0, x1+dx, dx)
nx = len(xvec) 
y0 = -3000. # min limit of grid
y1 = 3000. # max limit of grid
dy = 40.
yvec = np.arange(y0, y1+dy, dy)
ny = len(yvec)



#############################
# grid data from .dat files #
#############################
'''tu = np.zeros([ny, nx, 31, M], float)
td = np.zeros([ny, nx, 31, M], float)
tbs = np.zeros([ny, nx, 31, M], float)
tbl = np.zeros([ny, nx, 31, M], float)'''
es = np.zeros([ny, nx, 31, M], float)
el = np.zeros([ny, nx, 31, M], float)
esl = np.zeros([ny, nx, 31, M], float)
'''esl00 = np.zeros([ny, nx, 31, M], float)
esl25 = np.zeros([ny, nx, 31, M], float)
esl50 = np.zeros([ny, nx, 31, M], float)
esl75 = np.zeros([ny, nx, 31, M], float)
esl100 = np.zeros([ny, nx, 31, M], float)'''
for imo in range (0, M):
    print 'month: ' + month[imo]
    fichier = open('/net/argos/data/parvati/lahlod/ARCTIC/monthly_GLACE/lamb_spec_param_near_nadir_' + month[imo] + '2009_AMSUA30.dat','r')
    numlines = 0
    for line in fichier: numlines += 1
    fichier.close
    fichier = open('/net/argos/data/parvati/lahlod/ARCTIC/monthly_GLACE/lamb_spec_param_near_nadir_' + month[imo] + '2009_AMSUA30.dat','r')  
    nbtotal = numlines-1
    iligne = 0
    jjr = np.zeros([nbtotal],float)
    lat = np.zeros([nbtotal],float)
    lon = np.zeros([nbtotal],float)
    e = np.zeros([nbtotal],float)
    '''ts = np.zeros([nbtotal],float)
    tup = np.zeros([nbtotal],float)
    tdn = np.zeros([nbtotal],float)
    tb = np.zeros([nbtotal],float)
    theta_eff = np.zeros([nbtotal],float)
    opac = np.zeros([nbtotal],float)
    tdn_lamb = np.zeros([nbtotal],float)
    tb_spec = np.zeros([nbtotal],float)
    tb_lamb = np.zeros([nbtotal],float)'''
    e_spec = np.zeros([nbtotal],float)
    e_lamb = np.zeros([nbtotal],float)
    e_spec_lamb = np.zeros([nbtotal],float)
    '''e_sl_00 = np.zeros([nbtotal],float)
    e_sl_25 = np.zeros([nbtotal],float)
    e_sl_50 = np.zeros([nbtotal],float)
    e_sl_75 = np.zeros([nbtotal],float)
    e_sl_100 = np.zeros([nbtotal],float)'''
    while (iligne < nbtotal) :
         line=fichier.readline()
         liste = line.split()
         jjr[iligne] = float(liste[0])
         lat[iligne] = float(liste[2])
         lon[iligne] = float(liste[1])
         e[iligne] = float(liste[5])
         '''ts[iligne] = float(liste[6])
         tup[iligne] = float(liste[7])
         tdn[iligne] = float(liste[8])
         tb[iligne] = float(liste[10])
         theta_eff[iligne] = float(liste[12])
         opac[iligne] = float(liste[11])
         tdn_lamb[iligne] = float(liste[13])
         tb_spec[iligne]  = float(liste[14])
         tb_lamb[iligne] = float(liste[15])'''
         e_spec[iligne] = float(liste[16])
         e_lamb[iligne] = float(liste[17])
         e_spec_lamb[iligne] = float(liste[18])
         '''e_sl_00[iligne] = float(liste[19])
         e_sl_25[iligne] = float(liste[20])
         e_sl_50[iligne] = float(liste[21])
         e_sl_75[iligne] = float(liste[22])
         e_sl_100[iligne] = float(liste[23])'''
         iligne=iligne+1
    fichier.close()
    '''print 'tup'
    z0 = tup.min()
    z1 = tup.max()
    zgrid_output, ngrid_output, z2grid_output, sigmagrid_output, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(month_day[imo], jjr, month[imo], lon, lat, tup, z0, z1, dx, dy)
    tup_day = zgrid_output
    tu[:, :, 0 : month_day[imo], imo] = tup_day[:, :, :]
    print 'tdn'
    z0 = tdn.min()
    z1 = tdn.max()
    zgrid_output, ngrid_output, z2grid_output, sigmagrid_output, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(month_day[imo], jjr, month[imo], lon, lat, tdn, z0, z1, dx, dy)
    tdn_day = zgrid_output
    td[:, :, 0 : month_day[imo], imo] = tdn_day[:, :, :]
    print 'tb spec'
    z0 = tb_spec.min()
    z1 = tb_spec.max()
    zgrid_output, ngrid_output, z2grid_output, sigmagrid_output, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(month_day[imo], jjr, month[imo], lon, lat, tb_spec, z0, z1, dx, dy)
    tb_spec_day = zgrid_output
    tbs[:, :, 0 : month_day[imo], imo] = tb_spec_day[:, :, :]
    print 'tb lamb'
    z0 = tb_lamb.min()
    z1 = tb_lamb.max()
    zgrid_output, ngrid_output, z2grid_output, sigmagrid_output, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(month_day[imo], jjr, month[imo], lon, lat, tb_lamb, z0, z1, dx, dy)
    tb_lamb_day = zgrid_output
    tbl[:, :, 0 : month_day[imo], imo] = tb_lamb_day[:, :, :]'''
    print 'emis spec'
    z0 = e_spec.min()
    z1 = e_spec.max()
    zgrid_output, ngrid_output, z2grid_output, sigmagrid_output, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(month_day[imo], jjr, month[imo], lon, lat, e_spec, z0, z1, dx, dy)
    e_spec_day = zgrid_output
    es[:, :, 0 : month_day[imo], imo] = e_spec_day[:, :, :]
    print 'emis lamb'
    z0 = e_lamb.min()
    z1 = e_lamb.max()
    zgrid_output, ngrid_output, z2grid_output, sigmagrid_output, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(month_day[imo], jjr, month[imo], lon, lat, e_lamb, z0, z1, dx, dy)
    e_lamb_day = zgrid_output
    el[:, :, 0 : month_day[imo], imo] = e_lamb_day[:, :, :]
    print 'emis spec lamb'
    z0 = e_spec_lamb.min()
    z1 = e_spec_lamb.max()
    zgrid_output, ngrid_output, z2grid_output, sigmagrid_output, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(month_day[imo], jjr, month[imo], lon, lat, e_spec_lamb, z0, z1, dx, dy)
    e_spec_lamb_day = zgrid_output
    esl[:, :, 0 : month_day[imo], imo] = e_spec_lamb_day[:, :, :]
    '''print 'emis spec lamb 00'
    z0 = e_sl_00.min()
    z1 = e_sl_00.max()
    zgrid_output, ngrid_output, z2grid_output, sigmagrid_output, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(month_day[imo], jjr, month[imo], lon, lat, e_sl_00, z0, z1, dx, dy)
    e_sl_00_day = zgrid_output
    esl00[:, :, 0 : month_day[imo], imo] = e_sl_00_day[:, :, :]
    print 'emis spec lamb 25'
    z0 = e_sl_25.min()
    z1 = e_sl_25.max()
    zgrid_output, ngrid_output, z2grid_output, sigmagrid_output, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(month_day[imo], jjr, month[imo], lon, lat, e_sl_25, z0, z1, dx, dy)
    e_sl_25_day = zgrid_output
    esl25[:, :, 0 : month_day[imo], imo] = e_sl_25_day[:, :, :]
    print 'emis spec lamb 50'
    z0 = e_sl_50.min()
    z1 = e_sl_50.max()
    zgrid_output, ngrid_output, z2grid_output, sigmagrid_output, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(month_day[imo], jjr, month[imo], lon, lat, e_sl_50, z0, z1, dx, dy)
    e_sl_50_day = zgrid_output
    esl50[:, :, 0 : month_day[imo], imo] = e_sl_50_day[:, :, :]
    print 'emis spec lamb 75'
    z0 = e_sl_75.min()
    z1 = e_sl_75.max()
    zgrid_output, ngrid_output, z2grid_output, sigmagrid_output, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(month_day[imo], jjr, month[imo], lon, lat, e_sl_75, z0, z1, dx, dy)
    e_sl_75_day = zgrid_output
    esl75[:, :, 0 : month_day[imo], imo] = e_sl_75_day[:, :, :]
    print 'emis spec lamb 100'
    z0 = e_sl_100.min()
    z1 = e_sl_100.max()
    zgrid_output, ngrid_output, z2grid_output, sigmagrid_output, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(month_day[imo], jjr, month[imo], lon, lat, e_sl_100, z0, z1, dx, dy)
    e_sl_100_day = zgrid_output
    esl100[:, :, 0 : month_day[imo], imo] = e_sl_100_day[:, :, :]'''
    ###############################################
    # stack gridded data spec lamb in NETCDF file #
    ###############################################
    print 'stacking of gridded data'
    rootgrp = Dataset('/net/argos/data/parvati/lahlod/ARCTIC/monthly_GLACE/gridded_data/cartesian_grid/res_40/cartesian_grid_monthly_data_lamb_spec_near_nadir_AMSUA30_' + month[imo] + '2009.nc', 'w', format='NETCDF3_CLASSIC')
    rootgrp.createDimension('longitude', nx)
    rootgrp.createDimension('latitude', ny)
    rootgrp.createDimension('days', month_day[imo])
    nc_lon = rootgrp.createVariable('longitude', 'f', ('longitude',))
    nc_lat = rootgrp.createVariable('latitude', 'f', ('latitude',))
    nc_day = rootgrp.createVariable('days', 'f', ('days',))
    '''nc_tup = rootgrp.createVariable('tup', 'f', ('latitude', 'longitude', 'days'))
    nc_tdn = rootgrp.createVariable('tdn', 'f', ('latitude', 'longitude', 'days'))
    nc_tb_spec = rootgrp.createVariable('tb_spec', 'f', ('latitude', 'longitude', 'days'))
    nc_tb_lamb = rootgrp.createVariable('tb_lamb', 'f', ('latitude', 'longitude', 'days'))'''
    nc_e_spec = rootgrp.createVariable('e_spec', 'f', ('latitude', 'longitude', 'days'))
    nc_e_lamb = rootgrp.createVariable('e_lamb', 'f', ('latitude', 'longitude', 'days'))
    nc_e_spec_lamb = rootgrp.createVariable('e_spec_lamb', 'f', ('latitude', 'longitude', 'days'))
    '''nc_e_sl_00 = rootgrp.createVariable('e_mixed_s00', 'f', ('latitude', 'longitude', 'days'))
    nc_e_sl_25 = rootgrp.createVariable('e_mixed_s25', 'f', ('latitude', 'longitude', 'days'))
    nc_e_sl_50 = rootgrp.createVariable('e_mixed_s50', 'f', ('latitude', 'longitude', 'days'))
    nc_e_sl_75 = rootgrp.createVariable('e_mixed_s75', 'f', ('latitude', 'longitude', 'days'))
    nc_e_sl_100 = rootgrp.createVariable('e_mixed_s100', 'f', ('latitude', 'longitude', 'days'))'''
    nc_lon[:] = xvec
    nc_lat[:] = yvec
    '''nc_tup[:] = tu[:, :, 0 : month_day[imo], imo]
    nc_tdn[:] = td[:, :, 0 : month_day[imo], imo]
    nc_tb_spec[:] = tbs[:, :, 0 : month_day[imo], imo]
    nc_tb_lamb[:] = tbl[:, :, 0 : month_day[imo], imo]'''
    nc_e_spec[:] = es[:, :, 0 : month_day[imo], imo]
    nc_e_lamb[:] = el[:, :, 0 : month_day[imo], imo]
    nc_e_spec_lamb[:] = esl[:, :, 0 : month_day[imo], imo]
    '''nc_e_sl_00[:] = esl00[:, :, 0 : month_day[imo], imo]
    nc_e_sl_25[:] = esl25[:, :, 0 : month_day[imo], imo]
    nc_e_sl_50[:] = esl50[:, :, 0 : month_day[imo], imo]
    nc_e_sl_75[:] = esl75[:, :, 0 : month_day[imo], imo]
    nc_e_sl_100[:] = esl100[:, :, 0 : month_day[imo], imo]'''
    rootgrp.close()



############################################
# scatter plot theta_eff vs zenith_opacity #
############################################
'''plt.ion()
plt.figure()
scatter(opac, theta_eff, alpha = 0.4)
xlim(0.135, 0.24)
ylim(54.5, 56.3)
xlabel('Zenith opacity')
ylabel('Effective incidence angle (deg)')
grid(True)
plt.savefig('/mma/hermozol/Documents/figure_output/scatter_effective_incident_angle_vs_opacity_AMSUB_JANUARY2009.png')'''

