#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
from netCDF4 import Dataset
import arctic_map # function to regrid coast limits
import cartesian_grid_test # function to convert grid from polar to cartesian
import scipy.special
import ffgrid2
import map_ffgrid
from matplotlib import colors
from matplotlib.font_manager import FontProperties
import map_cartesian_grid
from mpl_toolkits.mplot3d import Axes3D






###############################
# time period characteristics #
###############################
MONTH = np.array(['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'])
month = np.array(['JANUARY', 'FEBRUARY', 'MARCH', 'APRIL', 'MAY', 'JUNE', 'JULY', 'AUGUST', 'SEPTEMBER', 'OCTOBER', 'NOVEMBER', 'DECEMBER'])
month_day = np.array([31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31])
M = len(month)


########################
# grid characteristics #
########################
x0 = -3000. # min limit of grid
x1 = 2500. # max limit of grid
dx = 40.
xvec = np.arange(x0, x1+dx, dx)
nx = len(xvec) 
y0 = -3000. # min limit of grid
y1 = 3000. # max limit of grid
dy = 40.
yvec = np.arange(y0, y1+dy, dy)
ny = len(yvec)


bin = 50
frequ = np.array([23, 30, 50, 89])
h_s = np.zeros([M, 4, 50], float)
h_l = np.zeros([M, 4, 50], float)
h_d = np.zeros([M, 4, 50], float)
h_r = np.zeros([M, 4, 50], float)
c_s = np.zeros([M, 4, 50], float)
c_l = np.zeros([M, 4, 50], float)
c_d = np.zeros([M, 4, 50], float)
c_r = np.zeros([M, 4, 50], float)
for ifr in range (3, 4):
    fichier = open('/net/argos/data/parvati/lahlod/ARCTIC/AMSUA_ice_class/sub_classification/AMSUA'+str(frequ[ifr])+'_data_classification_parameters_ice_no-ice_with_AMSUA23-and-30-spec_2009.dat','r')
    numlines = 0
    for line in fichier: numlines += 1
    fichier.close()
    fichier = open('/net/argos/data/parvati/lahlod/ARCTIC/AMSUA_ice_class/sub_classification/AMSUA'+str(frequ[ifr])+'_data_classification_parameters_ice_no-ice_with_AMSUA23-and-30-spec_2009.dat','r')
    nbtotal = numlines
    iligne = 0
    mo = np.zeros([nbtotal],object)
    hist_spec = np.zeros([nbtotal],float)
    corresp_spec = np.zeros([nbtotal],float)
    hist_lamb = np.zeros([nbtotal],float)
    corresp_lamb = np.zeros([nbtotal],float)
    hist_diff = np.zeros([nbtotal],float)
    corresp_diff = np.zeros([nbtotal],float)
    hist_ratio = np.zeros([nbtotal],float)
    corresp_ratio = np.zeros([nbtotal],float)
    while (iligne < nbtotal) :
         line=fichier.readline()
         liste = line.split()
         mo[iligne] = str(liste[0])
         hist_spec[iligne] = float(liste[1])
         corresp_spec[iligne] = float(liste[2])
         hist_lamb[iligne] = float(liste[3])
         corresp_lamb[iligne] = float(liste[4])
         hist_diff[iligne] = float(liste[5])
         corresp_diff[iligne] = float(liste[6])
         hist_ratio[iligne] = float(liste[7])
         corresp_ratio[iligne] = float(liste[8])
         iligne=iligne+1
    fichier.close()
    for imo in range (0, M):
        mm = nonzero(mo == str(month[imo]))[0]
        h_s[imo, ifr, :] = hist_spec[mm]
        h_l[imo, ifr, :] = hist_lamb[mm]
        h_d[imo, ifr, :] = hist_diff[mm]
        h_r[imo, ifr, :] = hist_ratio[mm]
        c_s[imo, ifr, :] = corresp_spec[mm]
        c_l[imo, ifr, :] = corresp_lamb[mm]
        c_d[imo, ifr, :] = corresp_diff[mm]
        c_r[imo, ifr, :] = corresp_ratio[mm]

ifr = 3
peak = np.zeros([M], float)
for imo in range (0, M):
   a = np.where(h_s[imo, ifr, :] == max(h_s[imo, ifr, :]))[0]
   peak[imo] = c_s[imo, ifr, a]


frequ = np.array(['23', '30', '50', '89'], int)
emis_spec = np.zeros([4, M, ny, nx], float)
emis_lamb = np.zeros([4, M, ny, nx], float)
emis_diff = np.zeros([4, M, ny, nx], float)
emis_ratio = np.zeros([4, M, ny, nx], float)
spec_ice = np.zeros([4, M, ny * nx], float)
lamb_ice = np.zeros([4, M, ny * nx], float)
diff_ice = np.zeros([4, M, ny * nx], float)
ratio_ice = np.zeros([4, M, ny * nx], float)
for ifr in range (0, 4):
    for imo in range (0, M):
        print 'month ' + month[imo]
        ########################
        # read ice extent data #
        ########################
        print 'open emissivity to sub_classify file'
        ## data of emis SPEC, LAMB, DIFF(SPEC-LAMB)
        fichier_e = Dataset('/net/argos/data/parvati/lahlod/ARCTIC/AMSUA_ice_class/sub_classification/cartesian_grid_map_sea_ice_extent_with-AMSUA23-and-30_'+month[imo]+'2009_AMSUA'+str(frequ[ifr])+'_spec_lamb_thresholds.nc', 'r', format='NETCDF3_CLASSIC')
        emis_spec[ifr, imo, :, :] = fichier_e.variables['spec_ice_area'][:]
        emis_lamb[ifr, imo, :, :] = fichier_e.variables['lamb_ice_area'][:]
        emis_diff[ifr, imo, :, :] = fichier_e.variables['diff_ice_area'][:]
        emis_ratio[ifr, imo, :, :] = fichier_e.variables['ratio_ice_area'][:]
        fichier_e.close()
        a = reshape(emis_spec[ifr, imo, :, :], size(emis_spec[ifr, imo, :, :]))
        spec_ice[ifr, imo, 0 : len(a[nonzero(isnan(a) == False)])] = a[nonzero(isnan(a) == False)]
        b = reshape(emis_lamb[ifr, imo, :, :], size(emis_lamb[ifr, imo, :, :]))
        lamb_ice[ifr, imo, 0 : len(a[nonzero(isnan(a) == False)])] = b[nonzero(isnan(b) == False)]
        c = reshape(emis_diff[ifr, imo, :, :], size(emis_diff[ifr, imo, :, :]))
        diff_ice[ifr, imo, 0 : len(a[nonzero(isnan(a) == False)])] = c[nonzero(isnan(c) == False)]
        d = reshape(emis_ratio[ifr, imo, :, :], size(emis_ratio[ifr, imo, :, :]))
        ratio_ice[ifr, imo, 0 : len(a[nonzero(isnan(a) == False)])] = d[nonzero(isnan(d) == False)]





######################
# correlation matrix #
######################
params = np.zeros([M, 16, 5673], float)
for imo in range (0, M):
    params[imo, :, :] = np.array([spec_ice[0, imo, :][nonzero(spec_ice[0, imo, :] != 0.)], spec_ice[1, imo, :][nonzero(spec_ice[1, imo, :] != 0.)], spec_ice[2, imo, :][nonzero(spec_ice[2, imo, :] != 0.)], spec_ice[3, imo, :][nonzero(spec_ice[3, imo, :] != 0.)], lamb_ice[0, imo, :][nonzero(lamb_ice[0, imo, :] != 0.)], lamb_ice[1, imo, :][nonzero(lamb_ice[1, imo, :] != 0.)], lamb_ice[2, imo, :][nonzero(lamb_ice[2, imo, :] != 0.)], lamb_ice[3, imo, :][nonzero(lamb_ice[3, imo, :] != 0.)], diff_ice[0, imo, :][nonzero(diff_ice[0, imo, :] != 0.)], diff_ice[1, imo, :][nonzero(diff_ice[1, imo, :] != 0.)], diff_ice[2, imo, :][nonzero(diff_ice[2, imo, :] != 0.)], diff_ice[3, imo, :][nonzero(diff_ice[3, imo, :] != 0.)], ratio_ice[0, imo, :][nonzero(ratio_ice[0, imo, :] != 0.)], ratio_ice[1, imo, :][nonzero(ratio_ice[1, imo, :] != 0.)], ratio_ice[2, imo, :][nonzero(ratio_ice[2, imo, :] != 0.)], ratio_ice[3, imo, :][nonzero(ratio_ice[3, imo, :] != 0.)], ])


corr_mat = np.zeros([M, 16, 16], float)
for imo in range (0, M): 
    for i in range (0, 16):
        for j in range (0, 16):
            corr_mat[imo, i, j] = np.corrcoef(params[imo, i, :], params_c[imo, j, :])[0][1]



name_params = np.array(['spec89', 'lamb89', 'diff89', 'ratio89', 'spec50', 'lamb50', 'diff50', 'ratio50', 'spec30', 'lamb30', 'diff30', 'ratio30', 'spec23', 'lamb23', 'diff23', 'ratio23'])
figure()
cs = pcolor(corr_mat[imo, :, :], cmap = cm.s3pcpn_l_r)
xticks(np.arange(0, 16, 1), name_params, rotation = 45)
yticks(np.arange(0, 16, 1), name_params, rotation = 45)
colorbar(cs)
#ticks = np.arange(corr_mat[imo, :, :].min(), 1., 0.1)
grid()


# test:
ion()
x_ind, y_ind, z_ind, volume = arctic_map.arctic_map_lat50()
x_coast = x_ind
y_coast = y_ind
z_coast = z_ind
for imo in range (0, M):
    map_cartesian_grid.draw_map_cartes_l(x_coast, y_coast, z_coast, volume, xvec, yvec, emis_ratio[0, :, :], 0.07, 3.40, 0.01, cm.s3pcpn_l_r, 'Sea ice extent - emissivity spec')
    title('AMSUA ' + str(frequ) + ' - ' + str(month[imo]) + ' 2009')
    #plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/sub_classification/maps_sea_ice_extent/emiss_ratio_map_AMSUA'+str(frequ)+'_with_AMSUA23-and-30-spec_'+str(month[imo])+'_2009.png')





#######################
# plot for each month #
#######################
ifr = 3
c = np.array(['r', 'b', 'c', 'm', 'y', 'g'])
fontP = FontProperties()
fontP.set_size('small')
## SPEC ##
## plot first six months of spec emissivity histograms ##
ion()
figure()
for imo in range (0, 6):
    plot(c_s[imo, ifr,:], h_s[imo, ifr,:], c = str(c[imo]), label = str(month[imo]))

grid()
xlim(c_s[imo, ifr,:].min() - 0.02, 1.02)
xlabel('emissivity SPEC')
ylabel('frequency of occurence')
legend(loc = 2, prop = fontP)
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/sub_classification/emiss_spec_AMSUA'+str(frequ[ifr])+'bin50_with_AMSUA23-and-30-spec_JANUARY-JUNE_2009.png')
## plot six following months of spec emissivity histograms ##
figure()
for imo in range (6, M):
    plot(c_s[imo, ifr,:], h_s[imo, ifr,:], c = str(c[imo - 6]), label = str(month[imo]))

grid()
xlim(c_s[imo, ifr,:].min() - 0.02, 1.02)
xlabel('emissivity SPEC')
ylabel('frequency of occurence')
legend(loc = 9, prop = fontP)
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/sub_classification/emiss_spec_AMSUA'+str(frequ[ifr])+'bin50_with_AMSUA23-and-30-spec_JULY-DECEMBER_2009.png')

## LAMB ##
## plot first six months of spec emissivity histograms ##
figure()
for imo in range (0, 6):
    plot(c_l[imo, ifr,:], h_l[imo, ifr,:], c = str(c[imo]), label = str(month[imo]))

grid()
xlim(c_l[imo, ifr, :].min() - 0.02, 1.02)
xlabel('emissivity LAMB')
ylabel('frequency of occurence')
legend(loc = 2, prop = fontP)
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/sub_classification/emiss_lamb_AMSUA'+str(frequ[ifr])+'bin50_with_AMSUA23-and-30-spec_JANUARY-JUNE_2009.png')
## plot six following months of spec emissivity histograms ##
figure()
for imo in range (6, M):
    plot(c_l[imo, ifr,:], h_l[imo, ifr,:], c = str(c[imo - 6]), label = str(month[imo]))

grid()
xlim(c_l[imo, ifr, :].min() - 0.02, 1.02)
xlabel('emissivity LAMB')
ylabel('frequency of occurence')
legend(loc = 9, prop = fontP)
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/sub_classification/emiss_lamb_AMSUA'+str(frequ[ifr])+'bin_50_with_AMSUA23-and-30-spec_JULY-DECEMBER_2009.png')

## DIFF ##
## plot first six months of spec emissivity histograms ##
figure()
for imo in range (0, 6):
    plot(c_d[imo, ifr,:], h_d[imo, ifr,:], c = str(c[imo]), label = str(month[imo]))

grid()
xlim(c_d[imo, ifr, :].min(), c_d[imo, ifr, :].max())
xlabel('emissivity DIFF')
ylabel('frequency of occurence')
legend(loc = 2, prop = fontP)
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/sub_classification/emiss_diff_AMSUA'+str(frequ[ifr])+'bin50_with_AMSUA23-and-30-spec_JANUARY-JUNE_2009.png')
## plot six following months of spec emissivity histograms ##
figure()
for imo in range (6, M):
    plot(c_d[imo, ifr, :], h_d[imo, ifr, :], c = str(c[imo - 6]), label = str(month[imo]))

grid()
xlim(c_d[imo, ifr, :].min(), c_d[imo, ifr, :].max())
xlabel('emissivity DIFF')
ylabel('frequency of occurence')
legend(loc = 9, prop = fontP)
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/sub_classification/emiss_diff_AMSUA'+str(frequ[ifr])+'bin50_with_AMSUA23-and-30-spec_JULY-DECEMBER_2009.png')

## RATIO ##
## plot first six months of spec emissivity histograms ##
figure()
for imo in range (0, 6):
    plot(c_r[imo, ifr, :], h_r[imo, ifr, :], c = str(c[imo]), label = str(month[imo]))

grid()
xlim(c_r[imo, ifr, :].min(), c_r[imo, ifr, :].max())
xlabel('emissivity RATIO')
ylabel('frequency of occurence')
legend(loc = 2, prop = fontP)
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/sub_classification/emiss_ratio_AMSUA'+str(frequ[ifr])+'bin50_with_AMSUA23-and-30-spec_JANUARY-JUNE_2009.png')
## plot six following months of spec emissivity histograms ##
figure()
for imo in range (6, M):
    plot(c_r[imo, ifr, :], h_r[imo, ifr, :], c = str(c[imo - 6]), label = str(month[imo]))

grid()
xlim(c_r[imo, ifr, :].min(), c_r[imo, ifr, :].max())
xlabel('emissivity RATIO')
ylabel('frequency of occurence')
legend(loc = 9, prop = fontP)
plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/sub_classification/emiss_ratio_AMSUA'+str(frequ[ifr])+'bin50_with_AMSUA23-and-30-spec_JULY-DECEMBER_2009.png')





ticks=np.arange(corr_mat.min(), corr_mat.max(), 0.01)





# test:
ion()
x_ind, y_ind, z_ind, volume = arctic_map.arctic_map_lat50()
x_coast = x_ind
y_coast = y_ind
z_coast = z_ind
map_cartesian_grid.draw_map_cartes_l(x_coast, y_coast, z_coast, volume, xdist, ydist, spec_ice[11, :, :], 0.6, 1.02, 0.01, cm.s3pcpn_l_r, 'test')
