#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
import ffgrid2
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
#import netCDF4
from matplotlib import colors

def draw(zz, xx, yy, outfile, txt,cax1,cax2,cax3):
        figure()
        dx=0.5
        dy=0.5
        x0, x1 = -180, 180
        y0, y1 = -90, 90
        #z=np.zeros([181,361],float)
        #x=np.zeros([361])
        #y=np.zeros([181])
        #z=np.zeros([361,721],float)
        #x=np.zeros([721])
        #y=np.zeros([361])
        
        zz0 = zz.min()
        zz1= zz.max()
        z, x, y = ffgrid2.ffgrid(xx, yy, zz, dx, dy, x0,x1,y0,y1,zz0, zz1)
        
        m = Basemap(width=5500000,height=5500000,
            resolution='l',projection='laea',\
            lat_ts=90,lat_0=90,lon_0=0.)
        
        #m1 = Basemap(projection='ortho',lon_0=0,lat_0=90,resolution='c')
        # add an axes with a black background
        #m = Basemap(projection='ortho',lon_0=0,lat_0=90,resolution='l',\
           # llcrnrx=0.,llcrnry=0.,urcrnrx=m1.urcrnrx/3.,urcrnry=m1.urcrnry/3.)

        #m = Basemap(projection='ortho',lon_0=0,lat_0=90,resolution='c')
	#m = Basemap(llcrnrlon=-180,urcrnrlon=180,llcrnrlat=-90,urcrnrlat=90,projection='cyl',resolution='c',fix_aspect=True)
       
        #ax = plt.gca()
	xii, yii = m(*np.meshgrid(x,y))
	#ax = plt.gca()
	#clevs=arange(0,0.8,0.005)
	#cax1=zz0
	#cax2=zz1
	#cax3=(cax2-cax1)/100
	clevs=arange(cax1,cax2,cax3)
	#boxColors = ['darkkhaki','royalblue']

	m.drawcoastlines(linewidth=1)
	#m.drawlsmask(land_color='white',ocean_color='#F4EAF1', lakes=False)
	#m.drawlsmask(land_color='#F4EAF1', lakes=False)
	cmap2 = colors.ListedColormap(['white',[0.9,0.9,0.9],[0.6,0.6,0.6],[0.8,0.8,0.8],[0.3,0.3,0.3],'white'])
        bounds=[0,1,2,3,4]
        norm = colors.BoundaryNorm(bounds, cmap2.N)
        cs=m.contourf(xii,yii,z, clevs, cmap=cmap2, extend="both") # emissivity
        


        #cs=m.contourf(xii,yii,z,  5, colors='none',hatches=[None,'.', '/', '\\', '*'],extend='lower')
                 
	cbar =colorbar(cs, orientation='vertical')
        #cbar.set_label(txt, color='k')
        #cbar.ax.tick_params(labelsize=14)
        
        tick_labels =['no ice','seasonal ice','permanent ice','ambiguous ice type','']
        tick_locs   = [0.5,1.5,2.5,3.5,4.5]
        #tick_locs   = [-3.9e-1,-2.6e-1,-1.3e-1,0e-1,1.3e-1,2.6e-1,3.9e-1]
        #tick_labels = ['-0.390','-0.260','-0.130','0','0.13','0.26','0.390']


        cbar.locator     = matplotlib.ticker.FixedLocator(tick_locs)
        cbar.formatter   = matplotlib.ticker.FixedFormatter(tick_labels)
        cbar.update_ticks()


        #cbar.set_ticklabels(['','no ice','young ice','ice after summer melt','ambiguous ice type',''])
        #cbar.set_tick_locs   = [0.5,1.5,2.5,3.5,4.5]

        #cbar.set_ticks([0.5,0.6,0.7,0.8,0.9,1.0])
        #cbar.set_ticklabels(['0.5','0.6','0.7','0.8','0.9','1.0'])
        
        

        #m.drawlsmask(ocean_color='white')
        #cbar.set_clim(0.65,1)
	#m.drawmapboundary(fill_color='aqua')
	
	#m.drawparallels(np.arange(-90.,90.,30.), labels=[1,0,0,0])
	#m.drawmeridians(np.arange(-180.,180.,40.), labels=[0,0,0,1])
	#m.drawparallels(np.arange(-90.,90.,10.), color='#909090', linewidth=1.0, zorder=None, dashes=[1, 1])
	#m.drawmeridians(np.arange(-180.,180.,50.))
	# stations: Thulé, Resolute, Longyearbyen, lqaluit, murmonsk, arkangelek

      	plt.savefig(outfile)
	#close()
