

list_e=[0.65 0.7 0.75 0.8 0.85 0.9 0.95];

for k=1:4
    T0=300;
    e=list_e(k);
    tau=[0.0000005:0.001:1];
    TT1=285;
    TT2=270;
    Td=TT1*(1-exp(-tau));
    Tu=TT2*(1-exp(-tau));
    ttau=exp(-tau);
    clear spec;
    clear lamb;
    clear Tb1;
    
    for i=1:length(tau)
        
        f1(i)=expint(tau(i));
        f(i)=acos(-tau(i)/(log((exp(-tau(i))-tau(i)*(exp(-tau(i))-tau(i)*f1(i))))))*180/pi;
        Tdd(i)=TT1*(1-exp(-tau(i)/cos(f(i)*pi/180)));
        spec(i)=(T0*e*exp(-tau(i)))+(1-e)*exp(-tau(i))*Td(i)+Tu(i);
        lamb(i)=(T0*e*exp(-tau(i)))+(1-e)*exp(-tau(i))*Tdd(i)+Tu(i);
        
        ee_sp(i)=(((spec(i)-Tu(i))*exp(tau(i)))-Td(i))/(T0-Td(i));
        ee_lm(i)=(((lamb(i)-Tu(i))*exp(tau(i)))-Td(i))/(T0-Td(i));
    
    end
    !C4(k)=ee_sp(11)-ee_lm(11);
    !C5(k)=spec(11)-lamb(11);
    
    
    
    subplot(4,2,2*k-1)
    plot(tau,spec,'-k')
    hold on
    plot(tau,lamb,'-.k')
    
    xlabel('Zenith opacity')
    ylabel('Brightness temperature (K)')
    
    C1=fix(TT1);
    C2=fix(TT2);
    C3=fix(T0);
    title(['Tbs comparison with initial e= ',num2str(e)]);
     
    subplot(4,2,2*k)
    plot(tau,ee_sp,'-k')
    hold on
    plot(tau,ee_lm,'-.k')
    xlabel('Zenith opacity')
    ylabel('Emissivity')
    
    
    C4(k)=ee_sp(11)-ee_lm(11);
    C5(k)=spec(11)-lamb(11);
    !title(['e=',num2str(e),',T1=',num2str(C1),',T2=',num2str(C2),',T0=',num2str(C3),',Diff at 0.1=',num2str(C4)]);
    !legend('Specular','lambertian');
     title(['Emissivities comparison with initial e= ',num2str(e)]);
end


fid = fopen('EFFECTIVE_ANGLES.DAT', 'wt');
%fid = fopen('TEST.DAT', 'wt');
for i=1:size(tau_theo,2)
        
        fprintf(fid, '%12.8E %12.8E\n', tau_theo(i), f(i));
end
fclose(fid)


legend('Specular','lambertian');
figure;

plot(tau,f,'-k')

xlabel('Zenith opacity')
ylabel('Effective incidence angle (deg)');

figure;

plot(ttau,f,'-k')

xlabel('Zenith transmission')
ylabel('Effective incidence angle (deg)');

