#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
from netCDF4 import Dataset
import arctic_map # function to regrid coast limits
import cartesian_grid_test # function to convert grid from polar to cartesian
import scipy.special
import ffgrid2
import map_ffgrid
from matplotlib.font_manager import FontProperties
import map_cartesian_grid






MONTH = np.array(['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'])
month = np.array(['JANUARY', 'FEBRUARY', 'MARCH', 'APRIL', 'MAY', 'JUNE', 'JULY', 'AUGUST', 'SEPTEMBER', 'OCTOBER', 'NOVEMBER', 'DECEMBER'])
month_day = np.array([31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31])
M = len(month)





frequ = 23


#########################
# emissivity thresholds #
#########################
fichier = open('/net/argos/data/parvati/lahlod/ARCTIC/AMSUA_ice_class/AMSUA'+ str(frequ) + '_data_classification_parameters_ice_no-ice_2009.dat', 'r')
numlines = 0
for line in fichier: numlines += 1

fichier.close()

fichier=open('/net/argos/data/parvati/lahlod/ARCTIC/AMSUA_ice_class/AMSUA' + str(frequ) + '_data_classification_parameters_ice_no-ice_2009.dat','r')
nbtotal = numlines-1
iligne = 0
mois = np.zeros([nbtotal],object)
emis_lim_spec = np.zeros([nbtotal],float)
emis_lim_lamb = np.zeros([nbtotal],float) 
while (iligne < nbtotal) :
    line=fichier.readline()
    liste = line.split()
    mois[iligne] = str(liste[0])
    emis_lim_spec[iligne] = float(liste[7])
    emis_lim_lamb[iligne] = float(liste[8])
    iligne=iligne+1

fichier.close()
vec = np.arange(0, nbtotal + 1, 50)
lim_spec = np.zeros([M], float)
lim_lamb = np.zeros([M], float)
for imo in range (0, M):
    lim_spec[imo] = emis_lim_spec[vec[imo]]
    lim_lamb[imo] = emis_lim_lamb[vec[imo]]



x0 = -3000. # min limit of grid
x1 = 2500. # max limit of grid
dx = 40.
xvec = np.arange(x0, x1+dx, dx)
nx = len(xvec) 
y0 = -3000. # min limit of grid
y1 = 3000. # max limit of grid
dy = 40.
yvec = np.arange(y0, y1+dy, dy)
ny = len(yvec)



emis_spec_moy = np.zeros([ny, nx, M], float)
emis_lamb_moy = np.zeros([ny, nx, M], float)
emis_diff = np.zeros([ny, nx, M], float)
emis_ratio = np.zeros([ny, nx, M], float)
for imo in range (0, M):
    print 'month ' + month[imo]
    ##############
    # emissivity #
    ##############
    print 'read file for emiss'
    fichier_emis = Dataset('/net/argos/data/parvati/lahlod/ARCTIC/monthly_GLACE/gridded_data/cartesian_grid/res_40/cartesian_grid_monthly_data_lamb_spec_near_nadir_AMSUA' + str(frequ) + '_' + month[imo] + '2009.nc', 'r', format='NETCDF3_CLASSIC')
    xdist = fichier_emis.variables['longitude'][:]
    ydist = fichier_emis.variables['latitude'][:]
    day = fichier_emis.variables['days'][:]
    emis_spec = fichier_emis.variables['e_spec'][:]
    emis_lamb = fichier_emis.variables['e_lamb'][:]
    fichier_emis.close()
    print 'calculation of monthly mean'
    for ilon in range (0, nx):
        for ilat in range (0, ny):
            emis_spec_moy[ilat, ilon, imo] = mean(emis_spec[ilat, ilon, :][nonzero(isnan(emis_spec[ilat, ilon, :]) == False)])
            emis_lamb_moy[ilat, ilon, imo] = mean(emis_lamb[ilat, ilon, :][nonzero(isnan(emis_lamb[ilat, ilon, :]) == False)])
    print 'calculation of monthly mean difference lamb-spec'
    emis_diff[:, :, imo] = emis_lamb_moy[:, :, imo] - emis_spec_moy[:, :, imo]
    #########
    # ratio #
    #########
    print 'read file for ratio'
    fichier_ratio = Dataset('/net/argos/data/parvati/lahlod/ARCTIC/monthly_GLACE/gridded_data/cartesian_grid/res_40/cartesian_grid_monthly_lamb-spec_ratio_near_nadir_AMSUA' + str(frequ) + '_' + month[imo] + '2009.nc', 'r', format='NETCDF3_CLASSIC')
    xdist = fichier_ratio.variables['longitude'][:]
    ydist = fichier_ratio.variables['latitude'][:]
    emis_ratio[:, :, imo] = fichier_ratio.variables['emis_ratio'][:]
    fichier_ratio.close()



###########################################
# emissivity distribution after filtering #
###########################################

hist_val_spec = np.zeros([50, M], float)
hist_val_lamb = np.zeros([50, M], float)
hist_val_ratio = np.zeros([50, M], float)
hist_val_diff = np.zeros([50, M], float)
corresp_val_spec = np.zeros([50, M], float)
corresp_val_lamb = np.zeros([50, M], float)
corresp_val_ratio = np.zeros([50, M], float)
corresp_val_diff = np.zeros([50, M], float)
emis_spec_f = np.zeros([7000, M], float)
emis_lamb_f = np.zeros([7000, M], float)
emis_ratio_f = np.zeros([7000, M], float)
emis_diff_f = np.zeros([7000, M], float)
X = np.zeros([7000, M], float)
Y = np.zeros([7000, M], float)
L_spec = np.zeros([M], int)
for imo in range (0, M):
    print 'month ' + month[imo]
    # choice of spec emissivity as the threshold for the study // definition of x and y index corresponding to the points which emissivity value is over threshold
    y_index_spec = np.where(emis_spec_moy[:, :, imo] >= lim_spec[imo])[0] 
    Y[0 : len(y_index_spec), imo] = y_index_spec[:]
    x_index_spec = np.where(emis_spec_moy[:, :, imo] >= lim_spec[imo])[1]
    X[0 : len(x_index_spec), imo] = x_index_spec[:]
    L_spec[imo] = len(x_index_spec) # = len(y_index)
#print 'length of x and y index ', L_spec[imo]
# definition of filtered values (vectors) with the previous threshold // values of filtered emissivity SPEC, LAMB, rate and difference LAMB-SPEC 
for ii in range (0, L_spec[imo]):
emis_spec_f[ii, imo] = emis_spec_moy[y_index_spec[ii], x_index_spec[ii], imo]
emis_lamb_f[ii, imo] = emis_lamb_moy[y_index_spec[ii], x_index_spec[ii], imo]
emis_ratio_f[ii, imo] = emis_ratio[y_index_spec[ii], x_index_spec[ii], imo]
emis_diff_f[ii, imo] = emis_diff[y_index_spec[ii], x_index_spec[ii], imo]
# definition of their distribution within the new filtered values
hist_val_spec[:, imo] = hist(emis_spec_f, bins = 50, normed = True, histtype='step')[0]
hist_val_lamb[:, imo] = hist(emis_lamb_f, bins = 50, normed = True, histtype='step')[0]
hist_val_ratio[:, imo] = hist(emis_ratio_f, bins = 50, normed = True, histtype='step')[0]
hist_val_diff[:, imo] = hist(emis_diff_f, bins = 50, normed = True, histtype='step')[0]
for ibin in range (0, 50):
corresp_val_spec[ibin, imo] = mean(hist(emis_spec_f, bins = 50, normed = True, histtype='step')[1][ibin : ibin + 2])
corresp_val_lamb[ibin, imo] = mean(hist(emis_lamb_f, bins = 50, normed = True, histtype='step')[1][ibin : ibin + 2])
corresp_val_ratio[ibin, imo] = mean(hist(emis_ratio_f, bins = 50, normed = True, histtype='step')[1][ibin : ibin + 2])
corresp_val_diff[ibin, imo] = mean(hist(emis_diff_f, bins = 50, normed = True, histtype='step')[1][ibin : ibin + 2])


return(emis_spec_f, emis_lamb_f, emis_ratio_f, emis_diff_f, L_spec)  



'''
########
# plot #
########
c = np.array(['r', 'b', 'c', 'm', 'y', 'g'])
figure()
for imo in range (0, 6):
plot(corresp_val[:, imo], hist_val[:, imo], c = str(c[imo]), label = str(month[imo]))

grid()
xlim(corresp_val.min() - 0.02, corresp_val.max() + 0.02)
xlabel('emissivity parameter')
ylabel('frequency of occurence')
fontP = FontProperties()
fontP.set_size('small')
legend(prop = fontP)
#plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/emiss_rate_AMSUA30_JANUARY-JUNE_2009.png')
## plot six following months of spec emissivity histograms ##
figure()
for imo in range (6, M):
plot(corresp_val[:, imo], hist_val[:, imo], c = str(c[imo - 6]), label = str(month[imo]))

grid()
xlim(corresp_val.min() - 0.02, corresp_val.max() + 0.02)
xlabel('emissivity parameter')
ylabel('frequency of occurence')
legend(loc = 1, prop = fontP)
#plt.savefig('/usr/home/lahlod/twice_d/fig_output_ARCTIC/fig_output_sea_ice_study/ice_class_AMSUA/emiss_rate_AMSUA30_JULY-DECEMBER_2009.png')
'''
