#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
import ffgrid2
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
import draw_map

####################################################
# from polar (lon, lat) to cartesian coords (x, y) #
####################################################


longitude = np.array([-170.602, -167.743, -169.509, -162.186, -177.988, -168.24 ,-170.076, -166.746, -168.767, -164.959, -170.677, -167.221,-172.508, -169.327, -174.282, -171.319, -167.727, -176.02 , -173.229, -169.924, -165.802, -177.737, -175.083, -172.005,-168.265, -163.448, -176.901, -174.004, -170.564, -166.263, -178.698, -175.945, -172.743, -168.842, -163.806,  179.512, -177.849, -174.838, -171.252, -166.757, -160.73 ,  177.718, -179.733, -176.875, -173.539, -169.464, -164.186,  175.908, -175.74 , -171.996])

latitude = np.array([65.093,  65.374,  65.694,  66.215,  65.074,  66.295,  66.61 ,66.895,  67.214,  67.489,  67.524,  67.817,  67.826,  68.133, 68.119,  68.437,  68.739,  68.403,  68.733,  69.049,  69.34 , 68.678,  69.019,  69.348,  69.66 ,  69.928,  69.295,  69.637, 69.965,  70.265,  69.562,  69.915,  70.257,  70.579,  70.856, 69.817,  70.184,  70.538,  70.878,  71.188,  71.419,  70.061, 70.441,  70.808,  71.163,  71.498,  71.783,  70.29 ,  71.436, 71.789])

z = np.array([247.17,  237.43,  237.66,  207.98,  247.8 ,  227.75,  225.36, 224.05,  239.93,  240.18,  235.74,  244.9 ,  227.58,  242.47,222.32,  232.91,  241.65,  220.91,  234.52,  230.57,  236.59, 225.  ,  223.64,  235.33,  234.3 ,  227.1 ,  224.58,  239.58,234.8 ,  236.97,  218.81,  232.01,  240.  ,  233.47,  232.18, 222.38,  218.81,  237.65,  234.8 ,  230.23,  222.63,  222.11, 231.17,  231.32,  234.91,  229.06,  219.26,  226.37,  229.54, 229.58])




L = len(z)
#z0 = min(z)
#z1 = max(z)
Rt = 6371.
alpha = (pi*Rt)/180.
beta = pi/180.
x = np.zeros([L], float)
y = np.zeros([L], float)
for k in range (0, L):
    if ((longitude[k] >= 0.) & (longitude[k] <= 90.)): # 4eme quadrant
        theta = (90. - longitude[k]) * beta
        x[k] = (90. - latitude[k]) * alpha * cos(theta)
        y[k] = (90. - latitude[k]) * alpha * sin(-theta)
    else:
        if ((longitude[k] > 90.) & (longitude[k] <= 180.)): # 1er quadrant
            theta = (longitude[k] - 90.) * beta
            x[k] = (90. - latitude[k]) * alpha * cos(theta)
            y[k] = (90. - latitude[k]) * alpha * sin(theta)
        else: 
            if ((longitude[k] >= -180.) & (longitude[k] < 0.)): # 2eme et 3eme quadrants
                theta = (270. + longitude[k]) * beta
                x[k] = (90. - latitude[k]) * alpha * cos(theta)
                y[k] = (90. - latitude[k]) * alpha * sin(theta)


# definition of the new cartesian grid (x, y) #
Mx = max(x)
mx = min(x)
x0 = round(mx) - 50. # xmin
x1 = round(Mx) + 50. # xmax
dx = 35. # delta(x)
xvec = np.arange(x0, x1+dx, dx)
nx = len(xvec)
My = max(y)
my = min(y)
y0 = round(my) - 50. # ymin
y1 = round(My) + 50. # ymax
dy = 35. # delta(y)
yvec = np.arange(y0, y1+dy, dy)
ny = len(yvec)
xgrid_cart, ygrid_cart= np.meshgrid(xvec, yvec) # new cartesian grid (centered on North pole)


# counting each grid cell #
ix = np.zeros([L], int)
i = 0
for i in range (0, L): # boucle sur les points M (abscisses) 
    if x[i] == x0:
        ix[i] = 0
    else:
        ix[i] = math.ceil((x[i] - x0) / dx) - 1 # associates each x vakue to a cell number

i = 0
iy = np.zeros([L], int) 
for i in range (0, L):# boucle sur les points M (ordonnees) 
    if y[i] == y0:
        iy[i] = 0
    else:
        iy[i] = math.ceil((y[i] - y0) / dy) - 1 # associates each y vakue to a cell number


# calculation of distances between point M(x,y) and 4 grid points of its belonging cell #
close_point = np.zeros([L, 2], int)
k = 0
for k in range (0, L): # boucle sur les points M (x et y)
    #print 'x', x[k]
    #print 'y', y[k]
    #print 'xvec', xvec[ix[k]]
    #print 'yvec', yvec[iy[k]]
    d1 = sqrt(((x[k] - xvec[ix[k]]) ** 2) + ((y[k] - yvec[iy[k]]) ** 2))
     #   print 'd1', d1
    d2 = sqrt(((x[k] - xvec[ix[k] + 1]) ** 2) + ((y[k] - yvec[iy[k]]) ** 2))
    #print 'd2', d2
    d3 = sqrt(((x[k] - xvec[ix[k]]) ** 2) + ((y[k] - yvec[iy[k] + 1]) ** 2))
     #   print 'd3', d3
    d4 = sqrt(((x[k] - xvec[ix[k] + 1]) ** 2) + ((y[k] - yvec[iy[k] + 1]) ** 2))
    #print 'd4', d4
    d_vec = np.array([d1, d2, d3, d4])
    ind = np.where(d_vec == min(d_vec)) # finds the smallest distance between the 4 points of the grid
    #print 'grid cell no : ' + str(ind[0][0]+1)
    point_vec = np.array([(ix[k], iy[k]), (ix[k] + 1, iy[k]), (ix[k], iy[k] + 1), (ix[k] + 1, iy[k] + 1)])
    #print 'chosen point in grid', point_vec[ind[0][0]] 
    close_point[k, :] = point_vec[ind[0][0]]# we have chosen which point of the grid is     closer to M // point_vec[ind[0][0]] = (cell no of closest x, celle no of closest y)


# association of z value to closest grid point #
zgrid = np.zeros([ny, nx], float) # z in new grid
ngrid = np.zeros([ny, nx], int) # nb of obs per new grid cell
z2grid = np.zeros([ny, nx], float) # z2 in new grid
for k in range (0, L):
    zgrid[close_point[k, 1], close_point[k, 0]] = zgrid[close_point[k, 1], close_point[k, 0]] + z[k]
    ngrid[close_point[k, 1], close_point[k, 0]] = ngrid[close_point[k, 1], close_point[k, 0]] + 1
    z2grid[close_point[k, 1], close_point[k, 0]] = z2grid[close_point[k, 1], close_point[k, 0]] + (z[k] * z[k])



sigmagrid = sqrt((1./(ngrid[98, 101]-1))*(z2grid[98, 101] - ngrid[98, 101]*ZGRID[98, 101]*ZGRID[98, 101]))


# z in each point of new grid #
ZGRID = zgrid / ngrid
# variance of z in each grid cell #
sigmagrid = np.zeros([ny, nx], float)
for j in range (0, nx):
    for i in range (0, ny):
        if (ngrid[i, j] > 1): # take away the cells where no obs 
            sigmagrid[i, j] = sqrt((1./(ngrid[i, j]-1.))*(z2grid[i, j] - ngrid[i, j]*ZGRID[i, j]*ZGRID[i, j]))
        else:
            if (ngrid[i, j] == 1):
                sigmagrid[i, j] = 0.
            else:
                sigmagrid[i, j] = NaN

for j in range (0, nx):
    for i in range (0, ny):
        if (sigmagrid[i, j] < 0.):
            sigmagrid = NaN



import arctic_map # function to regrid coast limits
import cartesian_grid_test # function to convert grid from polar to cartesian
plt.ion()
plt.figure()
#clevs3 = np.arange(0., 0.015, 0.001)
#cs = plt.contourf(xgrid_cart,ygrid_cart, z2grid, clevs, cmap=cm.s3pcpn_l_r) 
cs = plt.contourf(xgrid_cart, ygrid_cart, z2grid, cmap=cm.s3pcpn_l_r) 
cbar = colorbar(cs)
plt.figure()
#clevs3 = np.arange(0., 0.015, 0.001)
#cs = plt.contourf(xgrid_cart,ygrid_cart, z2grid, clevs, cmap=cm.s3pcpn_l_r) 
cs = plt.contourf(xgrid_cart, ygrid_cart, sigmagrid, cmap=cm.s3pcpn_l_r) 
cbar = colorbar(cs)
xlim(-4000., 3000.)
ylim(-4000., 4000.)








