#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
from netCDF4 import Dataset


## read file ##
nsidc_file = Dataset ('/net/argos/data/parvati/lahlod/ARCTIC/asicd25e2_20100101.nc','r', format = 'NETCDF4')
#for i in nsidc_file.variables:
#    print nsidc_file.variables[i]


time = nsidc_file.variables['time'][:]
lat = nsidc_file.variables['latitude'][:]
lon = nsidc_file.variables['longitude'][:]
sic = nsidc_file.variables['sea_ice_cover'][:]
domo = nsidc_file.variables['day_of_melt_onset'][:]
somo = nsidc_file.variables['status_of_melt_onset'][:]
aosi = nsidc_file.variables['age_of_sea_ice'][:]
gc = nsidc_file.variables['grid_conversions'][:]
cs = nsidc_file.variables['coord_system'][:]


nsidc_file.close()




plt.ion()
plt.figure()
m = Basemap(llcrnrlon=-180, urcrnrlon=180, llcrnrlat=-90., urcrnrlat=90, projection='cyl', resolution='c', fix_aspect=True)
m.drawcoastlines(linewidth = 1)
m.drawparallels(np.arange(-90., 90., 20.))
m.drawmeridians(np.arange(-180., 180., 20.))
xii,yii = m(*np.meshgrid(lon_cote, lat_cote))
