#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import numpy as np
import matplotlib.pyplot as plt
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
from netCDF4 import Dataset
import arctic_map # function to regrid coast limits
import cartesian_grid_test # function to convert grid from polar to cartesian


le_mois=np.array(['NOVEMBER2009', 'DECEMBER2009', 'JANUARY2010', 'FEBRUARY2010'])
month_days = np.array([30, 31, 31, 28])



for imo in range (0, 1):
    fichier=open("/net/argos/data/parvati/lahlod/ARCTIC/AMSUA_EMIS_GLACE_"+str(le_mois[imo])+".DAT",'r')
    numlines = 0
    for line in fichier: numlines += 1
    fichier.close()
    fichier=open("/net/argos/data/parvati/lahlod/ARCTIC/AMSUA_EMIS_GLACE_"+str(le_mois[imo])+".DAT",'r')
    nbtotal=numlines-1
    iligne=0
    lat=np.zeros([nbtotal],float)
    lon=np.zeros([nbtotal],float)
    jjr=np.zeros([nbtotal],float)
    zen=np.zeros([nbtotal],float)
    fov=np.zeros([nbtotal],float)
    ts=np.zeros([nbtotal],float)
    emis=np.zeros([4,nbtotal],float)
    tb=np.zeros([4,nbtotal],float)
    tup=np.zeros([4,nbtotal],float)
    tdn=np.zeros([4,nbtotal],float)
    #trans=np.zeros([4,nbtotal],float)
    while (iligne < nbtotal) :
         line = fichier.readline()
         # exemple : line = "0.22 2.3 5.0 6"
         liste = line.split()
         # exemple : listeCoord ['0.22', '2.3', '5.0', '6'] (liste de chaine de caract?es)
         lat[iligne] = float(liste[1])
         lon[iligne] = float(liste[0])
         jjr[iligne] = float(liste[4])
         ts[iligne] = float(liste[8])
         fov[iligne] = float(liste[10])
         #trans[iligne] = float(liste[17])
         for ki in range(0,4):
             emis[ki,iligne] = float(liste[12+ki])
             tb[ki,iligne] = float(liste[16+ki])
             tdn[ki,iligne] = float(liste[20+ki])
             tup[ki,iligne] = float(liste[24+ki])
             #trans[ki,iligne] = float(liste[28+ki])
             #tup_ssmis[ki,iligne] = float(liste[28+ki])
             #tdn_ssmis[ki,iligne] = float(liste[37+ki])
             #trans_ssmis[ki,iligne] = float(liste[44+ki])
         iligne=iligne+1
    fichier.close()
    jour = jjr
    month = month_days[imo] #number of days in month
    longi = lon
    lati = lat
    z_ini = tb[0,:]
    z0 = min(z_ini)
    z1 = max(z_ini)
    dx = 50.
    dy = 50.
    zgrid_output, ngrid_output, z2grid_output, sigmagrid_output, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(jour, month, longi, lati, z_ini, z0, z1, dx, dy)  
    tbch1_nov2009 = zgrid_output

    


## study zone 1 (ice after summer melt) ##
# x around -587.198 // y around 1187.5
index_x = np.where(xvec == -550.)[0][0]
index_y = np.where(yvec == 1150.)[0][0]
a = tbch1_nov2009[index_y, index_x, :]
b = ngrid_output[index_y, index_x, :]
c = sigmagrid_output[index_y, index_x, :]


plt.ion()
plt.figure()
plt.plot(a, 'r', label = 'Tb ch1')
legend()
plt.figure()
plt.plot(b, 'g', label = 'n values in cell')
legend()
plt.figure()
plt.plot(c, 'b', label = 'variance Tb values in cell' )
legend()

## interessant de comparer les Tb avec une resolution plus ou moins fine ##



tbmean = np.zeros([len(yvec), len(xvec)], float)
nmean = np.zeros([len(yvec), len(xvec)], float)
sigmamean = np.zeros([len(yvec), len(xvec)], float)
for ix in range (0, len(xvec)):
    for iy in range (0, len(yvec)):
        tbmean[iy, ix] = tbch1_nov2009[iy, ix, :][nonzero(isnan(tbch1_nov2009[iy, ix, :]) == False)].mean()
        nmean[iy, ix] = ngrid_output[iy, ix, :][nonzero(isnan(ngrid_output[iy, ix, :]) == False)].mean()
        sigmamean[iy, ix] = sigmagrid_output[iy, ix, :][nonzero(isnan(sigmagrid_output[iy, ix, :]) == False)].mean()




x_ind, y_ind, z_ind, volume = arctic_map.arctic_map_lat50()
plt.figure()
plt.scatter(x_ind, y_ind, c = z_ind, s = volume)
clevs = np.arange(137., 269., 1.)
cs = plt.contourf(xgrid_cart,ygrid_cart, tbmean, clevs, cmap=cm.s3pcpn_l_r) 
cbar = colorbar(cs)
xlim(-2500., 3000.)
ylim(-3000., 3000.)
#txt = 'variance - spatial resolution = ' + str(delta_xy[idel]) + 'km'    
#cbar.set_label(txt)
plt.figure()
plt.scatter(x_ind, y_ind, c = z_ind, s = volume)
clevs = np.arange(0, 30, 1)
cs = plt.contourf(xgrid_cart,ygrid_cart, nmean, clevs, cmap=cm.s3pcpn_l_r) 
cbar = colorbar(cs)
xlim(-2500., 3000.)
ylim(-3000., 3000.)
plt.figure()
plt.scatter(x_ind, y_ind, c = z_ind, s = volume)
clevs = np.arange(0., 16., 0.1)
cs = plt.contourf(xgrid_cart,ygrid_cart, sigmamean, clevs, cmap=cm.s3pcpn_l_r) 
cbar = colorbar(cs)
xlim(-2500., 3000.)
ylim(-3000., 3000.)






#for canal in range(0,4):
#    for ii in range (0,size(emis[canal,:])):
#        if (emis[canal,ii] > 1): emis[canal,ii] = NaN
bblat_nov2009 = nonzero(lat >= 65.)  
#bbfov = nonzero(fov[bblat] == 0.)
#ijr = 0
bbjr_nov2009 = nonzero(jjr[bblat_nov2009] == 15.)
lon_zon_nov2009 = lon[bblat_nov2009][bbjr_nov2009]
lat_zon_nov2009 = lat[bblat_nov2009][bbjr_nov2009]
#emisch4 = emis[3,:][bblat][bbjr]
#emisch3 = emis[2,:][bblat][bbjr]
tbch1_nov2009 = tb[0,:][bblat_nov2009][bbjr_nov2009]
tbch2_nov2009 = tb[1,:][bblat_nov2009][bbjr_nov2009]
tbch3_nov2009 = tb[2,:][bblat_nov2009][bbjr_nov2009]
tbch4_nov2009 = tb[3,:][bblat_nov2009][bbjr_nov2009]
#tsurf = ts[bblat][bbjr]    
#tdnch4 = tdn[3,:][bblat][bbjr]
#tdnch3 = tdn[2,:][bblat][bbjr]
#tupch4 = tup[3,:][bblat][bbjr]
#tupch3 = tup[2,:][bblat][bbjr]



# DECEMBER2009
imo = 1
fichier=open("/net/argos/data/parvati/lahlod/ARCTIC/AMSUA_EMIS_GLACE_"+str(le_mois[imo])+".DAT",'r')
numlines = 0
for line in fichier: numlines += 1

fichier.close()
fichier=open("/net/argos/data/parvati/lahlod/ARCTIC/AMSUA_EMIS_GLACE_"+str(le_mois[imo])+".DAT",'r')
nbtotal=numlines-1
iligne=0
lat=np.zeros([nbtotal],float)
lon=np.zeros([nbtotal],float)
jjr=np.zeros([nbtotal],float)
zen=np.zeros([nbtotal],float)
fov=np.zeros([nbtotal],float)
ts=np.zeros([nbtotal],float)
emis=np.zeros([4,nbtotal],float)
tb=np.zeros([4,nbtotal],float)
tup=np.zeros([4,nbtotal],float)
tdn=np.zeros([4,nbtotal],float)
#trans=np.zeros([4,nbtotal],float)
while (iligne < nbtotal) :
     line = fichier.readline()
     # exemple : line = "0.22 2.3 5.0 6"
     liste = line.split()
     # exemple : listeCoord ['0.22', '2.3', '5.0', '6'] (liste de chaine de caract?es)
     lat[iligne] = float(liste[1])
     lon[iligne] = float(liste[0])
     jjr[iligne] = float(liste[4])
     ts[iligne] = float(liste[8])
     fov[iligne] = float(liste[10])
     #trans[iligne] = float(liste[17])
     for ki in range(0,4):
         emis[ki,iligne] = float(liste[12+ki])
         tb[ki,iligne] = float(liste[16+ki])
         tdn[ki,iligne] = float(liste[20+ki])
         tup[ki,iligne] = float(liste[24+ki])
         #trans[ki,iligne] = float(liste[28+ki])
         #tup_ssmis[ki,iligne] = float(liste[28+ki])
         #tdn_ssmis[ki,iligne] = float(liste[37+ki])
         #trans_ssmis[ki,iligne] = float(liste[44+ki])
     iligne=iligne+1

fichier.close()
#for canal in range(0,4):
#    for ii in range (0,size(emis[canal,:])):
#        if (emis[canal,ii] > 1): emis[canal,ii] = NaN
bblat_dec2009 = nonzero(lat >= 65.)  
#bbfov = nonzero(fov[bblat] == 0.)
#ijr = 0
bbjr_dec2009 = nonzero(jjr[bblat_dec2009] == 15.)
lon_zon_dec2009 = lon[bblat_dec2009][bbjr_dec2009]
lat_zon_dec2009 = lat[bblat_dec2009][bbjr_dec2009]
#emisch4 = emis[3,:][bblat][bbjr]
#emisch3 = emis[2,:][bblat][bbjr]
tbch1_dec2009 = tb[0,:][bblat_dec2009][bbjr_dec2009]
tbch2_dec2009 = tb[1,:][bblat_dec2009][bbjr_dec2009]
tbch3_dec2009 = tb[2,:][bblat_dec2009][bbjr_dec2009]
tbch4_dec2009 = tb[3,:][bblat_dec2009][bbjr_dec2009]
#tsurf = ts[bblat][bbjr]    
#tdnch4 = tdn[3,:][bblat][bbjr]
#tdnch3 = tdn[2,:][bblat][bbjr]
#tupch4 = tup[3,:][bblat][bbjr]
#tupch3 = tup[2,:][bblat][bbjr]


# JANUARY2009
imo = 2
fichier=open("/net/argos/data/parvati/lahlod/ARCTIC/AMSUA_EMIS_GLACE_"+str(le_mois[imo])+".DAT",'r')
numlines = 0
for line in fichier: numlines += 1

fichier.close()
fichier=open("/net/argos/data/parvati/lahlod/ARCTIC/AMSUA_EMIS_GLACE_"+str(le_mois[imo])+".DAT",'r')
nbtotal=numlines-1
iligne=0
lat=np.zeros([nbtotal],float)
lon=np.zeros([nbtotal],float)
jjr=np.zeros([nbtotal],float)
zen=np.zeros([nbtotal],float)
fov=np.zeros([nbtotal],float)
ts=np.zeros([nbtotal],float)
emis=np.zeros([4,nbtotal],float)
tb=np.zeros([4,nbtotal],float)
tup=np.zeros([4,nbtotal],float)
tdn=np.zeros([4,nbtotal],float)
#trans=np.zeros([4,nbtotal],float)
while (iligne < nbtotal) :
     line = fichier.readline()
     # exemple : line = "0.22 2.3 5.0 6"
     liste = line.split()
     # exemple : listeCoord ['0.22', '2.3', '5.0', '6'] (liste de chaine de caract?es)
     lat[iligne] = float(liste[1])
     lon[iligne] = float(liste[0])
     jjr[iligne] = float(liste[4])
     ts[iligne] = float(liste[8])
     fov[iligne] = float(liste[10])
     #trans[iligne] = float(liste[17])
     for ki in range(0,4):
         emis[ki,iligne] = float(liste[12+ki])
         tb[ki,iligne] = float(liste[16+ki])
         tdn[ki,iligne] = float(liste[20+ki])
         tup[ki,iligne] = float(liste[24+ki])
         #trans[ki,iligne] = float(liste[28+ki])
         #tup_ssmis[ki,iligne] = float(liste[28+ki])
         #tdn_ssmis[ki,iligne] = float(liste[37+ki])
         #trans_ssmis[ki,iligne] = float(liste[44+ki])
     iligne=iligne+1

fichier.close()
#for canal in range(0,4):
#    for ii in range (0,size(emis[canal,:])):
#        if (emis[canal,ii] > 1): emis[canal,ii] = NaN
bblat_jan2009 = nonzero(lat >= 65.)  
#bbfov = nonzero(fov[bblat] == 0.)
#ijr = 0
bbjr_jan2009 = nonzero(jjr[bblat_jan2009] == 15.)
lon_zon_jan2009 = lon[bblat_jan2009][bbjr_jan2009]
lat_zon_jan2009 = lat[bblat_jan2009][bbjr_jan2009]
#emisch4 = emis[3,:][bblat][bbjr]
#emisch3 = emis[2,:][bblat][bbjr]
tbch1_jan2009 = tb[0,:][bblat_jan2009][bbjr_jan2009]
tbch2_jan2009 = tb[1,:][bblat_jan2009][bbjr_jan2009]
tbch3_jan2009 = tb[2,:][bblat_jan2009][bbjr_jan2009]
tbch4_jan2009 = tb[3,:][bblat_jan2009][bbjr_jan2009]
#tsurf = ts[bblat][bbjr]    
#tdnch4 = tdn[3,:][bblat][bbjr]
#tdnch3 = tdn[2,:][bblat][bbjr]
#tupch4 = tup[3,:][bblat][bbjr]
#tupch3 = tup[2,:][bblat][bbjr]





## test of variance distribution with different spatial resolution #####################################
imo = 0
longitude = lon_zon_nov2009 
latitude = lat_zon_nov2009
z = tbch1_nov2009
z0 = min(z)
z1 = max(z)
delta_xy = np.array([25., 30., 35., 40., 45., 50.])
Lxy = len(delta_xy)
plt.ion()
nber_val = np.zeros([6], float)
for idel in range (0, Lxy):
    dx = delta_xy[idel]
    dy = delta_xy[idel]
    x_ind, y_ind, z_ind, volume = arctic_map.arctic_map_lat50()
    ZGRID, ngrid, z2grid, sigmagrid, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(longitude, latitude, z, z0, z1, dx, dy)
    plt.figure()
    plt.scatter(x_ind, y_ind, c = z_ind, s = volume)
    clevs = np.arange(137., 269, 1.)
    cs = plt.contourf(xgrid_cart,ygrid_cart, zgrid_output[:, :, 0], clevs, cmap=cm.s3pcpn_l_r) 
    cbar = colorbar(cs)
    txt = 'variance - spatial resolution = ' + str(delta_xy[idel]) + 'km'    
    cbar.set_label(txt)
    xlim(-4000., 3000.)
    ylim(-4000., 4000.)
    plt.savefig('/usr/home/lahlod/twice_d/figure_output_ARCTIC/variance_new_grid_spatial_res_'+ str(delta_xy[idel]) + 'km_' + le_mois[imo] + '.png')
########################################################################################################

## new grid parameters for mapping ##
dx=50.
dy=50.
longitude = lon_zon_nov2009
latitude = lat_zon_nov2009
z = tbch1_nov2009
z0 = min(z)
z1 = max(z)
ZGRID, ngrid, z2grid, sigmagrid, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(longitude, latitude, z, z0, z1, dx, dy)
tb_mesh_nov2009 = ZGRID
x_mesh = xvec
y_mesh = yvec
## map parameters for arctic coast limits mapping ##
x_ind, y_ind, z_ind, volume = arctic_map.arctic_map_lat50()
## mapping ##
plt.ion()
plt.figure()
plt.scatter(x_ind, y_ind, c = z_ind, s = volume)
clevs1 = np.arange(0, 30, 1.)
cs = plt.contourf(xgrid_cart,ygrid_cart, ngrid, clevs1, cmap=cm.s3pcpn_l_r) 
cbar = colorbar(cs)
txt = 'number of values per grid - Tb ch1 (16th, november 2009) - AMSU-A'
cbar.set_label(txt)
xlim(-3000., 2500.)
ylim(-3000., 3000.)




## calculation of standard deviation for november in each new_grid cell ##
## 1 ## matrix of new gridded Tb per day ####
x0 = -3000.
x1 = 2500.
dx=25.
xvec = np.arange(x0, x1+dx, dx)
nx = len(xvec)
y0 = -3000.
y1 = 3000.
dy=25.
yvec = np.arange(y0, y1+dy, dy)
ny = len(yvec)
tbch1_mesh_nov2jan009 = np.zeros([ny, nx, 30], float)
tbch2_mesh_jan2009 = np.zeros([ny, nx, 30], float)
tsurf_mesh_jan2009 = np.zeros([ny, nx, 30], float)
for ijr in range (0, 30):
    bbjr_jan2009 = nonzero(jjr[bblat_jan2009] == ijr + 1.)
    print 'date: ' + str(ijr + 1) + ' nov 2009'
    lon_zon_nov2009 = lon[bblat_nov2009][bbjr_nov2009]
    lat_zon_nov2009 = lat[bblat_nov2009][bbjr_nov2009]
    tbch1_nov2009 = tb[0,:][bblat_nov2009][bbjr_nov2009]
    #tbch2_nov2009 = tb[1,:][bblat_nov2009][bbjr_nov2009]
    #tbch3_nov2009 = tb[2,:][bblat_nov2009][bbjr_nov2009]
    #tbch4_nov2009 = tb[3,:][bblat_nov2009][bbjr_nov2009]
    tsurf_nov2009 = ts[bblat_nov2009][bbjr_nov2009] 
    longitude = lon_zon_nov2009
    latitude = lat_zon_nov2009
    z = tbch1_nov2009 # channel 1
    z0 = min(z)
    z1 = max(z)
    ZGRID, ngrid, z2grid, sigmagrid, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(longitude, latitude, z, z0, z1, dx, dy)
    tbch1_mesh_nov2009[:, :, ijr] = ZGRID
    print 'channel 1'
    x_mesh = xvec
    y_mesh = yvec
    z = tbch2_nov2009 # channel 2
    z0 = min(z)
    z1 = max(z)
    ZGRID, ngrid, z2grid, sigmagrid, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(longitude, latitude, z, z0, z1, dx, dy)
    tbch2_mesh_nov2009[:, :, ijr] = ZGRID
    print 'channel 2'
    z = tsurf_nov2009 # surface temperature
    z0 = min(z)
    z1 = max(z)
    ZGRID, ngrid, z2grid, sigmagrid, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(longitude, latitude, z, z0, z1, dx, dy)
    tsurf_mesh_nov2009[:, :, ijr] = ZGRID
    print 'surf temp'



## 2 ## std in each grid cell ####
tbsum_tbch1 = np.zeros([241, 261], float)
tbsum_tbch2 = np.zeros([241, 261], float)
tbsum_tsurf = np.zeros([241, 261], float)
for ix in range (0, 261):
    for iy in range (0, 241):
        bb_value_tbch1 = nonzero(isnan(tbch1_mesh_nov2009[iy, ix, :]) == False)
        bb_value_tbch2 = nonzero(isnan(tbch2_mesh_nov2009[iy, ix, :]) == False)
        bb_value_tsurf = nonzero(isnan(tsurf_mesh_nov2009[iy, ix, :]) == False)
        # channel 1
        if (bb_value_tbch1[0] == np.array([])):
            tbsum_tbch1[iy, ix] = NaN # take out grid cells where no obs in the month
        else:
            tbsum_tbch1[iy, ix] = sum((tbch1_mesh_nov2009[iy, ix, :][bb_value_tbch1] - mean(tbch1_mesh_nov2009[iy, ix, :][bb_value_tbch1])) ** 2)  
        # channel 2      
        if (bb_value_tbch2[0] == np.array([])):
            tbsum_tbch2[iy, ix] = NaN # take out grid cells where no obs in the month
        else:
            tbsum_tbch2[iy, ix] = sum((tbch2_mesh_nov2009[iy, ix, :][bb_value_tbch2] - mean(tbch2_mesh_nov2009[iy, ix, :][bb_value_tbch2])) ** 2)
        # surface temperature
        if (bb_value_tsurf[0] == np.array([])):
            tbsum_tsurf[iy, ix] = NaN # take out grid cells where no obs in the month
        else:
            tbsum_tsurf[iy, ix] = sum((tsurf_mesh_nov2009[iy, ix, :][bb_value_tsurf] - mean(tsurf_mesh_nov2009[iy, ix, :][bb_value_tsurf])) ** 2)



std_tbch1_nov2009 = sqrt((1. / (30. - 1.)) * tbsum_tbch1)
std_tbch2_nov2009 = sqrt((1. / (30. - 1.)) * tbsum_tbch2)
std_tsurf_nov2009 = sqrt((1. / (30. - 1.)) * tbsum_tsurf)

for ix in range (0, 261):
    for iy in range (0, 241):
        if (std_tbch1_nov2009[iy, ix] < 0.):
            std_tbch1_nov2009[iy, ix] == NaN # take out the negative values of std
        if (std_tbch2_nov2009[iy, ix] < 0.):
            std_tbch2_nov2009[iy, ix] == NaN # take out the negative values of std
        if (std_tsurf_nov2009[iy, ix] < 0.):
            std_tsurf_nov2009[iy, ix] == NaN # take out the negative values of std


tbch1_mean_nov2009 = np.zeros([241, 261], float)
tbch2_mean_nov2009 = np.zeros([241, 261], float)
tsurf_mean_nov2009 = np.zeros([241, 261], float)
for ix in range (0, 261):
    for iy in range (0, 241):
        bb_val_tbch1 = nonzero(isnan(tbch1_mesh_nov2009[iy, ix, :]) == False)
        bb_val_tbch2 = nonzero(isnan(tbch2_mesh_nov2009[iy, ix, :]) == False)
        bb_val_tsurf = nonzero(isnan(tsurf_mesh_nov2009[iy, ix, :]) == False)
        tbch1_mean_nov2009[iy, ix] = tbch1_mesh_nov2009[iy, ix, :][bb_val_tbch1].mean()
        tbch2_mean_nov2009[iy, ix] = tbch2_mesh_nov2009[iy, ix, :][bb_val_tbch2].mean()
        tsurf_mean_nov2009[iy, ix] = tsurf_mesh_nov2009[iy, ix, :][bb_val_tsurf].mean()

## study zone ##
## 1 ## monthly mean (temporal) values ####
study_x = np.where((xvec >= -800.) & (xvec <= -350.))[0]
study_y = np.where((yvec >= 950.) & (yvec <= 1300.))[0]
Sx = len(study_x)
Sy = len(study_y)
tbch1_mean_zone_nov2009 = tbch1_mean_nov2009[study_y[0]: study_y[Sy - 1] + 1, study_x[0]: study_x[Sx - 1] + 1]
tbch2_mean_zone_nov2009 = tbch2_mean_nov2009[study_y[0]: study_y[Sy - 1] + 1, study_x[0]: study_x[Sx - 1] + 1]
tsurf_mean_zone_nov2009 = tsurf_mean_nov2009[study_y[0]: study_y[Sy - 1] + 1, study_x[0]: study_x[Sx - 1] + 1]
## 2 ## daily mean (spatial) values ####
tbch1_mean_day_nov2009 = np.zeros([30], float)
tbch2_mean_day_nov2009 = np.zeros([30], float)
tsurf_mean_day_nov2009 = np.zeros([30], float)
for ijr in range (0, 30):
    a = np.reshape(tbch1_mesh_nov2009[:, :, ijr], size(tbch1_mesh_nov2009[:, :, ijr]))
    bba = nonzero(isnan(a) == False)
    moy_a = mean(a[bba])
    tbch1_mean_day_nov2009[ijr] = moy_a
    b = np.reshape(tbch2_mesh_nov2009[:, :, ijr], size(tbch2_mesh_nov2009[:, :, ijr]))
    bbb = nonzero(isnan(b) == False)
    moy_b = mean(b[bbb])
    tbch2_mean_day_nov2009[ijr] = moy_b
    c = np.reshape(tsurf_mesh_nov2009[:, :, ijr], size(tsurf_mesh_nov2009[:, :, ijr]))
    bbc = nonzero(isnan(c) == False)
    moy_c = mean(c[bbc])
    tsurf_mean_day_nov2009[ijr] = moy_c
    anom_tbch1_nov2009[ijr]


plt.figure()
plt.plot(tbch1_mean_day_nov2009, 'b', label = 'Tb ch1')
plt.plot(tbch2_mean_day_nov2009, 'g', label = 'Tb ch2')
legend()
twinx()
plt.plot(tsurf_mean_day_nov2009, 'r', label = 'Tsurf')
legend()


# channel 1
plt.ion()
plt.figure()
plt.scatter(x_ind, y_ind, c = z_ind, s = volume)
clevs1 = np.arange(140., 255., 1.)
cs = plt.contourf(xgrid_cart,ygrid_cart, tbch1_mesh_nov2009[:, :, ijr], clevs1, cmap=cm.s3pcpn_l_r) 
cbar = colorbar(cs)
txt = 'std Tb ch1 (november 2009) - AMSU-A'
cbar.set_label(txt)
xlim(-3000., 2500.)
ylim(-2500., 3500.)

# channel 2
plt.figure()
plt.scatter(x_ind, y_ind, c = z_ind, s = volume)
clevs1 = np.arange(0.8, 39, 1.)
cs = plt.contourf(xgrid_cart,ygrid_cart,std_tbch2_nov2009, clevs1, cmap=cm.s3pcpn_l_r) 
cbar = colorbar(cs)
txt = 'std Tb ch2 (november 2009) - AMSU-A'
cbar.set_label(txt)
xlim(-4000., 3000.)
ylim(-4000., 4000.)

# surface temperature
plt.figure()
plt.scatter(x_ind, y_ind, c = z_ind, s = volume)
clevs1 = np.arange(0., 10., 0.1)
cs = plt.contourf(xgrid_cart,ygrid_cart,std_tsurf_nov2009, clevs1, cmap=cm.s3pcpn_l_r) 
cbar = colorbar(cs)
txt = 'std Tsurf (november 2009) - AMSU-A'
cbar.set_label(txt)
xlim(-4000., 3000.)
ylim(-4000., 4000.)






longitude = lon_zon_nov2009 
latitude = lat_zon_nov2009

delta_xy = np.array([25., 30., 35., 40., 45., 50.])
idel = 0
x0 = -3000.
x1 = 2500.
dx = delta_xy[idel]
xvec = np.arange(x0, x1+dx, dx)
nx = len(xvec)
y0 = -3000.
y1 = 3000.
dy= delta_xy[idel]
yvec = np.arange(y0, y1+dy, dy)
ny = len(yvec)
for ix in range (0, nx):
    for iy in range (0, ny):
        tbch1_moy_nov2009[iy, ix] = tbch1_mesh_nov2009[iy, ix, :].mean
z = tbch1_moy_nov2009
z0 = min(z)
z1 = max(z)
ZGRID, ngrid, z2grid, sigmagrid, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(longitude, latitude, z, z0, z1, dx, dy)
moy_ZGRID = ZGRID[nonzero(isnan(ZGRID) == False)].mean()
good_points = np.zeros([ny, nx], float)
for ix in range (0, nx):
    for iy in range (0, ny):
        if (sigmagrid[iy, ix] > ((1. * moy_ZGRID) / 100.)):
            good_points[iy, ix] = NaN
        else: 
            good_points[iy, ix] = sigmagrid[iy, ix]


plt.figure()
plt.scatter(x_ind, y_ind, c = z_ind, s = volume)
clevs1 = np.arange(143, 255, 1)
cs = plt.contourf(xgrid_cart,ygrid_cart,ZGRID, clevs1, cmap=cm.s3pcpn_l_r) 
cbar = colorbar(cs)
txt = 'best_grid cells: std < 1% of Tbch1 - res' + str(delta_xy[idel]) + 'km (november 2009, AMSU-A)'
cbar.set_label(txt)
xlim(-3000., 2500.)
ylim(-3000., 3000.)










nber_val_res25 = ngrid
idel = 1
dx = delta_xy[idel]
dy = delta_xy[idel]
ZGRID, ngrid, z2grid, sigmagrid, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(longitude, latitude, z, z0, z1, dx, dy)
nber_val_res30 = ngrid
idel = 2
dx = delta_xy[idel]
dy = delta_xy[idel]
ZGRID, ngrid, z2grid, sigmagrid, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(longitude, latitude, z, z0, z1, dx, dy)
nber_val_res35 = ngrid
idel = 3
dx = delta_xy[idel]
dy = delta_xy[idel]
ZGRID, ngrid, z2grid, sigmagrid, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(longitude, latitude, z, z0, z1, dx, dy)
nber_val_res40 = ngrid
idel = 4
dx = delta_xy[idel]
dy = delta_xy[idel]
ZGRID, ngrid, z2grid, sigmagrid, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(longitude, latitude, z, z0, z1, dx, dy)
nber_val_res45 = ngrid
idel = 5
dx = delta_xy[idel]
dy = delta_xy[idel]
ZGRID, ngrid, z2grid, sigmagrid, xvec, yvec, xgrid_cart, ygrid_cart = cartesian_grid_test.new_cartesian_grid(longitude, latitude, z, z0, z1, dx, dy)
nber_val_res50 = ngrid


ngrid_25km_vec = reshape(nber_val_res25, size(nber_val_res25))
ngrid_30km_vec = reshape(nber_val_res30, size(nber_val_res30))
ngrid_35km_vec = reshape(nber_val_res35, size(nber_val_res35))
ngrid_40km_vec = reshape(nber_val_res40, size(nber_val_res40))
ngrid_45km_vec = reshape(nber_val_res45, size(nber_val_res45))
ngrid_50km_vec = reshape(nber_val_res50, size(nber_val_res50))

plt.figure()
hist([ngrid_25km_vec, ngrid_30km_vec, ngrid_35km_vec, ngrid_40km_vec, ngrid_45km_vec, ngrid_50km_vec], histtype = 'bar', label = ['25km', '30km', '35km', '40km', '45km', '50km'])


