#! /usr/bin/env python
# -*- coding: utf-8 -*-

#################################
# Appel des modules necessaires #
#################################
import numpy as np
import matplotlib as mpl
import matplotlib.pyplot as plt
import string
from numpy import *
from mpl_toolkits.basemap import Basemap
from netCDF4 import Dataset
import scipy.optimize
from scipy.sparse import bsr_matrix


###############################
# Lecture des noms des massif #
###############################
nbmassifs=24
fichier = open ('D:\data\safran\listeml_massifs.dat', 'r')
iligne = 0
nom_massif=np.zeros([nbmassifs],object)
while (iligne < nbmassifs) :
    line=fichier.readline()
    liste = line.split(',')
    nom_massif[iligne] = str(liste[1])
    iligne=iligne+1
         

fichier.close()


################################################
# Définition des fonctions cout et incertitude #
################################################
# Fonction cout
def cost(x,xb,BI,y,RI,H):
    '''
    Return J and J' at x
    '''
    C = 2.
    Yx = np.array((x * H).T).flatten()
    Jb = np.dot(np.array(0.5 * (x-xb) * BI),(x-xb))[0]
    Jo = np.dot(np.array(0.5 * (y-Yx) * RI),(y-Yx))[0]
    a = np.zeros([13],float)
    da = np.zeros([13],float)
    a[0] = 0.
    da[0] = C*(-x[1]+0.5*(x[0]+x[2]))
    da[1] = C*(-x[0]+2.5*x[1]-2*x[2]+0.5*x[3])
    a[12] = 0.
    da[11] = C*(0.5*x[9]-2.*x[10]+2.5*x[11]-x[12])
    da[12] = C*(-x[11]+0.5*(x[10]+x[12]))
    for i in range(1,len(x)-1):
        a[i] = (-x[i]+0.5*(x[i-1]+x[i+1]))**2
    for i in range(2,len(x)-2):
        da[i] = C*(0.5*x[i-2]-2*x[i-1]+3*x[i]-2*x[i+1]+0.5*x[i+2])
    Jc = C*sum(a[1:12])
    JcPrime = np.matrix(da)
    d = np.matrix(y - Yx)
    JbPrime = (x-xb) * BI
    JoPrime = - d * RI * H.T
    return Jo+Jb+Jc,np.array(JoPrime+JbPrime+JcPrime)[0]

# Fonction incertitude
def uncertainty(x,xb,BI,y,RI,H):
            # inverse of Hessian
            #A = (I – K H ) B = 2 (J'')-1
            return (BI + (H * RI * H.T)).I


#####################
# Lecture des dates #
#####################
name_month = (['Dec2009','Jan2010','Feb2010','Mar2010','Apr2010','May2010','Jun2010','Jul2010'])
annee = (['09','10'])
list_mois = arange(1,9,1)
list_jour1 = arange(1,32,1)
list_jour2 = arange(1,32,1)
list_jour3 = arange(1,29,1)
list_jour4 = arange(1,32,1)
list_jour5 = arange(1,31,1)
list_jour6 = arange(1,32,1)
list_jour7 = arange(1,31,1)
list_jour8 = arange(1,32,1)
LST_JR = ([list_jour1,list_jour2,list_jour3,list_jour4,list_jour5,list_jour6,list_jour7,list_jour8])
lst_month = np.array([0,31,31+31,31+31+28,31+31+28+31,31+31+28+31+30,31+31+28+31+30+31,31+31+28+31+30+31+30,31+31+28+31+30+31+30+31])
#initialisation (mois de decembre)
jour_an = []
imo = 0
for ijr in range (0,len(LST_JR[imo])):
    nom_mois = '12'
    if (LST_JR[imo][ijr] <= 9):
        nom_jour = '0' + str(LST_JR[imo][ijr])
    else:
        nom_jour = str(LST_JR[imo][ijr])
    jour_an.append(annee[0] + nom_mois + nom_jour)

# mois de janvier a juillet
for imo in range (1,8):
    nom_mois = '0' + str(list_mois[imo]-1)
    for ijr in range (0,len(LST_JR[imo])):
        if (LST_JR[imo][ijr] <= 9):
            nom_jour = '0' + str(LST_JR[imo][ijr])
        else:
            nom_jour = str(LST_JR[imo][ijr])
        jour_an.append(annee[1] + nom_mois + nom_jour)

jour_an = np.array(jour_an)


##########
# 1D-Var #
##########
for imo in range (3,4):
    for imass in range (16,17):
        print 'massif', nom_massif[imass]
        #fichier_analyses = open ('D:/output_Vfinale/analyses/err8_C2_correl7000_tt-fixe/Dec2009-Juill2010/data/sans_AROME/data_analyses_massif_'+nom_massif[imass]+'_'+name_month[imo]+'.txt', 'a')
        ###########################
        # data guess ajuste AROME #
        ###########################
        fichier_arome = open ('D:/output_Vfinale/data_for_1DVar/Dec2009-Juill2010/data_AROME_moyen/data_AROME_massif_'+nom_massif[imass]+'_'+name_month[imo]+'.txt', 'r')
        lines_arome = 0
        for line in fichier_arome: lines_arome += 1
        fichier_arome.close()
        n1 = lines_arome
        fichier_arome = open ('D:/output_Vfinale/data_for_1DVar/Dec2009-Juill2010/data_AROME_moyen/data_AROME_massif_'+nom_massif[imass]+'_'+name_month[imo]+'.txt', 'r')
        iligne = 0
        date_arome = np.zeros([n1],object)
        massif_arome = np.zeros([n1],object)
        alt_arome = np.zeros([n1],float)
        rr_arome = np.zeros([n1],float)
        tt = np.zeros([n1],int)
        rr_guessi = np.zeros([n1],float)
        rr_guessf = np.zeros([n1],float)
        while (iligne < n1) :
                 line = fichier_arome.readline()
                 liste = line.split()
                 date_arome[iligne] = str(liste[0])
                 massif_arome[iligne] = str(liste[1])
                 alt_arome[iligne] = float(liste[2])
                 rr_arome[iligne] = float(liste[3])
                 tt[iligne] = int(liste[4])
                 rr_guessi[iligne] = float(liste[6])
                 rr_guessf[iligne] = float(liste[7])
                 iligne = iligne+1
        fichier_arome.close()
        #####################
        # data Observations #
        #####################
        fichier_obs = open ('D:/output_Vfinale/data_for_1DVar/Dec2009-Juill2010/data_OBS_in_massif/data_obs_in_massif_'+nom_massif[imass]+'_'+name_month[imo]+'.txt', 'r')
        lines_obs = 0
        for line in fichier_obs: lines_obs += 1
        fichier_obs.close()
        n2 = lines_obs
        fichier_obs = open ('D:/output_Vfinale/data_for_1DVar/Dec2009-Juill2010/data_OBS_in_massif/data_obs_in_massif_'+nom_massif[imass]+'_'+name_month[imo]+'.txt', 'r')
        iligne = 0
        date_obs = np.zeros([n2],object)
        massif_obs = np.zeros([n2],object)
        indic_obs = np.zeros([n2],object)
        lon_obs = np.zeros([n2],float)
        lat_obs = np.zeros([n2],float)
        alt_obs = np.zeros([n2],float)
        rr_obs = np.zeros([n2],float)
        while (iligne < n2) :
                 line = fichier_obs.readline()
                 liste = line.split()
                 date_obs[iligne] = str(liste[0])
                 massif_obs[iligne] = str(liste[1])
                 indic_obs[iligne] = str(liste[2])
                 lon_obs[iligne] = float(liste[3])
                 lat_obs[iligne] = float(liste[4])
                 alt_obs[iligne] = float(liste[5])
                 rr_obs[iligne] = float(liste[6])
                 iligne = iligne+1     
        fichier_obs.close()
        xb_alt = arange(300.,4200.,300) #niveaux d altitude
        alt_pt = alt_arome[0] #altitude moyenne AROME dans le massif
        guess_j = np.zeros([len(LST_JR[imo]),13],float)
        analyse_j = np.zeros([len(LST_JR[imo]),13],float)
        for ijr in range (0,len(LST_JR[imo])):
            print 'date:', jour_an[lst_month[imo]:lst_month[imo+1]][ijr]
            ########################## jours ou manque de donnees AROME #######################
            if jour_an[lst_month[imo]:lst_month[imo+1]][ijr] == '100218':
                #guess_j[ijr,0:13] = ([NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN])
                #analyse_j[ijr,0:13] = ([NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN])
                continue
            if jour_an[lst_month[imo]:lst_month[imo+1]][ijr] == '100521':
                #guess_j[ijr,0:13] = ([NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN])
                #analyse_j[ijr,0:13] = ([NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN])
                continue
            if jour_an[lst_month[imo]:lst_month[imo+1]][ijr] == '100622':
                #guess_j[ijr,0:13] = ([NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN])
                #analyse_j[ijr,0:13] = ([NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN])
                continue
            if jour_an[lst_month[imo]:lst_month[imo+1]][ijr] == '100716':
                #guess_j[ijr,0:13] = ([NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN])
                #analyse_j[ijr,0:13] = ([NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN])
                continue
            ###################################################################################
            lst_niv = arange(0,n1+13,13)
            guess = rr_guessi[lst_niv[ijr]:lst_niv[ijr+1]] #guess initial (sans ajustement)
            xb = rr_guessf[lst_niv[ijr]:lst_niv[ijr+1]] #guess final (apres ajustement AROME)
            rain_pt = rr_arome[lst_niv[ijr]:lst_niv[ijr+1]][0] #precip AROME moyenne dans le massif
            day = 0
            day = nonzero(date_obs == jour_an[lst_month[imo]:lst_month[imo+1]][ijr])
            y = rr_obs[day] #vecteur d observations dans le massif
            if len(y) == 0: #cas ou il n y a pas d obs dans le massif
                x = xb
                figure() 
                plot(guess,xb_alt,'b--',label="type de temps 6")
                plot(rain_pt,alt_pt,'mo',label="data AROME moyen")
                plot(xb,xb_alt,'b',label="ebauche")
                plot(x,xb_alt,'r',label="analyse")
                legend(loc='best')
                yticks(xb_alt,xb_alt)
                grid()
                xlabel('precipitations (mm)')
                ylabel('altitude (m)')
                title(name_month[imo])
                savefig('D:/output_Vfinale/analyses/err8_C2_correl7000_tt-fixe/Dec2009-Juill2010/graphes/profil_massif_'+nom_massif[imass]+'_'+jour_an[lst_month[imo]:lst_month[imo+1]][ijr]+'.png')
########### cas ou il y a des observations dans le massif
            else: #cas ou il y a des observations dans le massif
                y_alt = alt_obs[day] #altitudes des obs correspondantes dans le massif
                data_zero = 0
                data_zero = nonzero(y != 0.)
                if len(y[data_zero]) == 0: #cas ou il y a que des observations nulles dans le massif
                    x = np.zeros([13],float)
                    figure()
                    plot(y,y_alt,'ko',label="observations")
                    plot(guess,xb_alt,'b--',label="type de temps 6")
                    plot(rain_pt,alt_pt,'mo',label="data AROME moyen")
                    plot(xb,xb_alt,'b',label="ebauche")
                    plot(x,xb_alt,'r',label="analyse")
                    legend(loc='best')
                    yticks(xb_alt,xb_alt)
                    grid()
                    xlabel('precipitations (mm)')
                    ylabel('altitude (m)')
                    title(name_month[imo])
                    savefig('D:/output_Vfinale/analyses/err8_C2_correl7000_tt-fixe/Dec2009-Juill2010/graphes/profil_massif_'+nom_massif[imass]+'_'+jour_an[lst_month[imo]:lst_month[imo+1]][ijr]+'.png')
                else: #cas ou il y a des observations nulles et non nulles dans le massif
                    print 'parametres OK'
                    #################################
                    # Asimilation variationnelle 1D #
                    #################################
                    Da_mat = np.zeros([13,13],float) #matrice de covariance d'erreurs d ebauche 
                    for i in range(0,13):
                        for j in range(0,13):
                            Da_mat[i,j] = abs(xb_alt[i]-xb_alt[j])
                    B0 = np.eye(len(xb))
                    for i in range(0,13):
                        for j in range(0,13):
                            if (i == j):
                                B0[i,j]= 8.**2
                            else:
                                B0[i,j] = (exp(-(Da_mat[i,j]*Da_mat[i,j])/(7000*7000))-0.1)*8.*8.
                    B = np.matrix(B0)
                    BI = B.I
                    R0 = np.eye(len(y)) #matrice de covariance d'erreurs d observations 
                    for i in range(0,len(y)):
                        for j in range(0,len(y)):
                            if (i == j):
                                R0[i,j]= 5.**2
                            else:
                                R0[i,j]= 0.
                    R = np.matrix(R0)
                    RI = R.I
                    HO = np.zeros([len(xb),len(y)],float) #operateur observation 
                    for i in range(0,len(y)):
                        zon = 0
                        zon = nonzero(abs(xb_alt - y_alt[i]) <= 300.)
                        if (y_alt[i] < xb_alt[0]): #cas ou : altitude_obs < 300m
                            HO[0,i] = 1.
                            if jour_an[lst_month[imo]:lst_month[imo+1]][ijr] == '091230':
                                HO[0,i] = 0.5
                            if jour_an[lst_month[imo]:lst_month[imo+1]][ijr] == '091231':
                                HO[0,i] = 0.5    
                        else: #cas ou : altitude_obs > 300m
                            d1 = abs(y_alt[i] - xb_alt[zon][0])
                            c1 = 1-(d1/300.)
                            d2 = abs(y_alt[i] - xb_alt[zon][1])
                            c2 = 1-(d2/300.)
                            for j in range (0,13):
                                if (j == zon[0][0]):
                                    HO[j,i] = c1 
                                if (j == zon[0][1]):
                                    HO[j,i] = c2            
                    H=np.matrix(HO)
                    x = np.zeros([len(xb)],float) #initialisation du vecteur d analyse
                    retval = scipy.optimize.fmin_l_bfgs_b(cost,x,args=(xb,BI,y,RI,H),factr=1000000000.0,pgtol=1e-15) #minimisation - appel de la fonction cout
                    x = retval[0] 
                    print 'optimisation OK'
                    for ind in range (0,len(x)):
                        if (x[ind] < 0.):
                            x[ind] = 0.
                    Cpost = uncertainty(x,xb,BI,y,RI,H) #erreurs - Incertitude d analyse, d ebauche et d observations
                    yCpost = np.ones([len(xb)])
                    yB = np.ones([len(xb)])
                    yR = np.ones([len(y)])
                    for i in range(0,len(xb)):
                        for j in range(0,len(xb)):
                            if (i == j):
                                yCpost[i]= sqrt(Cpost[i,j])
                                yB[i]=sqrt(B[i,j]) #incertitude de l ebauche
                    for i in range(0,len(y)):
                        for j in range(0,len(y)):
                            if (i == j):
                                yR[i]=sqrt(R[i,j]) #incertitude des observations
            #---------------------------------------------------------------------------------------
            # Tracé des profils
            #---------------------------------------------------------------------------------------
                    figure()
                    plot(y,y_alt,'ko',label="observations")
                    plot(guess,xb_alt,'b--',label="type de temps 6")
                    plot(rain_pt,alt_pt,'mo',label="data AROME moyen")
                    plot(xb,xb_alt,'b',label="ebauche")
                    plot(x,xb_alt,'r',label="analyse")
                    legend(loc='best')
                    yticks(xb_alt,xb_alt)
                    grid()
                    xlabel('precipitations (mm)')
                    ylabel('altitude (m)')
                    title(name_month[imo])
                    savefig('D:/output_Vfinale/analyses/err8_C2_correl7000_tt-fixe/Dec2009-Juill2010/graphes/profil_massif_'+nom_massif[imass]+'_'+jour_an[lst_month[imo]:lst_month[imo+1]][ijr]+'.png')
    #---------------------------------------------------------------------------------------
    # Stockage des analyses dans un fichier txt # yB, yR, yCpost, x par jour et par massif
    #---------------------------------------------------------------------------------------
                for ialt in range (0,13):
                    fichier_analyses.write(('%(date)6s   %(massif)10s   %(niv_alts)5.1f   %(guess)5.3f   %(analyse)5.3f   %(alt_obs)5.1f   %(obs_ini)5.3f \n' % {
                        'date':jour_an[lst_month[imo]:lst_month[imo+1]][ijr],
                        'massif':nom_massif[imass],
                        'niv_alts':xb_alt[ialt],
                        #'guess_ini':guess[ialt],
                        'guess':xb[ialt],
                        'analyse':x[ialt],
                        'alt_obs':y_alt.mean(),
                        'obs_ini':y.mean()
                        }))
        fichier_analyses.close()
