#! /usr/bin/env python
# -*- coding: utf-8 -*-

#################################
# Appel des modules necessaires #
#################################
import numpy as np
import matplotlib as mpl
import matplotlib.pyplot as plt
import string
from numpy import *
from mpl_toolkits.basemap import Basemap
from netCDF4 import Dataset
import scipy.optimize
from scipy.sparse import bsr_matrix
from mpl_toolkits.axes_grid1 import host_subplot


##########################
# Lecture des nom_massif #
##########################
nbmassifs=24
fichier = open ('D:\data\safran\listeml_massifs.dat', 'r')
iligne = 0
nom_massif=np.zeros([nbmassifs],object)
while (iligne < nbmassifs) :
    line=fichier.readline()
    liste = line.split(',')
    nom_massif[iligne] = str(liste[1])
    iligne=iligne+1
         

fichier.close()


#################
# Lecture dates #
#################
name_month = (['Dec2009','Jan2010','Feb2010','Mar2010','Apr2010','May2010','Jun2010','Jul2010'])
annee = (['09','10'])
list_mois = arange(1,9,1)
list_jour1 = arange(1,32,1)
list_jour2 = arange(1,32,1)
list_jour3 = arange(1,29,1)
list_jour4 = arange(1,32,1)
list_jour5 = arange(1,31,1)
list_jour6 = arange(1,32,1)
list_jour7 = arange(1,31,1)
list_jour8 = arange(1,32,1)
LST_JR = ([list_jour1,list_jour2,list_jour3,list_jour4,list_jour5,list_jour6,list_jour7,list_jour8])
lst_month = np.array([0,31,31+31,31+31+28,31+31+28+31,31+31+28+31+30,31+31+28+31+30+31,31+31+28+31+30+31+30,31+31+28+31+30+31+30+31])
        ####################################
        #initialisation (mois de decembre) #
        ####################################
jour_an = []
imo = 0
for ijr in range (0,len(LST_JR[imo])):
    nom_mois = '12'
    if (LST_JR[imo][ijr] <= 9):
        nom_jour = '0' + str(LST_JR[imo][ijr])
    else:
        nom_jour = str(LST_JR[imo][ijr])
    jour_an.append(annee[0] + nom_mois + nom_jour)

        #############################
        # mois de janvier a juillet #
        #############################
for imo in range (1,8):
    nom_mois = '0' + str(list_mois[imo]-1)
    for ijr in range (0,len(LST_JR[imo])):
        if (LST_JR[imo][ijr] <= 9):
            nom_jour = '0' + str(LST_JR[imo][ijr])
        else:
            nom_jour = str(LST_JR[imo][ijr])
        jour_an.append(annee[1] + nom_mois + nom_jour)

jour_an = np.array(jour_an)


##########################
# Lecture massifs SAFRAN #
##########################
num_mass = (['01','02','03','04','05','06','07','08','09','10','11','12','13','14','15','16','17','18','19','31','25','29','30','51'])
cd D:/python/assimilation_donnees/assimilation_1D
import funct_analyses_safran
N,DN,A,DA,I,DI = funct_analyses_safran.analyses_safran()
lst_niv = arange(0,416,13)
niv_alt = arange(300.,4200.,300)


########################
# Correl obs//analyses #
########################
obs = np.zeros([8,24,16],float)
altitudeobs = np.zeros([8,24,16],float)
indicatifobs = np.zeros([8,24,16],object)
longitudeobs = np.zeros([8,24,16],float)
latitudeobs = np.zeros([8,24,16],float)
estim_g2 = np.zeros([8,24,16],float)
estim_a2 = np.zeros([8,24,16],float)
estim_S = np.zeros([8,24,16],float)
nbL = np.zeros([8,24],int)
for imo in range (0,8):
    Robs = np.zeros([24,16],float)
    Altobs = np.zeros([24,16],float)
    indmass = np.zeros([24,16],object)
    longi = np.zeros([24,16],float)
    lati = np.zeros([24,16],float)
    guess_2 = np.zeros([24,16],float)
    ana_2 = np.zeros([24,16],float)
    ana_S = np.zeros([24,16],float)
    L = np.zeros([24],float)
    for imass in range (0,24):
        ########################
        # Lecture data analyse #
        ########################
        fichier2 = open ('D:/output_Vfinale/analyses/err8_C2_correl7000_tt-fixe/Dec2009-Juill2010/data/avec_AROME/data_analyse_massif_'+nom_massif[imass]+'_'+name_month[imo]+'.txt', 'r')
        lines2 = 0
        for line in fichier2: lines2 += 1
        fichier2.close()
        n2 = lines2
        fichier2 = open ('D:/output_Vfinale/analyses/err8_C2_correl7000_tt-fixe/Dec2009-Juill2010/data/avec_AROME/data_analyse_massif_'+nom_massif[imass]+'_'+name_month[imo]+'.txt', 'r')
        iligne = 0
        date2 = np.zeros([n2],object)
        massif2 = np.zeros([n2],object)
        guess2 = np.zeros([n2],float)
        analyse2 = np.zeros([n2],float)
        while (iligne < n2) :
            line = fichier2.readline()
            liste = line.split()
            date2[iligne] = str(liste[0])
            massif2[iligne] = str(liste[1])
            guess2[iligne] = float(liste[4])
            analyse2[iligne] = float(liste[5])
            iligne = iligne+1     
        fichier2.close()
        #############################
        # Lecture data observations #
        #############################
        fichier_obs = open ('D:/output_Vfinale/data_for_1DVar/Dec2009-Juill2010/data_OBS_in_massif/data_obs_in_massif_'+nom_massif[imass]+'_'+name_month[imo]+'.txt', 'r')
        lines_obs = 0
        for line in fichier_obs: lines_obs += 1
        fichier_obs.close()
        no = lines_obs
        fichier_obs = open ('D:/output_Vfinale/data_for_1DVar/Dec2009-Juill2010/data_OBS_in_massif/data_obs_in_massif_'+nom_massif[imass]+'_'+name_month[imo]+'.txt', 'r')
        iligne = 0
        date_obs = np.zeros([no],object)
        massif_obs = np.zeros([no],object)
        indic_obs = np.zeros([no],object)
        lon_obs = np.zeros([no],float)
        lat_obs = np.zeros([no],float)
        alt_obs = np.zeros([no],float)
        rr_obs = np.zeros([no],float)
        while (iligne < no) :
            line = fichier_obs.readline()
            liste = line.split()
            date_obs[iligne] = str(liste[0])
            massif_obs[iligne] = str(liste[1])
            indic_obs[iligne] = str(liste[2])
            lon_obs[iligne] = float(liste[3])
            lat_obs[iligne] = float(liste[4])
            alt_obs[iligne] = float(liste[5])
            rr_obs[iligne] = float(liste[6])
            iligne = iligne+1     
        fichier_obs.close()
        day31 = 0
        day31 = nonzero(date_obs == jour_an[lst_month[imo]:lst_month[imo+1]][len(LST_JR[imo])-1])
        indic_mass = indic_obs[day31]
        indmass[imass,0:len(indic_obs[day31])] = indic_obs[day31]
        longi[imass,0:len(indic_obs[day31])] = lon_obs[day31]
        lati[imass,0:len(indic_obs[day31])] = lat_obs[day31]
        L[imass] = len(indic_mass)
        ###############################
        # Lecture data analyse SAFRAN #
        ###############################
        fichier_saf = open ('D:/output_Vfinale/data_safran/analyses_safran_massif_'+num_mass[imass]+'_'+name_month[imo]+'.txt', 'r')
        lines_saf = 0
        for line in fichier_saf: lines_saf += 1
        fichier_saf.close()
        ns = lines_saf
        fichier_saf = open ('D:/output_Vfinale/data_safran/analyses_safran_massif_'+num_mass[imass]+'_'+name_month[imo]+'.txt', 'r')
        iligne = 0
        date_saf = np.zeros([ns],object)
        massif_saf = np.zeros([ns],object)
        nom_mass = np.zeros([ns],object)
        expo_saf = np.zeros([ns],object)
        niv_saf = np.zeros([ns],float)
        analyse_saf = np.zeros([ns],float)
        while (iligne < ns) :
            line = fichier_saf.readline()
            liste = line.split()
            date_saf[iligne] = str(liste[0])
            massif_saf[iligne] = str(liste[1])
            nom_mass[iligne] = str(liste[2])
            expo_saf[iligne] = str(liste[3])
            niv_saf[iligne] = float(liste[4])
            analyse_saf[iligne] = float(liste[5])
            iligne = iligne+1     
        fichier_saf.close()
        #########################################################
        # Calcul correl (precips observees // precips estimees) #
        #########################################################
        print 'massif:', nom_massif[imass]
        POBS = np.zeros([len(indic_mass)],float)
        AOBS = np.zeros([len(indic_mass)],float)
        G2 = np.zeros([len(indic_mass)],float)
        A2 = np.zeros([len(indic_mass)],float)
        AS = np.zeros([len(indic_mass)],float)
        for jj in range (0,len(indic_mass)):
            Pobs = np.zeros([len(LST_JR[imo])],float)
            Aobs = np.zeros([len(LST_JR[imo])],float)
            g2 = np.zeros([len(LST_JR[imo])],float)
            a2 = np.zeros([len(LST_JR[imo])],float)
            aS = np.zeros([len(LST_JR[imo])],float)
            for ijr in range (0,len(LST_JR[imo])):
                print 'date:',jour_an[lst_month[imo]:lst_month[imo+1]][ijr]
                ################
                # OBSERVATIONS #
                ################
                day = 0
                day = nonzero(date_obs == jour_an[lst_month[imo]:lst_month[imo+1]][ijr])
                day2 = 0
                day2 = nonzero(date2 == jour_an[lst_month[imo]:lst_month[imo+1]][ijr])
                bb = nonzero(indic_obs[day] == indic_mass[jj])
                ######################## Sortir jours manquant AROME ##############
                if jour_an[lst_month[imo]:lst_month[imo+1]][ijr] == '100218':
                    Pobs[ijr] = NaN
                    Aobs[ijr] = NaN
                    g2[ijr] = NaN
                    a2[ijr] = NaN
                    aS[ijr] = NaN
                    continue
                if jour_an[lst_month[imo]:lst_month[imo+1]][ijr] == '100521':
                    Pobs[ijr] = NaN
                    Aobs[ijr] = NaN
                    g2[ijr] = NaN
                    a2[ijr] = NaN
                    aS[ijr] = NaN
                    continue
                if jour_an[lst_month[imo]:lst_month[imo+1]][ijr] == '100622':
                    Pobs[ijr] = NaN
                    Aobs[ijr] = NaN
                    g2[ijr] = NaN
                    a2[ijr] = NaN
                    aS[ijr] = NaN
                    continue
                if jour_an[lst_month[imo]:lst_month[imo+1]][ijr] == '100716':
                    Pobs[ijr] = NaN
                    Aobs[ijr] = NaN
                    g2[ijr] = NaN
                    a2[ijr] = NaN
                    aS[ijr] = NaN
                    continue
                if shape(bb)[1] == 0:
                    Pobs[ijr] = NaN
                    Aobs[ijr] = NaN
                    a1[ijr] = NaN
                    a2[ijr] = NaN
                    aS[ijr] = NaN
                ###################################################################
                else:
                    print 'station:', indic_obs[day][bb]
                    Pobs[ijr] = rr_obs[day][bb][0]
                    Aobs[ijr] = alt_obs[day][bb][0]
                    #########
                    # GUESS #
                    #########
                    GUESS2 = guess2[day2]
                    ############
                    # ANALYSES #
                    ############
                    ANALYSE2 = analyse2[day2]
                    ###################
                    # ANALYSES SAFRAN #
                    ###################
                    day_saf = 0
                    day_saf = nonzero((date_saf == jour_an[lst_month[imo]:lst_month[imo+1]][ijr]) & (expo_saf == 'Plat'))
                    SAFRAN = analyse_saf[day_saf]
                    alti_saf = np.array(DA[imass])
                    ##########
                    # correl #
                    ##########
                    I = 0
                    I = nonzero(abs(Aobs[ijr]-niv_alt) < 300.)
                    if (shape(I)[1] < 2):
                        Pobs[ijr] = NaN
                        Aobs[ijr] = NaN
                        g1[ijr] = NaN
                        g2[ijr] = NaN
                        a1[ijr] = NaN
                        a2[ijr] = NaN
                    else:
                        d1 = abs(niv_alt[I][0] - Aobs[ijr])
                        d2 = abs(niv_alt[I][1] - Aobs[ijr])
                        g2[ijr] = ((d1 * GUESS2[I][1]) + (d2 * GUESS2[I][0])) / (d1 + d2)
                        a2[ijr] = ((d1 * ANALYSE2[I][1]) + (d2 * ANALYSE2[I][0])) / (d1 + d2)
                    J = 0
                    J = nonzero(abs(Aobs[ijr] - alti_saf) < 300.)
                    if (shape(J)[1] < 2):
                        aS[ijr] = NaN
                    else:
                        dS1 = abs(alti_saf[J][0] - Aobs[ijr])
                        dS2 = abs(alti_saf[J][1] - Aobs[ijr])
                        aS[ijr] = ((dS1 * SAFRAN[J][0]) + (dS2 * SAFRAN[J][1])) / (dS1 + dS2)
            data = 0
            data = nonzero((isnan(Pobs) == False) & (isnan(g2) == False) & (isnan(a2) == False) & (isnan(aS) == False))
            POBS[jj] = Pobs[data].mean()
            AOBS[jj] = Aobs[0]
            ## moyennes sur chaque mois ##
            G2[jj] = g2[data].mean()
            A2[jj] = a2[data].mean()
            AS[jj] = aS[data].mean()
        Robs[imass,0:len(indic_mass)] = POBS[0:len(indic_mass)]
        Altobs[imass,0:len(indic_mass)] = AOBS[0:len(indic_mass)]
        guess_2[imass,0:len(indic_mass)] = G2[0:len(indic_mass)]
        ana_2[imass,0:len(indic_mass)] = A2[0:len(indic_mass)]
        ana_S[imass,0:len(indic_mass)] = AS[0:len(indic_mass)]
    obs[imo,0:24,0:16] = Robs[0:24,:]
    altitudeobs[imo,0:24,0:16] = Altobs[0:24,:]
    indicatifobs[imo,0:24,0:16] = indmass[0:24,:]
    longitudeobs[imo,0:24,0:16] = longi[0:24,:]
    latitudeobs[imo,0:24,0:16] = lati[0:24,:]
    estim_g2[imo,0:24,0:16] = guess_2[0:24,:]
    estim_a2[imo,0:24,0:16] = ana_2[0:24,:]
    estim_S[imo,0:24,0:16] = ana_S[0:24,:]
    nbL[imo,0:24] = L[0:24]


########
# Plot #
########
MM = np.zeros([8],float)
for imo in range (0,8):
    M = np.zeros([24],float)
    figure()
    plot(obs[imo,0,:],estim_a2[imo,0,:],'bx',label='1D_Var')
    M[0] = max(estim_a2[imo,0,:])
    plot(obs[imo,0,:],estim_S[imo,0,:],'rx',label='SAFRAN')
    for imass in range(1,24):
        M[imass] = max(estim_a2[imo,imass,:])
        plot(obs[imo,imass,:],estim_a2[imo,imass,:],'bx')
        plot(obs[imo,imass,:],estim_S[imo,imass,:],'r+')
    xlabel('Precipitations observees (mm)')
    ylabel('Precipitations analysees (mm)')
    legend(loc='best')
    grid()
    MM[imo] = max(M)
    x=arange(0,MM[imo],1)
    plot(x,'k')
    title(name_month[imo])
    savefig('D:/output_Vfinale/stats/err8_C2_correl7000_tt-fixe/Dec2009-Juill2010/graphes/avec_AROME/correl_avec_AROME-SAFRAN/correl_'+name_month[imo]+'.jpg')
    

########################
# Stockage data correl #
########################
for imo in range (0,8):
    data = open ('D:/output_Vfinale/stats/err8_C2_correl7000_tt-fixe/Dec2009-Juill2010/data/avec_AROME/data_correl/correl_'+name_month[imo]+'.txt', 'a')
    for imass in range (0,24):
        for ii in range (0,nbL[imo,imass]):
            data.write(('%(massif)10s   %(nom_sta)7s   %(lon_sta)4.2f   %(lat_sta)4.2f   %(alt_sta)5.1f   %(obs)5.3f   %(estim_g2)5.3f    %(estim_a2)5.3f   %(estim_aS)5.3f \n' % {
                                            'massif':nom_massif[imass],
                                            'nom_sta':indicatifobs[imo,imass,ii],
                                            'lon_sta':longitudeobs[imo,imass,ii],
                                            'lat_sta':latitudeobs[imo,imass,ii],
                                            'alt_sta':altitudeobs[imo,imass,ii],
                                            'obs':obs[imo,imass,ii],
                                            'estim_g2':estim_g2[imo,imass,ii],
                                            'estim_a2':estim_a2[imo,imass,ii],
                                            'estim_aS':estim_S[imo,imass,ii],
                                            }))
    data.close()


###################################################################
# Lecture data correl - calcul de la correlation pour chaque mois #
###################################################################
#corr1 = np.zeros([8],float)
#corr2 = np.zeros([8],float)
#Moy_obs = np.zeros([8],float)
#Moy_1 = np.zeros([8],float)
#Moy_2 = np.zeros([8],float)
for imo in range (0,8):
    fichier = open ('D:/output_Vfinale/stats/err8_C2_correl7000_tt-fixe/Dec2009-Juill2010/data/data_correl_avec_AROME-sans_AROME/correl_'+name_month[imo]+'.txt', 'r')
    lines = 0
    for line in fichier: lines += 1
    fichier.close()
    n = lines
    fichier = open ('D:/output_Vfinale/stats/err8_C2_correl7000_tt-fixe/Dec2009-Juill2010/data/data_correl_avec_AROME-sans_AROME/correl_'+name_month[imo]+'.txt', 'r')
    iligne = 0
    massif = np.zeros([n],object)
    indicatif = np.zeros([n],object)
    longit = np.zeros([n],float)
    latit = np.zeros([n],float)
    altit = np.zeros([n],float)
    p_observe = np.zeros([n],float)
    p_estime_a1 = np.zeros([n],float)
    p_estime_a2 = np.zeros([n],float)
    while (iligne < n):
        line = fichier.readline()
        liste = line.split()
        massif[iligne] = str(liste[0])
        indicatif[iligne] = str(liste[1])
        longit[iligne] = float(liste[2])
        latit[iligne] = float(liste[3])
        altit[iligne] = float(liste[4])
        p_observe[iligne] = float(liste[5])
        p_estime_a1[iligne] = float(liste[7])
        p_estime_a2[iligne] = float(liste[9])
        iligne = iligne+1     
    fichier.close()
    q = nonzero(isnan(p_observe) == False)
    figure()
    plot(p_observe[q],p_estime_a1[q],'r+',label='avec AROME')
    plot(p_observe[q],p_estime_a2[q],'bx',label='sans AROME')
    Mo = max(p_observe[q])
    M1 = max(p_estime_a1[q])
    M2 = max(p_estime_a2[q])
    MM = max(Mo,M1,M2)
    xlabel('Precipitations observees (mm)')
    ylabel('Precipitations analysees (mm)')
    legend(loc='best')
    grid()
    x=arange(0,MM,1)
    plot(x,'k')
    title(name_month[imo])
    savefig('D:/output_Vfinale/stats/err8_C2_correl7000_tt-fixe/Dec2009-Juill2010/graphes/correl_avec_sans_AROME/compar_obs_estim_avec_sans_arome_'+name_month[imo]+'bis.png')    
    #Moy_obs[imo] = p_observe[q].mean()
    #Moy_1[imo] = p_estime_a1[q].mean()
    #Moy_2[imo] = p_estime_a2[q].mean()
    #corr1[imo] = corrcoef(p_observe[q],p_estime_a1[q])[0,1]
    #corr2[imo] = corrcoef(p_observe[q],p_estime_a2[q])[0,1]


####################
# Plot data correl #
####################
x=arange(1,9,1)
figure()
plot(x,corr1,'m',label='avec AROME')
plot(x,corr2,'c',label='sans AROME')
xticks(x,name_month,rotation=30)
ylabel('correlation')
legend(loc='best')
grid()
    






