#! /usr/bin/env python
# -*- coding: utf-8 -*-

#################################
# Appel des modules necessaires #
#################################
import numpy as np
import matplotlib as mpl
import matplotlib.pyplot as plt
import string
from numpy import *
from mpl_toolkits.basemap import Basemap
from netCDF4 import Dataset
import scipy.optimize
from scipy.sparse import bsr_matrix
import collections


################################
# Lecture des noms des massifs #
################################
nbmassifs=24
fichier = open ('D:\data\safran\listeml_massifs.dat', 'r')
iligne = 0
nom_massif=np.zeros([nbmassifs],object)
while (iligne < nbmassifs) :
    line=fichier.readline()
    liste = line.split(',')
    nom_massif[iligne] = str(liste[1])
    iligne=iligne+1
         

fichier.close()



################################################################
# Lecture des niveaux d altitude des profils d analyses SAFRAN #
################################################################
cd D:/python/assimilation_donnees/assimilation_1D
import funct_analyses_safran
N,DN,A,DA,I,DI = funct_analyses_safran.analyses_safran()
lst_expo = (['0','1','3','5','7','4','6'])
expo = (['Plat','N','E','S','W','SE','SW'])
lst_mass = (['01','02','03','04','05','06','07',
             '08','09','10','11','12','13','14',
             '15','16','17','18','19','31','25',
             '29','30','51'])


################################################
# Lecture des dates (de dec 2009 a juill 2010) #
################################################
annee = (['09','10'])
list_mois = arange(1,9,1)
list_jour1 = arange(1,32,1)
list_jour2 = arange(1,32,1)
list_jour3 = arange(1,29,1)
list_jour4 = arange(1,32,1)
list_jour5 = arange(1,31,1)
list_jour6 = arange(1,32,1)
list_jour7 = arange(1,31,1)
list_jour8 = arange(1,32,1)
LST_JR = ([list_jour1,list_jour2,list_jour3,list_jour4,list_jour5,list_jour6,list_jour7,list_jour8])
#initialisation (mois de decembre)
jour_an = []
imo = 0
for ijr in range (0,len(LST_JR[imo])):
    nom_mois = '12'
    if (LST_JR[imo][ijr] <= 9):
        nom_jour = '0' + str(LST_JR[imo][ijr])
    else:
        nom_jour = str(LST_JR[imo][ijr])
    jour_an.append(annee[0] + nom_mois + nom_jour)

# mois de janvier a juillet
for imo in range (1,8):
    nom_mois = '0' + str(list_mois[imo]-1)
    for ijr in range (0,len(LST_JR[imo])):
        if (LST_JR[imo][ijr] <= 9):
            nom_jour = '0' + str(LST_JR[imo][ijr])
        else:
            nom_jour = str(LST_JR[imo][ijr])
        jour_an.append(annee[1] + nom_mois + nom_jour)

jour_an = np.array(jour_an)

###############################
# Lecture des analyses SAFRAN #
###############################
for imass in range (0,24): #boucle sur les massifs
    print 'nom_massif',nom_massif[imass]
    rain24h = np.zeros([7,len(DN[imass]),243])
    for iex in range (0,7): #boucle sur les expositions
        rr = np.zeros([len(DN[imass]),243],float)
        for iniv in range (0,len(DN[imass])): #boucle sur les niveaux d altitude
            fichier_safran = open ('D:/data/safran/analyses_SAFRAN/met_laura_'+lst_mass[imass]+DN[imass][iniv]+lst_expo[iex], 'r')
            lines = 0
            for line in fichier_safran: lines += 1
            fichier_safran.close()
            n = lines
            fichier_safran = open ('D:/data/safran/analyses_SAFRAN/met_laura_'+lst_mass[imass]+DN[imass][iniv]+lst_expo[iex], 'r')
            iligne = 0
            date = np.zeros([n-1],object)
            hour = np.zeros([n-1],object)
            rain = np.zeros([n-1],float)
            line = fichier_safran.readlines()[1:] #ne pas lire la premiere ligne
            while (iligne < n-1) :
                liste = line[iligne].split()
                date[iligne] = str(liste[1])
                hour[iligne] = str(liste[2])
                rain[iligne] = float(liste[6])
                iligne = iligne+1
            fichier_safran.close()
            date = date[1:n]
            hour = hour[1:n]
            rain = rain[1:n]
            r = np.zeros([243],float)
            lst_hour = arange(0,n-1,24)
            for ijr in range (0,243):
                #rain[lst_hour[ijr]:lst_hour[ijr+1]]
                r[ijr] = rain[lst_hour[ijr]:lst_hour[ijr+1]].sum()
            rr[iniv,0:243] = r[0:243]
        rain24h[iex,0:len(DN[imass]),0:243] = rr[0:len(DN[imass]),0:243]
    print 'ok'
    #############################################################################
    # Stockage des profils d analyse SAFRAN - un fichier par mois et par massif #
    #############################################################################
    for imo in range (0,8): #boucle sur les mois de la periode d etude
        name_month = (['Dec2009','Jan2010','Feb2010','Mar2010','Apr2010','May2010','Jun2010','Jul2010'])
        lst_month = np.array([0,31,31+31,31+31+28,31+31+28+31,31+31+28+31+30,31+31+28+31+30+31,31+31+28+31+30+31+30,31+31+28+31+30+31+30+31])
        fichier_datasaf = open ('D:/output_Vfinale/data_safran/analyses_safran_massif_'+lst_mass[imass]+'_'+name_month[imo]+'.txt', 'a')
        for ijr in range(0,len(LST_JR[imo])): #boucle sur les jours de chaque mois
            for iex in range(0,7): #boucle sur les expositions
                for iniv in range(0,len(DN[imass])): #boucle sur les niveaux d altitude
                    print 'ok'
                    fichier_datasaf.write(('%(date)6s   %(massif)10s   %(nom_massif)10s   %(expo)4s   %(niv_alti)5.1f   %(rr_safran)5.3f  \n' % {
                                        'date':np.array(jour_an)[lst_month[imo]:lst_month[imo+1]][ijr],
                                        'massif':lst_mass[imass],
                                        'nom_massif':nom_massif[imass],
                                        'expo':expo[iex],
                                        'niv_alti':DA[imass][iniv],
                                        'rr_safran':rain24h[iex,iniv,lst_month[imo]:lst_month[imo+1]][ijr]
                                        }))
        fichier_datasaf.close()


#################################
# Plots profils analyses SAFRAN #
#################################
lst_month = np.array([0,31,31+31,31+31+28,31+31+28+31,31+31+28+31+30,31+31+28+31+30+31,31+31+28+31+30+31+30,31+31+28+31+30+31+30+31])
name_month = (['Dec2009','Jan2010','Feb2010','Mar2010','Apr2010','May2010','Jun2010','Jul2010'])
col = (['b','r','g','c','m','k','y'])
imo = 7
for imass in range (13,14): 
    fichier_safran = open ('D:/output_Vfinale/data_safran/analyses_safran_massif_'+lst_mass[imass]+'_'+name_month[imo]+'.txt', 'r')
    lines_safran = 0
    for line in fichier_safran: lines_safran += 1
    fichier_safran.close()
    n2 = lines_safran
    fichier_safran = open ('D:/output_Vfinale/data_safran/analyses_safran_massif_'+lst_mass[imass]+'_'+name_month[imo]+'.txt', 'r')
    iligne = 0
    date_saf = np.zeros([n2],object)
    ind_mass_saf = np.zeros([n2],object)
    mass_saf = np.zeros([n2],object)
    exp_saf = np.zeros([n2],object) 
    niv_saf = np.zeros([n2],float)
    ana_saf = np.zeros([n2],float)
    while (iligne < n2) :
        line = fichier_safran.readline()
        liste = line.split()
        date_saf[iligne] = str(liste[0])
        ind_mass_saf[iligne] = str(liste[1])
        mass_saf[iligne] = str(liste[2])
        exp_saf[iligne] = str(liste[3])
        niv_saf[iligne] = float(liste[4])
        ana_saf[iligne] = float(liste[5])
        iligne = iligne+1
    fichier_safran.close()
    SAF = np.zeros([len(LST_JR[imo]),7,len(DN[imass])],float)        
    for ijr in range(0,len(LST_JR[imo])):
        day_saf = 0
        day_saf = nonzero(date_saf == jour_an[lst_month[imo]:lst_month[imo+1]][ijr])
        saf = np.zeros([7,len(DN[imass])],float)
        for iex in range(0,7):
            exp = 0
            exp = nonzero(exp_saf[day_saf] == expo[iex])
            saf[iex,0:len(DN[imass])] = ana_saf[day_saf][exp]
        SAF[ijr,0:7,0:len(DN[imass])] = saf[0:7,0:len(DN[imass])]
        day = 0
        day = nonzero(date_obs == jour_an[lst_month[imo]:lst_month[imo+1]][ijr])
        figure()
        plot(SAF[ijr,0,:],DA[imass],col[0],label='analyse SAFRAN')
                legend(loc='best')
        xlabel('precipitations (mm)')
        ylabel('altitude (m)')
        yticks(arange(300.,4200.,300),arange(300.,4200.,300))
        grid()
        #savefig('D:/output_Vfinale/analyses/compar_analyses_tt-fixes/Dec2009-Juill2010/ana_SAF_ana_AROME_obs_massif_'+nom_massif[imass]+'_'+jour_an[lst_month[imo]:lst_month[imo+1]][ijr]+'.png')
