#! /usr/bin/env python
# -*- coding: utf-8 -*-

#################################
# Appel des modules necessaires #
#################################
import numpy as np
import matplotlib as mpl
import matplotlib.pyplot as plt
import string
from numpy import *
from mpl_toolkits.basemap import Basemap
from matplotlib.collections import PolyCollection
from matplotlib.patches import Polygon
import matplotlib.path as mpath
import collections
import struct
from netCDF4 import Dataset


##################################################
# Appel de la fonction: lire stations par massif #
##################################################
cd D:/python/assimilation_donnees/routines_preliminaires
import fonct_sta_obs_in_massifs
massifs, nb_sta = fonct_sta_obs_in_massifs.sta_massifs()

###########################
# Types de temps par jour #
###########################
#TT_jrs = ([6,2,5,6,2,5,5,2,3,5,3,6,6,5,6,6,6,6,6,6,6,5,5,5,6,5,6,6,1,5,5]) #un type de temps par jour
TT_jrs = 6 #un type de temps fixe


#####################
# Lecture des dates #
#####################
name_month = (['Dec2009','Jan2010','Feb2010','Mar2010','Apr2010','May2010','Jun2010','Jul2010'])
annee = (['09','10'])
list_mois = arange(1,9,1)
list_jour1 = arange(1,32,1)
list_jour2 = arange(1,32,1)
list_jour3 = arange(1,29,1)
list_jour4 = arange(1,32,1)
list_jour5 = arange(1,31,1)
list_jour6 = arange(1,32,1)
list_jour7 = arange(1,31,1)
list_jour8 = arange(1,32,1)
LST_JR = ([list_jour1,list_jour2,list_jour3,list_jour4,list_jour5,list_jour6,list_jour7,list_jour8])
lst_month = np.array([0,31,31+31,31+31+28,31+31+28+31,31+31+28+31+30,31+31+28+31+30+31,31+31+28+31+30+31+30,31+31+28+31+30+31+30+31])
    #initialisation (mois de decembre)
jour_an = []
imo = 0
for ijr in range (0,len(LST_JR[imo])):
    nom_mois = '12'
    if (LST_JR[imo][ijr] <= 9):
        nom_jour = '0' + str(LST_JR[imo][ijr])
    else:
        nom_jour = str(LST_JR[imo][ijr])
    jour_an.append(annee[0] + nom_mois + nom_jour)

    # mois de janvier a juillet
for imo in range (1,8):
    nom_mois = '0' + str(list_mois[imo]-1)
    for ijr in range (0,len(LST_JR[imo])):
        if (LST_JR[imo][ijr] <= 9):
            nom_jour = '0' + str(LST_JR[imo][ijr])
        else:
            nom_jour = str(LST_JR[imo][ijr])
        jour_an.append(annee[1] + nom_mois + nom_jour)

jour_an = np.array(jour_an)


######################################
# Assoc. data obs dans chaque massif #
######################################
for imo in range (0,8):
    LONOBSm = np.zeros([len(LST_JR[imo]),24,16])
    LATOBSm = np.zeros([len(LST_JR[imo]),24,16])
    ALTOBSm = np.zeros([len(LST_JR[imo]),24,16])
    RROBSm = np.zeros([len(LST_JR[imo]),24,16])
    for ijr in range (0,len(LST_JR[imo])):
	print 'date:', jour_an[lst_month[imo]:lst_month[imo+1]][ijr]
        type_tps = np.zeros([24,16],float)
        LONOBS = np.zeros([24,16],float)
        LATOBS = np.zeros([24,16],float)
        ALTOBS = np.zeros([24,16],float)
        RROBS = np.zeros([24,16],float)
        fichier = open ('D:/data/obs/obs_0912-1007/R'+jour_an[lst_month[imo]:lst_month[imo+1]][ijr]+'06', 'r')
        numlines = 0
        for line in fichier: numlines += 1
        fichier.close()
        nbtotal = numlines
        fichier = open ('D:/data/obs/obs_0912-1007/R'+jour_an[lst_month[imo]:lst_month[imo+1]][ijr]+'06', 'r')
        iligne = 0
        lat=np.zeros([nbtotal],float)
        typeobs=np.zeros([nbtotal],int)
        lon=np.zeros([nbtotal],float)
        indic=np.zeros([nbtotal],object)
        rrobs=np.zeros([nbtotal],float)
        alt=np.zeros([nbtotal],float)
        while (iligne < nbtotal) :
            line = fichier.readline()
            lon[iligne] = float(line[12:18])/100.
            lat[iligne] = float(line[6:12])/100.
            rrobs[iligne] = float(line[44:50])/100.
            indic[iligne] = line[28:38]
            alt[iligne] = float(line[38:44])/10.
            iligne=iligne+1
        fichier.close()
        bb = 0
        bb = nonzero((rrobs >= 0.) & (rrobs <= 500.) & (alt >= 0.) & (alt <= 4000.))
        L = shape(bb)[1]
        print 'sta_obs coherents:',L
        for imass in range (0,24): # boucle sur les massifs
            print 'massif:',nom_massif[imass]
            indice = np.zeros([nb_sta[imass]],float)
            altobs = np.zeros([nb_sta[imass]],float)
            lonobs = np.zeros([nb_sta[imass]],float)
            latobs = np.zeros([nb_sta[imass]],float)
            RRobs = np.zeros([nb_sta[imass]],float)
            imin = np.zeros([nb_sta[imass]],float)
            for ii in range (0,nb_sta[imass]): # boucle sur les stations dans un massif donne
                print'nom sta dans massif:',massifs[imass][ii]
                for sta in range (0,L): # boucle sur toutes les stations d obs
                    if indic[bb][sta] == massifs[imass][ii]:
                        print 'existe'
                        indice[ii] = sta
                        print 'indice:',indice[ii]
                        lonobs[ii] = lon[bb][indice[ii]]
                        latobs[ii] = lat[bb][indice[ii]]
                        altobs[ii] = alt[bb][indice[ii]] 
                        RRobs[ii] = rrobs[bb][indice[ii]]
                        RRobs[ii]
                        print 'TT du jour:',TT_jrs
                if indic[bb][indice[ii]] != massifs[imass][ii]:
                    print 'n existe pas'
                    indice[ii] = NaN
                    lonobs[ii] = NaN 
                    latobs[ii] = NaN
                    altobs[ii] = NaN
                    RRobs[ii] = NaN
            LONOBS[imass,0:nb_sta[imass]] = lonobs[0:nb_sta[imass]]
            LATOBS[imass,0:nb_sta[imass]] = latobs[0:nb_sta[imass]]
            ALTOBS[imass,0:nb_sta[imass]] = altobs[0:nb_sta[imass]]
            RROBS[imass,0:nb_sta[imass]] = RRobs[0:nb_sta[imass]]
        LONOBSm[ijr,0:24,0:16] = LONOBS[0:24,0:16]
        LATOBSm[ijr,0:24,0:16] = LATOBS[0:24,0:16]
        ALTOBSm[ijr,0:24,0:16] = ALTOBS[0:24,0:16]
        RROBSm[ijr,0:24,0:16] = RROBS[0:24,0:16]
    for imass in range(0,24):
        fichier_data = open ('D:/output_Vfinale/data_for_1DVar/Dec2009-Juill2010/data_OBS_in_massif/data_obs_in_massif_'+nom_massif[imass]+'_'+name_month[imo]+'.txt', 'a')
        for ijr in range(0,len(LST_JR[imo])):
            if (list_mois[imo] <= 9):
                nom_mois = '0' + str(list_mois[imo])
            else:
                nom_mois = str(list_mois[imo])	
            if (LST_JR[imo][ijr] <= 9):
                nom_jour = '0' + str(LST_JR[imo][ijr])
            else:
                nom_jour = str(LST_JR[imo][ijr])
            jour_an = annee + nom_mois + nom_jour
            print 'date pour fichier:', jour_an
            for sta in range (0,nb_sta[imass]):
                if (
                    (isnan(LONOBSm[ijr,imass,sta]) == True) &
                    (isnan(LATOBSm[ijr,imass,sta]) == True) &
                    (isnan(ALTOBSm[ijr,imass,sta]) == True) &
                    (isnan(RROBSm[ijr,imass,sta]) == True)
                    ):
                    print 'sortir du fichier'
                    continue
                else:
                    fichier_data.write(('%(date)6s   %(massif)10s   %(indicatif)10s   %(long)3.2f   %(lati)4.2f   %(altiobs)5.1f   %(pobs)4.2f   %(tt)1s \n' % {
                        'date':jour_an,
                        'massif':nom_massif[imass],
                        'indicatif':massifs[imass][sta],
                        'long':LONOBSm[ijr,imass,sta],
                        'lati':LATOBSm[ijr,imass,sta],
                        'altiobs':ALTOBSm[ijr,imass,sta],
                        'pobs':RROBSm[ijr,imass,sta],
                        'tt':TT_jrs
                        }))
        fichier_data.close()
