#! /usr/bin/env python
# -*- coding: utf-8 -*-

#################################
# Appel des modules necessaires #
#################################
import numpy as np
import matplotlib as mpl
import matplotlib.pyplot as plt
import string
from numpy import *
from mpl_toolkits.basemap import Basemap
from netCDF4 import Dataset
import scipy.optimize
from scipy.sparse import bsr_matrix
from matplotlib.collections import PolyCollection
from matplotlib.patches import Polygon
import matplotlib.path as mpath


#####################################
# Lecture des niv alt et rr_massifs #
#####################################
nbtotal = 91
fichier = open ('D:\data\safran\NORELmt_typetemps_massifs.dat', 'r')
iligne = 0
alt_massifs = np.zeros([nbtotal],float)
type_temps = np.zeros([nbtotal],float)
rr_massifs = np.zeros([nbtotal,24],float)

while (iligne < nbtotal) :
         line = fichier.readline()
         liste = line.split()
         alt_massifs[iligne] = float(liste[1])
         type_temps[iligne] = float(liste[0])
         for jj in range(0,24):
             rr_massifs[iligne,jj] = float(liste[jj+2])
         iligne = iligne+1
         

fichier.close()
xb_alt=alt_massifs[0:13]


##########################################################
# data AROME moyen + guess initial = nouveau guess AROME #
##########################################################
tt = np.array([6,2,5,6,2,5,5,2,3,5,3,6,6,5,6,6,
               6,6,6,6,6,5,5,5,6,5,6,6,1,5,5]) #un type de temps par jour:
tt = 6 #un type de temps fixe moyen
lst_tt = arange(0,7*13,13)
niv = arange(300.,4200.,300)

    #####################
    # Lecture des dates #
    #####################
name_month = (['Dec2009','Jan2010','Feb2010','Mar2010','Apr2010','May2010','Jun2010','Jul2010'])
annee = (['09','10'])
list_mois = arange(1,9,1)
list_jour1 = arange(1,32,1)
list_jour2 = arange(1,32,1)
list_jour3 = arange(1,29,1)
list_jour4 = arange(1,32,1)
list_jour5 = arange(1,31,1)
list_jour6 = arange(1,32,1)
list_jour7 = arange(1,31,1)
list_jour8 = arange(1,32,1)
LST_JR = ([list_jour1,list_jour2,list_jour3,list_jour4,list_jour5,list_jour6,list_jour7,list_jour8])
lst_month = np.array([0,31,31+31,31+31+28,31+31+28+31,31+31+28+31+30,31+31+28+31+30+31,31+31+28+31+30+31+30,31+31+28+31+30+31+30+31])
    #initialisation (mois de decembre)
jour_an = []
imo = 0
for ijr in range (0,len(LST_JR[imo])):
    nom_mois = '12'
    if (LST_JR[imo][ijr] <= 9):
        nom_jour = '0' + str(LST_JR[imo][ijr])
    else:
        nom_jour = str(LST_JR[imo][ijr])
    jour_an.append(annee[0] + nom_mois + nom_jour)

    # mois de janvier a juillet
for imo in range (1,8):
    nom_mois = '0' + str(list_mois[imo]-1)
    for ijr in range (0,len(LST_JR[imo])):
        if (LST_JR[imo][ijr] <= 9):
            nom_jour = '0' + str(LST_JR[imo][ijr])
        else:
            nom_jour = str(LST_JR[imo][ijr])
        jour_an.append(annee[1] + nom_mois + nom_jour)

jour_an = np.array(jour_an)

    #############################
    # Creation du nouveau guess #
    #############################
for imo in range (4,7):
    for imass in range (0,24):
        ALT_arome = np.zeros([24],float)
        RR_arome = np.zeros([24,31],float)
        #TT = np.zeros([24,31],float)
        GUESSI = np.zeros([24,31,13],float)
        GUESSF = np.zeros([24,31,13],float)
        print 'massif',nom_massif[imass]
        fichier = open ('D:/output_Vfinale/data_for_1DVar/Dec2009-Juill2010/data_AROME_moyen/data_ini/data_AROME_massif_'+nom_massif[imass]+'_'+name_month[imo]+'.txt', 'r')
        numlines = 0
        for line in fichier: numlines += 1
        fichier.close()
        fichier = open ('D:/output_Vfinale/data_for_1DVar/Dec2009-Juill2010/data_AROME_moyen/data_ini/data_AROME_massif_'+nom_massif[imass]+'_'+name_month[imo]+'.txt', 'r')
        nbtotal = numlines
        iligne = 0
        date = np.zeros([nbtotal],object)
        massif = np.zeros([nbtotal],object)
        alt_arome = np.zeros([nbtotal],float)
        rr_arome = np.zeros([nbtotal],float)
        while (iligne < nbtotal) :
            line = fichier.readline()
            liste = line.split()
            date[iligne] = str(liste[0])
            massif[iligne] = str(liste[1])
            alt_arome[iligne] = float(liste[3])
            rr_arome[iligne] = float(liste[4])
            iligne = iligne+1
        fichier.close()
        guessj = np.zeros([31,13],float)
        guess_final = np.zeros([31,13],float)
        for ijr in range (0,len(LST_JR[imo])):
            guessj[ijr,0:13] = rr_massifs[lst_tt[tt-1]:lst_tt[tt],imass]
            print 'guess initial:', guessj[ijr,0:13]
            ############################################
            # creation du guess ajuste par AROME moyen #
            ############################################
            I = 0
            I = nonzero(abs(alt_arome[0] - niv) < 300.)
            d1 = abs(niv[I][0] - alt_arome[0])
            d2 = abs(niv[I][1] - alt_arome[0])
            rr_arome_interp = ((d1 * guessj[ijr,0:13][I][1]) + (d2 * guessj[ijr,0:13][I][0])) / (d1 + d2)
            print 'rr AROME interpolee:', rr_arome_interp
            if (rr_arome[ijr] == NaN):
                guess_final[ijr,0:13] = ([NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN,NaN])
            if (rr_arome[ijr] == 0.):
                alpha = rr_arome_interp
                guess_final[ijr,I[0][1]+1:13] = guessj[ijr,I[0][1]+1:13] - alpha
                guess_final[ijr,0:I[0][1]+1] = 0.
                print 'guess final:', guess_final[ijr,0:13]
            else:
                guess_final[ijr,0:13] = (rr_arome[ijr] / rr_arome_interp) * guessj[ijr,0:13]
                print 'guess final:', guess_final[ijr,0:13]
        ALT_arome[imass] = alt_arome[0]
        RR_arome[imass,0:len(LST_JR[imo])] = rr_arome[0:len(LST_JR[imo])]
        #TT[imass,0:31] = tt[0:31]
        GUESSI[imass,0:len(LST_JR[imo]),0:13] = guessj[0:len(LST_JR[imo]),0:13]
        GUESSF[imass,0:len(LST_JR[imo]),0:13] = guess_final[0:len(LST_JR[imo]),0:13]
        ################################
        # stockage dans un fichier txt #
        ################################
        fichier_arome = open ('D:/output_Vfinale/data_for_1DVar/Dec2009-Juill2010/data_AROME_moyen/data_AROME_massif_'+nom_massif[imass]+'_'+name_month[imo]+'.txt', 'a')
        for ijr in range (0,len(LST_JR[imo])):
            if (list_mois[imo] <= 9):
                nom_mois = '0' + str(list_mois[imo])
            else:
                nom_mois = str(list_mois[imo])	
            if (LST_JR[imo][ijr] <= 9):
                nom_jour = '0' + str(LST_JR[imo][ijr])
            else:
                nom_jour = str(LST_JR[imo][ijr])
            jour_an = annee + nom_mois + nom_jour
            for ialt in range (0,13):
                fichier_arome.write(('%(date)6s   %(massif)10s   %(alt_arome)5.1f   %(rr_arome)4.3f   %(TT)1s   %(niv_alts)5.1f   %(guess_initial)4.2f   %(guess_final)7.5f \n' % {
                        'date':jour_an,
                        'massif':nom_massif[imass],
                        'alt_arome':ALT_arome[imass],
                        'rr_arome':RR_arome[imass,ijr],
                        'TT':tt,
                        'niv_alts':niv[ialt],
                        'guess_initial':GUESSI[imass,ijr,ialt],
                        'guess_final':GUESSF[imass,ijr,ialt]
                        }))
        fichier_arome.close()
