#! /usr/bin/env python
# -*- coding: utf-8 -*-

#################################
# Appel des modules necessaires #
#################################
import numpy as np
import matplotlib as mpl
import matplotlib.pyplot as plt
import string
from numpy import *
from mpl_toolkits.basemap import Basemap
from netCDF4 import Dataset
import scipy.optimize
from scipy.sparse import bsr_matrix
from matplotlib.collections import PolyCollection
from matplotlib.patches import Polygon
import matplotlib.path as mpath


#####################################################
# Lecture des points des polygones de chaque massif #
#####################################################

nbmassifs=24
fichier = open ('D:\data\safran\listeml_massifs.dat', 'r')
iligne = 0
nom_massif=np.zeros([nbmassifs],object)
numero_massif=np.zeros([nbmassifs],float)
points_massif=np.zeros([nbmassifs],int)
lats_massif=np.zeros([nbmassifs,15],float)
lons_massif=np.zeros([nbmassifs,15],float)
while (iligne < nbmassifs) :
         line=fichier.readline()
         liste = line.split(',')
         numero_massif[iligne] = float(liste[0])
         nom_massif[iligne] = str(liste[1])
         points_massif[iligne]=int(liste[2])
         for jj in range(0,points_massif[iligne]):
             lats_massif[iligne,jj] = float(liste[jj+3])/100
             lons_massif[iligne,jj] = float(liste[jj+3+points_massif[iligne]])/100
         iligne=iligne+1
         

fichier.close()


######################################
# Def de la fonction 'point_in_poly' #
######################################
# Determine if a point is inside a given polygon or not
# Polygon is a list of (x,y) pairs. This fuction
# returns True or False.  The algorithm is called
# "Ray Casting Method".
def point_in_poly(x,y,poly):
    n = len(poly)
    inside = False
    p1x,p1y = poly[0]
    for i in range(n+1):
        p2x,p2y = poly[i % n]
        if y > min(p1y,p2y):
            if y <= max(p1y,p2y):
                if x <= max(p1x,p2x):
                    if p1y != p2y:
                        xinters = (y-p1y)*(p2x-p1x)/(p2y-p1y)+p1x
                    if p1x == p2x or x <= xinters:
                        inside = not inside
        p1x,p1y = p2x,p2y
    return inside


#################################
# Appplication aux points AROME #
#################################

    ############################
    # Lecture de lon/lat AROME #
    ############################
arome = Dataset('D:/data/arome/arome_surf/arome_grib_20091130.nc', 'r', format='NETCDF3_CLASSIC')
alt = arome.variables['analyse altitude'][:]
lat = arome.variables['latitude'][:]
lon = arome.variables['longitude'][:]
point_x,point_y=(lon,lat)
arome.close()
# rr_arome, zz_arome, alt_arome moyen dans un massif puis par jour
rain_aro = np.zeros([8,31,24],float)
alt_aro = np.zeros([8,31,24],float)
liste_types = arange(0,91,13)

    #####################
    # Lecture des dates #
    #####################
name_month = (['Dec2009','Jan2010','Feb2010','Mar2010','Apr2010','May2010','Jun2010','Jul2010'])
annee = (['09','10'])
list_mois = arange(1,9,1)
list_jour1 = arange(1,32,1)
list_jour2 = arange(1,32,1)
list_jour3 = arange(1,29,1)
list_jour4 = arange(1,32,1)
list_jour5 = arange(1,31,1)
list_jour6 = arange(1,32,1)
list_jour7 = arange(1,31,1)
list_jour8 = arange(1,32,1)
LST_JR = ([list_jour1,list_jour2,list_jour3,list_jour4,list_jour5,list_jour6,list_jour7,list_jour8])
lst_month = np.array([0,31,31+31,31+31+28,31+31+28+31,31+31+28+31+30,31+31+28+31+30+31,31+31+28+31+30+31+30,31+31+28+31+30+31+30+31])
    #initialisation (mois de decembre)
jour_an = []
imo = 0
for ijr in range (0,len(LST_JR[imo])):
    nom_mois = '12'
    if (LST_JR[imo][ijr] <= 9):
        nom_jour = '0' + str(LST_JR[imo][ijr])
    else:
        nom_jour = str(LST_JR[imo][ijr])
    jour_an.append(annee[0] + nom_mois + nom_jour)

    # mois de janvier a juillet
for imo in range (1,8):
    nom_mois = '0' + str(list_mois[imo]-1)
    for ijr in range (0,len(LST_JR[imo])):
        if (LST_JR[imo][ijr] <= 9):
            nom_jour = '0' + str(LST_JR[imo][ijr])
        else:
            nom_jour = str(LST_JR[imo][ijr])
        jour_an.append(annee[1] + nom_mois + nom_jour)

jour_an = np.array(jour_an)

for imo in range (5,7):
    RR_AROME = np.zeros([len(LST_JR[imo]),24],float)
    ALT_AROME = np.zeros([len(LST_JR[imo]),24],float)
    #ZZ_AROME = np.zeros([len(LST_JR[imo]),24],float)
    for ijr in range (0,len(LST_JR[imo])):
	print jour_an[lst_month[imo]:lst_month[imo+1]][ijr]
        if jour_an[lst_month[imo]:lst_month[imo+1]][ijr] == '100217':
            continue
        if jour_an[lst_month[imo]:lst_month[imo+1]][ijr] == '100520':
            continue
        if jour_an[lst_month[imo]:lst_month[imo+1]][ijr] == '100621':
            continue
        if jour_an[lst_month[imo]:lst_month[imo+1]][ijr] == '100715':
            continue
        rr_arome = np.zeros([24],float)
        alt_arome = np.zeros([24],float)
        for imass in range (0,24):
            print 'massif',nom_massif[imass]
            # initialisation
            poly = [(lons_massif[imass,0], lats_massif[imass,0])]
            # reste du polygone
            for ii in range (1,points_massif[imass]):
                poly.append((lons_massif[imass,ii], lats_massif[imass,ii]),)
            indices = [(0, 0)]
            for ix in range (0,661):
                for iy in range (0,421):
                    if point_in_poly(point_x[ix],point_y[iy],poly) == True:
                        indices.append((ix, iy))
            rain24h = np.zeros([shape(indices)[0]],float)
            alt_zone = np.zeros([shape(indices)[0]],float)
            #zz_moy = np.zeros([shape(indices)[0]],float)
            arome = Dataset('D:/data/arome/arome_surf/arome_grib_20'+jour_an+'.nc', 'r', format='NETCDF3_CLASSIC')
            for ipt in range (0,shape(indices)[0]):
                alt_zone[ipt] = alt[indices[ipt][1],indices[ipt][0]]
                neige6h = arome.variables['prevision6h neige'][indices[ipt][1],indices[ipt][0]]
                neige30h = arome.variables['prevision30h neige'][indices[ipt][1],indices[ipt][0]]
                eau6h = arome.variables['prevision6h eau'][indices[ipt][1],indices[ipt][0]]
                eau30h = arome.variables['prevision30h eau'][indices[ipt][1],indices[ipt][0]]
                graupel6h = arome.variables['prevision6h graupel'][indices[ipt][1],indices[ipt][0]]
                graupel30h = arome.variables['prevision30h graupel'][indices[ipt][1],indices[ipt][0]]
                rain24h[ipt] = (neige30h + eau30h + graupel30h) - (neige6h + graupel6h + eau6h)
                #z500_0h = Dataset('D:/data/Z500/arome_Z500/arome_grib_Z500-0000_0000_decembre2009.nc', 'r', format='NETCDF3_CLASSIC')
                #z500_6h = Dataset('D:/data/Z500/arome_Z500/arome_grib_Z500-0600_0000_decembre2009.nc', 'r', format='NETCDF3_CLASSIC')
                #z500_12h = Dataset('D:/data/Z500/arome_Z500/arome_grib_Z500-1200_0000_decembre2009.nc', 'r', format='NETCDF3_CLASSIC')
                #z500_18h = Dataset('D:/data/Z500/arome_Z500/arome_grib_Z500-1800_0000_decembre2009.nc', 'r', format='NETCDF3_CLASSIC')
                #jours = z500_0h.variables['jours'][:]
                #zz00h = z500_0h.variables['Z'][0,ijr,indices[ipt][1],indices[ipt][0]]/10.
                #zz06h = z500_6h.variables['Z'][0,ijr,indices[ipt][1],indices[ipt][0]]/10.
                #zz12h = z500_12h.variables['Z'][0,ijr,indices[ipt][1],indices[ipt][0]]/10.
                #zz18h = z500_18h.variables['Z'][0,ijr,indices[ipt][1],indices[ipt][0]]/10.
                #zz_moy[ipt] = (1./4)*(zz00h+zz06h+zz12h+zz18h)
                #z500_0h.close()
                #z500_6h.close()
                #z500_12h.close()
                #z500_18h.close()
            bb = 0
            bb = nonzero(rain24h[1:] >= 0.)
            cc = 0
            cc = nonzero((alt_zone[1:] >= 0.) & (alt_zone[1:] <= 4500.))
            rr_arome[imass] = rain24h[1:][bb].mean()
            alt_arome[imass] = alt_zone[1:][cc].mean()
            #zz_arome[imass] = zz_moy[:].mean()
            arome.close()
        RR_AROME[ijr,0:24] = rr_arome[0:24]
        ALT_AROME[ijr,0:24] = alt_arome[0:24]
        #ZZ_AROME[ijr,0:24] = zz_arome[0:24]
    rain_aro[imo,0:len(LST_JR[imo]),0:24] = RR_AROME[0:len(LST_JR[imo]),0:24]
    alt_aro[imo,0:len(LST_JR[imo]),0:24] = ALT_AROME[0:len(LST_JR[imo]),0:24]

########### NOTE ####################################
# Ce programme a ete tourne mois par mois           #
# (env. une journee pour obtenir les infos          #
# sur un mois).                                     #
# Les donnees ont donc ete stockees mois par mois   #
# dans un fichier texte.                            #
#####################################################

##############################################
# Stockage des donnees dans des fichiers txt #
##############################################

##########################
# Data AROME du mois M-1 #
##########################
rainarome_avt = ([14.669,13.522,20.034,16.826,19.813,11.420,8.377,
                  6.281,11.699,11.154,3.155,11.571,8.302,7.581,
                  7.081,3.415,10.828,2.387,6.221,8.536,7.791,
                  1.903,3.332,11.541])
altarome_avt = ([1126.6,1206.2,1952.8,1526.5,2191.5,1976.9,1558.1,
                 2397.5,930.5,744.2,1040.6,1280.1,2134.4,1889.5,
                 1975.3,2264.6,1752.6,1350.6,2120.9,1878.5,2024.5,
                 1761.0,1985.0,1532.9])
tt = 6
date_ini = (['091201','100101','100201','100301','100401','100501','100601','100701'])

##############################
# Data AROME des autres mois #
##############################
for imo in range(5,6):
    for imass in range(0,24):
        fichier_data = open ('D:/output_Vfinale/data_for_1DVar/Dec2009-Juill2010/data_AROME_moyen/data_ini/data_AROME_massif_'+nom_massif[imass]+'_'+name_month[0]+'2010.txt', 'a')
        #########################################################################
        #initialisation - premier jour du mois : prendre data du mois précédent #
        #########################################################################
        fichier_data.write(('%(date)6s   %(massif)10s   %(tt)1s   %(alti_arome)5.1f   %(rr_arome)5.3f \n' % {
                'date':date_ini[imo],
                'massif':nom_massif[imass],
                'tt':tt,
                'alti_arome':altarome_avt[imass],
                'rr_arome':altarome_avt[imass]
                }))
        #######################
        # Phase intermediaire #
        #######################
        for ijr in range (1,len(LST_JR[imo])):
            if ((alt_aro[imo,ijr-1,imass] == 0.) & (rain_aro[imo,ijr-1,imass] == 0.)):
                alt_aro[imo,ijr-1,imass] = NaN
                rain_aro[imo,ijr-1,imass] = NaN
            fichier_data.write(('%(date)6s   %(massif)10s   %(tt)1s   %(alti_arome)5.1f   %(rr_arome)5.3f \n' % {
                'date':jour_an,
                'massif':nom_massif[imass],
                'tt':tt,
                'alti_arome':alt_aro[imo,ijr-1,imass],
                'rr_arome':rain_aro[imo,ijr-1,imass]
                }))
        fichier_data.close()
