#!/usr/bin/env python
# -*- coding: utf-8 -*-


#################################
# Appel des modules necessaires #
#################################
import string
import matplotlib.pyplot as pyplot #used to build contour and wind barbs plots
from numpy import *
import string
import numpy as np
import netCDF4
from netCDF4 import Dataset
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
from matplotlib.collections import PolyCollection
from matplotlib.patches import Polygon
import matplotlib.path as mpath


#########################################
# Lecture et cartographie de data AROME #
#########################################
# ici je boucle sur les dates (sur une annee)
list_anne=[2009]
list_mois=arange(12,13,1)
list_jour=arange(1,32,1)
pluie=np.zeros([31],float)
for ian in range (0,1):
        for imo in range (0,1):
		for ijr in range (0,1):
                        if (list_mois[imo] <= 9):
                                nom_mois = '0' + str(list_mois[imo])
			else:
                                nom_mois = str(list_mois[imo])
				
			if (list_jour[ijr] <= 9):
                                nom_jour = '0' + str(list_jour[ijr])
			else:
                                nom_jour = str(list_jour[ijr])
			
			jour_an=str(list_anne[ian])+nom_mois+nom_jour
			print jour_an
			fichier_netcdf = 'D:/data/arome/arome_surf/arome_grib_' + jour_an + '.nc'
			arome = Dataset(fichier_netcdf, 'r', format='NETCDF3_CLASSIC')
			#nc_surf1 = arome.variables['prevision6h humidite relative 2m']
			#nc_surf2 = arome.variables['prevision6h temperature 2m']
			#nc_surf3 = arome.variables['prevision6h nebul']
			#nc_surf4 = arome.variables['prevision30h nebul']
			#nc_surf5 = arome.variables['prevision6h TCWV']
			#nc_surf6 = arome.variables['prevision6h flux net solaire D']
			#nc_surf7 = arome.variables['prevision6h flux net thermique D']
			#nc_surf8 = arome.variables['analyse pression au sol']
			#nc_surf9 = arome.variables['prevision6h pression au sol']
			nc_surf10 = arome.variables['analyse altitude']
			nc_surf11 = arome.variables['prevision6h neige']
			nc_surf12 = arome.variables['prevision30h neige']
			nc_surf13 = arome.variables['prevision6h eau']
			nc_surf14 = arome.variables['prevision30h eau']
			nc_surf15 = arome.variables['prevision6h graupel']
			nc_surf16 = arome.variables['prevision30h graupel']
			#nc_surf17 = arome.variables['prevision6h Vvent 10m']
			#nc_surf18 = arome.variables['prevision6h Uvent 10m']
			lat = arome.variables['latitude'][:]
			lon = arome.variables['longitude'][:]
			alt = arome.variables['analyse altitude'][:]
			eau6h = nc_surf13[:]
			eau30h = nc_surf14[:]
			eau24h = eau30h - eau6h
			neige6h = nc_surf11[:]
			neige30h = nc_surf12[:]
			neige24h = neige30h - neige6h
			graupel6h = nc_surf15[:]
			graupel30h = nc_surf16[:]
			graupel24h = graupel30h - graupel6h
			rain = eau24h + graupel24h + neige24h
			figure()
			m = Basemap(llcrnrlon=4.5,urcrnrlon=8.5,llcrnrlat=43.125,urcrnrlat=46.875,projection='cyl',resolution='h',fix_aspect=True)
                        m.drawcoastlines(linewidth=0.5)
                        m.drawparallels(np.arange(-90.,90.,1.), labels=[1,0,0,0])
                        m.drawlsmask(land_color='white',ocean_color='#C8E7EF', lakes=True)
                        m.drawmeridians(np.arange(-180.,180.,1.), labels=[0,0,0,1])
                        m.drawmapboundary(fill_color='aqua')
			#clevs=arange(0,0.8,0.005)
			clevs=arange(0.,100.,1)
			#x_arome,y_arome = np.meshgrid(lon,lat)
		        cs=m.contourf(x_arome,y_arome,alt,clevs)
			cbar =colorbar(cs) 
		        cbar.set_label('precipitations')
		        #cbar.set_clim(0.65,1)
			m.drawmapboundary(fill_color='aqua')
                        plt.show()
                        plt.savefig('D:/data_out/figures/assimilation/stats_safran_arome_obs/carto_rrarome_massifs/rrarome_massifs_'+jour_an+'.png')
			#close()
			


