#!/usr/bin/env python
# -*- coding: utf-8 -*-

#################################
# Appel des modules necessaires #
#################################
import string
import matplotlib.pyplot as pyplot #used to build contour and wind barbs plots
from numpy import *
import string
import numpy as np
import netCDF4
#from mpl_toolkits.basemap import shiftgrid, cm
from netCDF4 import Dataset
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm


#############################
# Lecture de altitude AROME #
#############################
fichier_netcdf = 'D:/data/arome/arome_surf/arome_grib_20091231.nc'
arome = Dataset(fichier_netcdf, 'r', format='NETCDF3_CLASSIC')
alt = arome.variables['analyse altitude'][:]
lat = arome.variables['latitude'][:]
lon = arome.variables['longitude'][:]


###########################
# Lecture de altitude OBS #
###########################
fichier = open ('D:/data/obs/obs_0912-1007/R09120106', 'r')
numlines = 0
for line in fichier: numlines += 1

fichier.close()
nbtotal=numlines
fichier = open ('D:/data/obs/obs_0912-1007/R09120106', 'r')
iligne = 0
lat=np.zeros([nbtotal],float)
typeobs=np.zeros([nbtotal],int)
lon=np.zeros([nbtotal],float)
indic=np.zeros([nbtotal],object)
rrobs=np.zeros([nbtotal],float)
alt=np.zeros([nbtotal],float)
while (iligne < nbtotal) :
    line = fichier.readline()
    lon[iligne] = float(line[12:18])/100.
    lat[iligne] = float(line[6:12])/100.
    rrobs[iligne] = float(line[44:50])/100.
    indic[iligne] = line[28:38]
    alt[iligne] = float(line[38:44])/10.
    iligne=iligne+1

fichier.close()
bb=0
bb=nonzero((alt >= 0.) & (alt <= 3800.))


cmap1 = matplotlib.colors.LinearSegmentedColormap.from_list(name='black_white_blue', colors =[(1, 1, 1), (0, 0., 1), (0.4, 0.4, 0.4)])
m = Basemap(llcrnrlon=4.5,urcrnrlon=8.5,llcrnrlat=43.125,urcrnrlat=46.875,projection='cyl',resolution='i',fix_aspect=True)   
m.drawcoastlines(linewidth=1)
m.drawparallels(np.arange(-90.,90.,1.), color='#909090', linewidth=1.0, zorder=None, dashes=[1, 1], labels=[1,0,0,0])
m.drawlsmask(land_color='white',ocean_color='#C8E7EF', lakes=True)
m.drawmeridians(np.arange(-180.,180.,1.), labels=[0,0,0,1])
# carto altitude AROME
x_arome, y_arome = m(*np.meshgrid(lon,lat))
clevs=arange(0,3800,1)
cs=m.contourf(x_arome,y_arome,alt,clevs,cmap=cmap1)
cbar =colorbar(cs)
cbar.set_label('altitude issue du modele AROME (m)')
# carto altitude stations OBS
x_obs,y_obs = m(lon[bb],lat[bb])
csobs = m.scatter(x_obs,y_obs,c=alt[bb],vmin=0,vmax=3000)
cbarobs = colorbar(csobs,orientation='horizontale')
cbarobs.set_label('altitude stations (m)')
plt.legend(loc='best')
plt.savefig('D:/data_out/figures/stats_arome_surf_rrobs/altitude-ect.png')



    
