#! /usr/bin/env python
# -*- coding: utf-8 -*-

#################################
# Appel des modules necessaires #
#################################
import numpy as np
import matplotlib as mpl
import matplotlib.pyplot as plt
import string
from numpy import *
from mpl_toolkits.basemap import Basemap
from matplotlib.collections import PolyCollection
from matplotlib.patches import Polygon
import matplotlib.path as mpath


############################################################
# Lecture des coord lon/lat de delimitation des 24 massifs #
############################################################    
nbmassifs = 24 #nb de massifs alpins
fichier = open ('D:\data\safran\listeml_massifs.dat', 'r')
iligne = 0
nom_massif = np.zeros([nbmassifs],object) #vecteur regroupant le nom de chaque massif
numero_massif = np.zeros([nbmassifs],float) #vecteur regroupant le num correspondant a chaque massif
points_massif = np.zeros([nbmassifs],int) #vecteur regroupant le nb de pts du polygone qui definit le massif
lats_massif = np.zeros([nbmassifs,15],float) #latitude des pts du polygone de chaque massif
lons_massif = np.zeros([nbmassifs,15],float) #longitude des pts du polygone de chaque massif
while (iligne < nbmassifs) :
         line = fichier.readline()
         liste = line.split(',')
         numero_massif[iligne] = float(liste[0])
         nom_massif[iligne] = str(liste[1])
         name = nom_massif[iligne]
         print 'nom du massif :', name
         points_massif[iligne] = int(liste[2])
         for jj in range(0,points_massif[iligne]):
             lats_massif[iligne,jj] = float(liste[jj+3])/100
             lons_massif[iligne,jj] = float(liste[jj+3+points_massif[iligne]])/100
         iligne=iligne+1
         

fichier.close()


###################################
# Cartographie des massifs SAFRAN #
###################################
m = Basemap(llcrnrlon=5.1,urcrnrlon=7.8,llcrnrlat=43.6,urcrnrlat=46.6,projection='cyl',resolution='i',fix_aspect=True)   
m.drawcoastlines(linewidth=1)
m.drawparallels(np.arange(-90.,90.,1.), color='#909090', linewidth=0.5, zorder=None, dashes=[1, 1], labels=[1,0,0,0])
m.drawlsmask(land_color='white',ocean_color='#C8E7EF', lakes=True)
m.drawmeridians(np.arange(-180.,180.,1.), labels=[0,0,0,1])
# nom de chaque massif et coordonnees du texte sur la carte:
LONvec_txt = np.array([6.25,6.20,6.66,6.36,6.74,6.38,6.22,6.70,5.94,5.58,5.33,5.76,6.02,5.92,6.34,6.55,6.06,5.64,6.68,6.33,6.41,6.43,7.04,6.97])
LATvec_txt = np.array([46.18,45.92,45.88,45.70,45.58,45.45,45.30,45.24,45.7,45.41,44.98,45.24,45.12,44.90,44.83,45.02,44.66,44.58,44.73,44.49,44.39,44.19,44.22,46.37])
NOM_MASSIF = np.array(['Chablais','Aravis','Mont Blanc','Beaufortin','Haute Tarentaise','Vanoise','Maurienne','Haute Maurienne','Bauges','Chartreuse','Vercors','Belledonne','Grandes Rousses','Oisans','Pelvoux','Thabor','Champsaur','Devoluy','Queyras','Parpaillon','Ubaye','Alpes-Azur','Mercantour','Diablerets'])
Path = mpath.Path
for imass in range (0,nbmassifs): #boucle sur les 24 massifs
    #####################################
    # Creation de la liste de polygones #
    #####################################
    init = [
        (Path.MOVETO, (lons_massif[imass,0], lats_massif[imass,0])),
        (Path.CURVE4, (lons_massif[imass,1], lats_massif[imass,1])),
        (Path.LINETO, (lons_massif[imass,2], lats_massif[imass,2])),
                ] #initialisation (3 premiers points du polygone)
    for ii in range (3,points_massif[imass]):
        init.append((Path.CURVE4, (lons_massif[imass,ii], lats_massif[imass,ii])),) #points intermediaires du polygone
        fin = [(Path.CLOSEPOLY, (lons_massif[imass,0], lats_massif[imass,0])),] #derniers points du polygone
    pathmassif = init + fin #polygone final
    codes, verts = zip(*pathmassif)
    path = mpath.Path(verts, codes)
    x_mass, y_mass = zip(*path.vertices)
    line, = plt.plot(x_mass, y_mass, 'r-')
    annotate(NOM_MASSIF[imass], xy=(LONvec_txt[imass],LATvec_txt[imass])) #ajout du nom des massifs sur la carte
