#!/usr/bin/env python
# -*- coding: utf-8 -*-

#################################
# Appel des modules necessaires #
#################################
import string
import matplotlib as mpl
import matplotlib.pyplot as pyplot #used to build contour and wind barbs plots
from numpy import *
import string
import numpy as np
import netCDF4
#from mpl_toolkits.basemap import shiftgrid, cm
from netCDF4 import Dataset
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
from matplotlib.collections import PolyCollection
from matplotlib.patches import Polygon
import matplotlib.path as mpath

#---------------------------------------------------------------------------------------------------------------------

###############################################################
# Creation du vecteur 'dates' de decembre 2009 a juillet 2010 #
###############################################################
name_month = (['Dec2009','Jan2010','Feb2010','Mar2010','Apr2010','May2010','Jun2010','Jul2010'])
annee = (['09','10'])
list_mois = arange(1,9,1)
list_jour1 = arange(1,32,1)
list_jour2 = arange(1,32,1)
list_jour3 = arange(1,29,1)
list_jour4 = arange(1,32,1)
list_jour5 = arange(1,31,1)
list_jour6 = arange(1,32,1)
list_jour7 = arange(1,31,1)
list_jour8 = arange(1,32,1)
LST_JR = ([list_jour1,list_jour2,list_jour3,list_jour4,list_jour5,list_jour6,list_jour7,list_jour8])
lst_month = np.array([0,31,31+31,31+31+28,31+31+28+31,31+31+28+31+30,31+31+28+31+30+31,31+31+28+31+30+31+30,31+31+28+31+30+31+30+31])
        ####################################
        #initialisation (mois de decembre) #
        ####################################
jour_an = []
imo = 0
for ijr in range (0,len(LST_JR[imo])):
    nom_mois = '12'
    if (LST_JR[imo][ijr] <= 9):
        nom_jour = '0' + str(LST_JR[imo][ijr])
    else:
        nom_jour = str(LST_JR[imo][ijr])
    jour_an.append(annee[0] + nom_mois + nom_jour)

        #############################
        # mois de janvier a juillet #
        #############################
for imo in range (1,8):
    nom_mois = '0' + str(list_mois[imo]-1)
    for ijr in range (0,len(LST_JR[imo])):
        if (LST_JR[imo][ijr] <= 9):
            nom_jour = '0' + str(LST_JR[imo][ijr])
        else:
            nom_jour = str(LST_JR[imo][ijr])
        jour_an.append(annee[1] + nom_mois + nom_jour)

jour_an = np.array(jour_an)

#---------------------------------------------------------------------------------------------------------------------

#######################
# Lecture de data OBS #
#######################
# ici je boucle sur les dates
for imo in range (0,1): # lecture du mois de decembre 2009
    for ijr in range (0,len(LST_JR[imo])): #boucle sur les jours du mois de decembre 2009
        fichier = open ('D:/data/obs/obs_0912-1007/R'+jour_an[LST_JR[imo]][ijr]+'06', 'r')
        numlines = 0
        for line in fichier: numlines += 1
        fichier.close()
        nbtotal=numlines
        fichier = open ('D:/data/obs/obs_0912-1007/R'+jour_an[LST_JR[imo]][ijr]+'06', 'r')
        iligne = 0
        lat=np.zeros([nbtotal],float)
        typeobs=np.zeros([nbtotal],int)
        lon=np.zeros([nbtotal],float)
        indic=np.zeros([nbtotal],object)
        rrobs=np.zeros([nbtotal],float)
        alt=np.zeros([nbtotal],float)
        while (iligne < nbtotal) :
            line = fichier.readline()
            lon[iligne] = float(line[12:18])/100.
            lat[iligne] = float(line[6:12])/100.
            rrobs[iligne] = float(line[44:50])/100.
            indic[iligne] = line[28:38]
            alt[iligne] = float(line[38:44])/10.
            iligne=iligne+1
        fichier.close()
        bb = 0
        bb = nonzero((rrobs > 0.) & (rrobs <= 500.) & (alt >= 0.) & (alt <= 4000.)) #sortir les valeurs de precips et d alt erronees du fichier

#---------------------------------------------------------------------------------------------------------------------

#########################
# Lecture de data AROME #
#########################
fichier_netcdf = 'D:/data/arome_grib/arome_grib_20091201.nc'
arome = Dataset(fichier_netcdf, 'r', format='NETCDF3_CLASSIC')
nc_surf = arome.variables['analyse altitude']
lat_arome = arome.variables['latitude'][:]
lon_arome = arome.variables['longitude'][:]
alt_arome = nc_surf[:]
arome.close()

#---------------------------------------------------------------------------------------------------------------------

###########################################################################
# Lecture des coord lon/lat qui delimitent les polygones de chaque massif #
###########################################################################    
nbmassifs=24 #nb de massifs alpins
fichier = open ('D:\data\safran\listeml_massifs.dat', 'r')
iligne = 0
nom_massif=np.zeros([nbmassifs],object)#vecteur regroupant le nom de chaque massif
numero_massif=np.zeros([nbmassifs],float)#vecteur regroupant le num correspondant a chaque massif
points_massif=np.zeros([nbmassifs],int)#vecteur regroupant le nb de pts du polygone qui definit le massif
lats_massif=np.zeros([nbmassifs,15],float)#latitudes des pts du polygone de chaque massif
lons_massif=np.zeros([nbmassifs,15],float)#longitudes des pts du polygone de chaque massif
while (iligne < nbmassifs) :
         line=fichier.readline()
         liste = line.split(',')
         numero_massif[iligne] = float(liste[0])
         nom_massif[iligne] = str(liste[1])
         name = nom_massif[iligne]
         print 'nom du massif : '+name
         points_massif[iligne]=int(liste[2])
         for jj in range(0,points_massif[iligne]):
             lats_massif[iligne,jj] = float(liste[jj+3])/100
             lons_massif[iligne,jj] = float(liste[jj+3+points_massif[iligne]])/100
         iligne=iligne+1
         

fichier.close()

#---------------------------------------------------------------------------------------------------------------------

####################################################################################################
# Cartographie du champ d altitude AROME de l alt des stations d observation et des massifs SAFRAN #
####################################################################################################
cmap1 = matplotlib.colors.LinearSegmentedColormap.from_list(name='black_white_blue', colors =[(1, 1, 1), (0, 0., 1), (0.4, 0.4, 0.4)])	
m = Basemap(llcrnrlon=4.5,urcrnrlon=8.5,llcrnrlat=43.125,urcrnrlat=46.875,projection='cyl',resolution='h',fix_aspect=True)
m.drawcoastlines(linewidth=0.5)
m.drawparallels(np.arange(43.125.,46.875,0.375), labels=[1,0,0,0])
m.drawlsmask(land_color='white',ocean_color='#C8E7EF', lakes=True)
m.drawmeridians(np.arange(4.5,8.5,0.5), labels=[0,0,0,1])
    #############
    # Alt AROME #
    #############
x_arome,y_arome = m(*np.meshgrid(lon_arome,lat_arome))
clevs = arange (0,3800,100)
cs_arome=m.contourf(x_arome,y_arome,alt_arome,clevs,cmap=cmap1)
cbar_arome =colorbar(cs_arome) 
cbar_arome.set_label('Altitude AROME (m)')
    ######################
    # Alt stations d obs #
    ######################
x_obs,y_obs = m(lon_obs[bb_obs],lat_obs[bb_obs])
cs_obs=m.scatter(x_obs,y_obs,c=alt_obs[bb_obs])
cbar_obs = colorbar(cs_obs, orientation='horizontale')
cbar_obs.set_label('Altitude stations (m)')
    #####################
    # polygones massifs #
    #####################
Path = mpath.Path
for imass in range (0,nbmassifs): #boucle sur les 24 massifs
    init = [
        (Path.MOVETO, (lons_massif[imass,0], lats_massif[imass,0])),
        (Path.CURVE4, (lons_massif[imass,1], lats_massif[imass,1])),
        (Path.LINETO, (lons_massif[imass,2], lats_massif[imass,2])),
                ] #initialisation (3 premiers points du polygone)
    for ii in range (3,points_massif[imass]):
        init.append((Path.CURVE4, (lons_massif[imass,ii], lats_massif[imass,ii])),) #points intermediaires du polygone
        fin = [(Path.CLOSEPOLY, (lons_massif[imass,0], lats_massif[imass,0])),] #derniers points du polygone
    pathmassif = init + fin #polygone final
    codes, verts = zip(*pathmassif)
    path = mpath.Path(verts, codes)
    x_mass, y_mass = zip(*path.vertices)
    line, = plt.plot(x_mass, y_mass, 'r-')


plt.savefig('D:/data_out/figures/safran/carto_arome_sta_obs_massifs.png')

			

