#! /usr/bin/env python
# -*- coding: utf-8 -*-

#################################
# Appel des modules necessaires #
#################################
import numpy as np
import matplotlib as mpl
import matplotlib.pyplot as plt
import string
from numpy import *
from mpl_toolkits.basemap import Basemap
from matplotlib.collections import PolyCollection
from matplotlib.patches import Polygon


######################################################
# Lecture du fichier 'NORELmt_typetemps_massifs.dat' #
######################################################
nbtotal = 91
fichier = open ('D:\data\safran\NORELmt_typetemps_massifs.dat', 'r')
iligne = 0
alt_massifs = np.zeros([nbtotal],float)
type_temps = np.zeros([nbtotal],float)
rr_massifs = np.zeros([nbtotal,24],float)

while (iligne < nbtotal) :
         line = fichier.readline()
         # exemple : line = "0.22 2.3 5.0 6"
         liste = line.split()
         # exemple : listeCoord ['0.22', '2.3', '5.0', '6'] (liste de chaine de caractères)
         alt_massifs[iligne] = float(liste[1])
         type_temps[iligne] = float(liste[0])
         for jj in range(0,24):
             rr_massifs[iligne,jj] = float(liste[jj+2]) #precipitations par niveau d altitude, par massif
         iligne = iligne+1
         

fichier.close()


##################################################################
# Plot des types de temps (profils de precipitations par massif) #
##################################################################
niv_alt = 13 #nb de niveaux d altitude
types_tps = 7 #nb de profils types de temps
nb_massifs = 24 # nb de massifs
rr_vec = np.zeros([13],float) #vecteur profil de precips
alts = alt_massifs[0+13:niv_alt+13] #niveaux d altitude
liste_types = arange(0,91,niv_alt) #lire tous les types de temps (x7)
typet=(['1','2','3','4','5','6','7'])
for imass in range(0,24): #boucle sur tous les massifs
    figure()
    colors = (['b','r','g','c','m','y','k']) #une couleur par type de temps
    for itype in range (0,types_tps):
        for ialt in range (0,niv_alt):
            rr_vec[ialt] = rr_massifs[ialt+liste_types[itype],imass]
        plot(rr_vec,alts,colors[itype],label=typet[itype])
        xlabel('precipitations (mm)')
        ylabel('altitude (m)')
        grid()
        yticks(alts,alts)
    legend(loc='best')
    savefig('D:/data_out/figures/safran/profils_rrsafran_par_massifs/profils_tt_par_couleur/rr_clim_alt_'+str(imass)+'_colors.png')     
