#! /usr/bin/env python
# -*- coding: utf-8 -*-
cd D:/python/safran_maille_11_9 #se placer dans le répertoire permettant de lire la routine qui defini la fonction 'types_temps'
#################################
# Appel des modules necessaires #
#################################
import numpy as np
import matplotlib as mpl
import matplotlib.pyplot as plt
import string
from mpl_toolkits.basemap import Basemap
import matplotlib.path as mpath
from netCDF4 import Dataset
import ffgrid2
import trace
import types_temps_etalon
from collections import Counter


            #########
            # AROME #
            #########

#########################
# Lecture de z500 arome #
#########################
fichier_netcdf_arome = 'D:/data/Z500/arome_Z500/Z500_arome_maille_11_9.nc'
arome = Dataset(fichier_netcdf_arome, 'r', format='NETCDF3_CLASSIC')
nc_lon = arome.variables['longitude']
nc_lat = arome.variables['latitude']
nc_ligne = arome.variables['ligne']
nc_z500 = arome.variables['Z500']
lon_arome = nc_lon[:]
lat_arome = nc_lat[:]
jour_anal = nc_ligne[:]
zz_arome = nc_z500[:]
arome.close()


#########################################################
# Calcul des distances entre z500 etalons et z500 AROME #
#########################################################

#lecture des 7 types de temps etalons:
type_1, type_2, type_3, type_4, type_5, type_6, type_7 = types_temps_etalon.types_temps()
type_01_vec = reshape(type_1,99)
type_02_vec = reshape(type_2,99)
type_03_vec = reshape(type_3,99)
type_04_vec = reshape(type_4,99)
type_05_vec = reshape(type_5,99)
type_06_vec = reshape(type_6,99)
type_07_vec = reshape(type_7,99)

    #########################
    # METHODE1: correlation #
    #########################
correls_arome = np.zeros([124,7],float)
corr_max_arome = np.zeros([124],float)
type_tps_arome = np.zeros([124],int)
for ii in range (0,124):
    print'etape boucle:',ii
    dist_01_arome = corrcoef(reshape(zz_arome[ii,:,:],99) ,type_01_vec)[0,1]
    dist_02_arome = corrcoef(reshape(zz_arome[ii,:,:],99) ,type_02_vec)[0,1]
    dist_03_arome = corrcoef(reshape(zz_arome[ii,:,:],99) ,type_03_vec)[0,1]
    dist_04_arome = corrcoef(reshape(zz_arome[ii,:,:],99) ,type_04_vec)[0,1]
    dist_05_arome = corrcoef(reshape(zz_arome[ii,:,:],99) ,type_05_vec)[0,1]
    dist_06_arome = corrcoef(reshape(zz_arome[ii,:,:],99) ,type_06_vec)[0,1]
    dist_07_arome = corrcoef(reshape(zz_arome[ii,:,:],99) ,type_07_vec)[0,1]
    c_arome = np.array([dist_01_arome, dist_02_arome, dist_03_arome, dist_04_arome, dist_05_arome, dist_06_arome, dist_07_arome])
    correls_arome[ii,0:7] = c_arome[0:7]
    corr_max_arome[ii] = c_arome.max()
    for i in range (0,len(c_arome)):
        if c_arome[i] == corr_max_arome[ii]:
            type_tps_arome[ii] = i+1
            print 'type de temps le plus proche:TT_0',type_tps_arome[ii]
    ##########################
    # Plot pour varification #
    ##########################
    #figure()
    #plt.scatter(reshape(zz_arome[ii,:,:],99) ,type_01_vec,c='b')
    #plt.scatter(reshape(zz_arome[ii,:,:],99) ,type_02_vec,c='g')
    #plt.scatter(reshape(zz_arome[ii,:,:],99) ,type_03_vec,c='r')
    #plt.scatter(reshape(zz_arome[ii,:,:],99) ,type_04_vec,c='c')
    #plt.scatter(reshape(zz_arome[ii,:,:],99) ,type_05_vec,c='m')
    #plt.scatter(reshape(zz_arome[ii,:,:],99) ,type_06_vec,c='y')
    #plt.scatter(reshape(zz_arome[ii,:,:],99) ,type_07_vec,c='k')
    #legend((p1, p2, p3, p4, p5, p6, p7), ('Type1','Type2','Type3','Type4','Type5','Type6','Type7'))
    #xlabel('z500 AROME')
    #ylabel('z500 type de temps etalon')

        ##########################################
        # plot correlation pour chaque TT etalon #
        ##########################################
T = np.array(['Type1','Type2','Type3','Type4','Type5','Type6','Type7'])
colors=(['b','r','g','c','m','y','k'])
#np.savetxt('D:/data_out/tt_arome_arpege_safran/correl_ijours_jtypes_AROME',correls_arome)
lst_temps = arange(0,124,1)
for it in range (0,7):
    correl_temps = np.loadtxt('D:/data_out/tt_arome_arpege_safran/correl_ijours_jtypes_AROME',usecols=[it])
    plt.plot(lst_temps,correl_temps,colors[it],label=T[it])
    plt.xlim(0,124)
    #plt.annotate('13/12/2009 - analyse 00h', xy=(48,-0.58),  xycoords='data',
                #xytext=(-50, 30), textcoords='offset points',
               # bbox=dict(boxstyle="round", fc="0.8"),
                #arrowprops=dict(arrowstyle="->"),
               # )
    #plt.annotate('19/12/2009 - analyse 00h', xy=(72,0.28),  xycoords='data',
                #xytext=(-50, 30), textcoords='offset points',
              #  bbox=dict(boxstyle="round", fc="0.8"),
              #  arrowprops=dict(arrowstyle="->"),
              #  )
    xlabel('indice du jour et echeance')
    ylabel('correlation AROME//7 types de temps etalons')    
    #plt.savefig('D:/data_out/figures/safran_maille_11_9/z500_arome/correlation_types_temps_etalons.png')

    #################
    # METHODE2: RMS #
    #################
type_tps_arome = np.zeros([124],float)
zz_biais_1 = np.zeros([124],float)
zz_biais_2 = np.zeros([124],float)
zz_biais_3 = np.zeros([124],float)
zz_biais_4 = np.zeros([124],float)
zz_biais_5 = np.zeros([124],float)
zz_biais_6 = np.zeros([124],float)
zz_biais_7 = np.zeros([124],float)
zz_std_1 = np.zeros([124],float)
zz_std_2 = np.zeros([124],float)
zz_std_3 = np.zeros([124],float)
zz_std_4 = np.zeros([124],float)
zz_std_5 = np.zeros([124],float)
zz_std_6 = np.zeros([124],float)
zz_std_7 = np.zeros([124],float)
zz_rms_1 = np.zeros([124],float)
zz_rms_2 = np.zeros([124],float)
zz_rms_3 = np.zeros([124],float)
zz_rms_4 = np.zeros([124],float)
zz_rms_5 = np.zeros([124],float)
zz_rms_6 = np.zeros([124],float)
zz_rms_7 = np.zeros([124],float)
diff_rms_arome = np.zeros([124,7],float)
rms_min_arome = np.zeros([124],float)
for ii in range (0,124):
    print'definition du jour',ii
    #type 1
    zz_biais_1[ii]=(reshape(zz_arome[ii,:,:],99) - type_01_vec).mean()
    zz_std_1[ii]=(reshape(zz_arome[ii,:,:],99) - type_01_vec).std()
    zz_rms_1[ii]=sqrt((zz_biais_1[ii]*zz_biais_1[ii])+(zz_std_1[ii]*zz_std_1[ii]))
    #type 2
    zz_biais_2[ii]=(reshape(zz_arome[ii,:,:],99) - type_02_vec).mean()
    zz_std_2[ii]=(reshape(zz_arome[ii,:,:],99) - type_02_vec).std()
    zz_rms_2[ii]=sqrt((zz_biais_2[ii]*zz_biais_2[ii])+(zz_std_2[ii]*zz_std_2[ii]))
    #type 3
    zz_biais_3[ii]=(reshape(zz_arome[ii,:,:],99) - type_03_vec).mean()
    zz_std_3[ii]=(reshape(zz_arome[ii,:,:],99) - type_03_vec).std()
    zz_rms_3[ii]=sqrt((zz_biais_3[ii]*zz_biais_3[ii])+(zz_std_3[ii]*zz_rms_3[ii]))
    #type 4
    zz_biais_4[ii]=(reshape(zz_arome[ii,:,:],99) - type_04_vec).mean()
    zz_std_4[ii]=(reshape(zz_arome[ii,:,:],99) - type_04_vec).std()
    zz_rms_4[ii]=sqrt((zz_biais_4[ii]*zz_biais_4[ii])+(zz_std_4[ii]*zz_rms_4[ii]))
    #type 5
    zz_biais_5[ii]=(reshape(zz_arome[ii,:,:],99) - type_05_vec).mean()
    zz_std_5[ii]=(reshape(zz_arome[ii,:,:],99) - type_05_vec).std()
    zz_rms_5[ii]=sqrt((zz_biais_5[ii]*zz_biais_5[ii])+(zz_std_5[ii]*zz_rms_5[ii]))
    #type 6
    zz_biais_6[ii]=(reshape(zz_arome[ii,:,:],99) - type_06_vec).mean()
    zz_std_6[ii]=(reshape(zz_arome[ii,:,:],99) - type_06_vec).std()
    zz_rms_6[ii]=sqrt((zz_biais_6[ii]*zz_biais_6[ii])+(zz_std_6[ii]*zz_rms_6[ii]))
    #type 7
    zz_biais_7[ii]=(reshape(zz_arome[ii,:,:],99) - type_07_vec).mean()
    zz_std_7[ii]=(reshape(zz_arome[ii,:,:],99) - type_07_vec).std()
    zz_rms_7[ii]=sqrt((zz_biais_7[ii]*zz_biais_7[ii])+(zz_std_7[ii]*zz_rms_7[ii]))
    #recherche du rms min
    d_rms_arome = np.array([zz_rms_1[ii],zz_rms_2[ii],zz_rms_3[ii],zz_rms_4[ii],zz_rms_5[ii],zz_rms_6[ii],zz_rms_7[ii]])
    diff_rms_arome[ii,0:7] = d_rms_arome[0:7]
    rms_min_arome[ii] = d_rms_arome.min()
    for n in range (0,7):
        if d_rms_arome[n] == rms_min_arome[ii]:
            type_tps_arome[ii] = n+1
            print 'type de temps le plus proche:',type_tps_arome[ii]

np.savetxt('D:/data_out/tt_arome_arpege_safran/rms_ijours_jtypes_AROME',diff_rms_arome)
lst_temps = arange(0,124,1)
for it in range (0,7):
    rms_temps_arome = np.loadtxt('D:/data_out/tt_arome_arpege_safran/rms_ijours_jtypes_AROME',usecols=[it])
    colors=(['b','r','g','c','m','y','k'])
    plt.plot(lst_temps,rms_temps_arome,colors[it],label=T[it])
    plt.xlim(0,124)
    #plt.annotate('19/12/2009 - analyse 00h', xy=(72,614),  xycoords='data',
    #            xytext=(-50, 30), textcoords='offset points',
    #            bbox=dict(boxstyle="round", fc="0.8"),
    #            arrowprops=dict(arrowstyle="->"),
    #            )
    #plt.annotate('13/12/2009 - analyse 00h', xy=(48,63.8),  xycoords='data',
                #xytext=(-50, 30), textcoords='offset points',
                #bbox=dict(boxstyle="round", fc="0.8"),
                #arrowprops=dict(arrowstyle="->"),
               # )
    xlabel('indice du jour et echeance')
    ylabel('rms AROME//7 types de temps etalons')


            ##########
            # ARPEGE #
            ##########
fichier_netcdf = 'D:/data/Z500/arpege_Z500/Z500_arpege.nc'
arpege = Dataset(fichier_netcdf, 'r', format='NETCDF3_CLASSIC')
nclon = arpege.variables['longitude']
nclat = arpege.variables['latitude']
ncligne = arpege.variables['ligne']
ncz500 = arpege.variables['Z500']
lon_arpege = nclon[:]
lat_arpege = nclat[:]
jour_anal = ncligne[:]
zz_arpege = ncz500[:]
arpege.close()

#########################################################
# Calcul des distances entre z500 etalons et z500 AROME #
#########################################################

    #########################
    # METHODE1: correlation #
    #########################
correls_arpege = np.zeros([124,7],float)
corr_max_arpege = np.zeros([124],float)
type_tps_arpege = np.zeros([124],float)
for ii in range (0,124):
    print'etape boucle:',ii
    dist_01_arpege = corrcoef(reshape(zz_arpege[ii,:,:],99) ,type_01_vec)[0,1]
    dist_02_arpege = corrcoef(reshape(zz_arpege[ii,:,:],99) ,type_02_vec)[0,1]
    dist_03_arpege = corrcoef(reshape(zz_arpege[ii,:,:],99) ,type_03_vec)[0,1]
    dist_04_arpege = corrcoef(reshape(zz_arpege[ii,:,:],99) ,type_04_vec)[0,1]
    dist_05_arpege = corrcoef(reshape(zz_arpege[ii,:,:],99) ,type_05_vec)[0,1]
    dist_06_arpege = corrcoef(reshape(zz_arpege[ii,:,:],99) ,type_06_vec)[0,1]
    dist_07_arpege = corrcoef(reshape(zz_arpege[ii,:,:],99) ,type_07_vec)[0,1]
    c_arpege = np.array([dist_01_arpege, dist_02_arpege, dist_03_arpege, dist_04_arpege, dist_05_arpege, dist_06_arpege, dist_07_arpege])
    correls_arpege[ii,0:7] = c_arpege[0:7]
    corr_max_arpege[ii] = c_arpege.max()
    for i in range (0,len(c_arpege)):
        if c_arpege[i] == corr_max_arpege[ii]:
            type_tps_arpege[ii] = i+1
            print 'type de temps le plus proche:TT_0',type_tps_arpege[ii]
    #figure()
    #plt.scatter(reshape(zz_arpege[ii,:,:],99) ,type_01_vec,c='b')
    #plt.scatter(reshape(zz_arpege[ii,:,:],99) ,type_02_vec,c='g')
    #plt.scatter(reshape(zz_arpege[ii,:,:],99) ,type_03_vec,c='r')
    #plt.scatter(reshape(zz_arpege[ii,:,:],99) ,type_04_vec,c='c')
    #plt.scatter(reshape(zz_arpege[ii,:,:],99) ,type_05_vec,c='m')
    #plt.scatter(reshape(zz_arpege[ii,:,:],99) ,type_06_vec,c='y')
    #plt.scatter(reshape(zz_arpege[ii,:,:],99) ,type_07_vec,c='k')
    #p1 = Rectangle((0, 0), 1, 1, fc="b")
    #p2 = Rectangle((0, 0), 1, 1, fc="g")
    #p3 = Rectangle((0, 0), 1, 1, fc="r")
    #p4 = Rectangle((0, 0), 1, 1, fc="c")
    #p5 = Rectangle((0, 0), 1, 1, fc="m")
    #p6 = Rectangle((0, 0), 1, 1, fc="y")
    #p7 = Rectangle((0, 0), 1, 1, fc="k")
    #legend((p1, p2, p3, p4, p5, p6, p7), ('Type1','Type2','Type3','Type4','Type5','Type6','Type7'))
    #xlabel('z500 ARPEGE')
    #ylabel('z500 type de temps etalon')


np.savetxt('D:/data_out/tt_arome_arpege_safran/correl_ijours_jtypes_ARPEGE',correls_arpege)
lst_temps = arange(0,124,1)
for it in range (0,7):
    correl_temps_arpege = np.loadtxt('D:/data_out/tt_arome_arpege_safran/correl_ijours_jtypes_ARPEGE',usecols=[it])
    colors=(['b','r','g','c','m','y','k'])
    plt.plot(lst_temps,correl_temps_arpege,colors[it])
    plt.xlim(0,124)
    plt.annotate('13/12/2009 - analyse 00h', xy=(48,-0.511),  xycoords='data',
                xytext=(-50, 30), textcoords='offset points',
                bbox=dict(boxstyle="round", fc="0.8"),
                arrowprops=dict(arrowstyle="->"),
                )
    p1 = Rectangle((0, 0), 1, 1, fc="b")
    p2 = Rectangle((0, 0), 1, 1, fc="r")
    p3 = Rectangle((0, 0), 1, 1, fc="g")
    p4 = Rectangle((0, 0), 1, 1, fc="c")
    p5 = Rectangle((0, 0), 1, 1, fc="m")
    p6 = Rectangle((0, 0), 1, 1, fc="y")
    p7 = Rectangle((0, 0), 1, 1, fc="k")
    legend((p1, p2, p3, p4, p5, p6, p7), ('Type1','Type2','Type3','Type4','Type5','Type6','Type7'))
    xlabel('indice jour et analyse')
    ylabel('correlation ARPEGE-TT etalons')    
    #plt.savefig('D:/data_out/figures/safran_maille_11_9/z500_arome/correlation_types_temps_etalons.png')

    
    #################
    # METHODE1: RMS #
    #################
type_arpege = np.zeros([124],float)
zz_biais_1 = np.zeros([124],float)
zz_biais_2 = np.zeros([124],float)
zz_biais_3 = np.zeros([124],float)
zz_biais_4 = np.zeros([124],float)
zz_biais_5 = np.zeros([124],float)
zz_biais_6 = np.zeros([124],float)
zz_biais_7 = np.zeros([124],float)
zz_std_1 = np.zeros([124],float)
zz_std_2 = np.zeros([124],float)
zz_std_3 = np.zeros([124],float)
zz_std_4 = np.zeros([124],float)
zz_std_5 = np.zeros([124],float)
zz_std_6 = np.zeros([124],float)
zz_std_7 = np.zeros([124],float)
zz_rms_1 = np.zeros([124],float)
zz_rms_2 = np.zeros([124],float)
zz_rms_3 = np.zeros([124],float)
zz_rms_4 = np.zeros([124],float)
zz_rms_5 = np.zeros([124],float)
zz_rms_6 = np.zeros([124],float)
zz_rms_7 = np.zeros([124],float)
diff_rms_arpege = np.zeros([124,7],float)
min_arpege = np.zeros([124],float)

for ii in range (0,124):
    print'definition du jour',ii
    #type 1
    zz_biais_1[ii]=(reshape(zz_arpege[ii,:,:],99) - type_01_vec).mean()
    zz_std_1[ii]=(reshape(zz_arpege[ii,:,:],99) - type_01_vec).std()
    zz_rms_1[ii]=sqrt((zz_biais_1[ii]*zz_biais_1[ii])+(zz_std_1[ii]*zz_std_1[ii]))
    #type 2
    zz_biais_2[ii]=(reshape(zz_arpege[ii,:,:],99) - type_02_vec).mean()
    zz_std_2[ii]=(reshape(zz_arpege[ii,:,:],99) - type_02_vec).std()
    zz_rms_2[ii]=sqrt((zz_biais_2[ii]*zz_biais_2[ii])+(zz_std_2[ii]*zz_std_2[ii]))
    #type 3
    zz_biais_3[ii]=(reshape(zz_arpege[ii,:,:],99) - type_03_vec).mean()
    zz_std_3[ii]=(reshape(zz_arpege[ii,:,:],99) - type_03_vec).std()
    zz_rms_3[ii]=sqrt((zz_biais_3[ii]*zz_biais_3[ii])+(zz_std_3[ii]*zz_rms_3[ii]))
    #type 4
    zz_biais_4[ii]=(reshape(zz_arpege[ii,:,:],99) - type_04_vec).mean()
    zz_std_4[ii]=(reshape(zz_arpege[ii,:,:],99) - type_04_vec).std()
    zz_rms_4[ii]=sqrt((zz_biais_4[ii]*zz_biais_4[ii])+(zz_std_4[ii]*zz_rms_4[ii]))
    #type 5
    zz_biais_5[ii]=(reshape(zz_arpege[ii,:,:],99) - type_05_vec).mean()
    zz_std_5[ii]=(reshape(zz_arpege[ii,:,:],99) - type_05_vec).std()
    zz_rms_5[ii]=sqrt((zz_biais_5[ii]*zz_biais_5[ii])+(zz_std_5[ii]*zz_rms_5[ii]))
    #type 6
    zz_biais_6[ii]=(reshape(zz_arpege[ii,:,:],99) - type_06_vec).mean()
    zz_std_6[ii]=(reshape(zz_arpege[ii,:,:],99) - type_06_vec).std()
    zz_rms_6[ii]=sqrt((zz_biais_6[ii]*zz_biais_6[ii])+(zz_std_6[ii]*zz_rms_6[ii]))
    #type 7
    zz_biais_7[ii]=(reshape(zz_arpege[ii,:,:],99) - type_07_vec).mean()
    zz_std_7[ii]=(reshape(zz_arpege[ii,:,:],99) - type_07_vec).std()
    zz_rms_7[ii]=sqrt((zz_biais_7[ii]*zz_biais_7[ii])+(zz_std_7[ii]*zz_rms_7[ii]))
    d_rms_arpege = np.array([zz_rms_1[ii],zz_rms_2[ii],zz_rms_3[ii],zz_rms_4[ii],zz_rms_5[ii],zz_rms_6[ii],zz_rms_7[ii]])
    diff_rms_arpege[ii,0:7] = d_rms_arpege[0:7]
    min_arpege[ii] = d_rms_arpege.min()
    for n in range (0,7):
        if d_rms_arpege[n] == min_arpege[ii]:
            type_arpege[ii] = n+1
            print 'type de temps le plus proche:',type_arpege[ii]
            
np.savetxt('D:/data_out/tt_arome_arpege_safran/rms_ijours_jtypes_ARPEGE',diff_rms_arpege)
lst_temps = arange(0,124,1)
for it in range (0,7):
    rms_temps_arpege = np.loadtxt('D:/data_out/tt_arome_arpege_safran/rms_ijours_jtypes_ARPEGE',usecols=[it])
    colors=(['b','r','g','c','m','y','k'])
    plt.plot(lst_temps,rms_temps_arpege,colors[it])
    plt.xlim(0,124)
    plt.annotate('13/12/2009 - analyse 00h', xy=(48,32.81),  xycoords='data',
                xytext=(-50, 30), textcoords='offset points',
                bbox=dict(boxstyle="round", fc="0.8"),
                arrowprops=dict(arrowstyle="->"),
                )
    p1 = Rectangle((0, 0), 1, 1, fc="b")
    p2 = Rectangle((0, 0), 1, 1, fc="r")
    p3 = Rectangle((0, 0), 1, 1, fc="g")
    p4 = Rectangle((0, 0), 1, 1, fc="c")
    p5 = Rectangle((0, 0), 1, 1, fc="m")
    p6 = Rectangle((0, 0), 1, 1, fc="y")
    p7 = Rectangle((0, 0), 1, 1, fc="k")
    legend((p1, p2, p3, p4, p5, p6, p7), ('Type1','Type2','Type3','Type4','Type5','Type6','Type7'))
    xlabel('indice jour et analyse')
    ylabel('rms ARPEGE-TT etalons')
