#! /usr/bin/env python
# -*- coding: utf-8 -*-


#---------------------------------------------------------------------------------------
# Appel des modules necessaires
#---------------------------------------------------------------------------------------


import numpy as np
import matplotlib as mpl
import matplotlib.pyplot as plt
import string
from mpl_toolkits.basemap import Basemap
import matplotlib.path as mpath
from netCDF4 import Dataset
#cd D:/python/safran_maille_11_9
import ffgrid2
import trace
import types_temps_etalon


#---------------------------------------------------------------------------------------
# Ouverture d un fichier z500 pour lon/lat
#---------------------------------------------------------------------------------------

 
fichier = Dataset('D:/data/arome_grib_Z500/arome_grib_Z500-0000_0000_decembre2009.nc','r',format='NETCDF3_CLASSIC')
lon = fichier.variables['longitude'][:]
lat = fichier.variables['latitude'][:]
alon,alat = np.meshgrid(lon,lat)
S = len(lon) * len(lat)
lon_vec = reshape(alon,S)
lat_vec = reshape(alat,S)
fichier.close()


#---------------------------------------------------------------------------------------
# Adaptation au maillage SAFRAN 11*9 et creation de la matrice z500_arome
#---------------------------------------------------------------------------------------


lst_analyse = (['00','06','12','18'])
L = len(lst_analyse)
list_jour=arange(1,32,1)
# Domaine d etude (ALPES)
x0, x1 = 4.5, 8.5 
y0, y1 = 46.875, 43.125 
# Pas SAFRAN lon/lat
dx=0.5
dy=-0.375
# Limites max/min de z500
z0 = np.zeros([31],float)
z1 = np.zeros([31],float)
iech = 0

zz_arome = np.zeros([124,11,9],float)
indice_arome = 0

for ijr in range (0,31):
    if (list_jour[ijr] <= 9):
        nom_jour = '0' + str(list_jour[ijr])
    else:
        nom_jour = str(list_jour[ijr])
    date = '200912'+nom_jour
    print 'date:', date
    echeance = lst_analyse[iech]
    for iech in range (0,L):
        fichier = Dataset('D:/data/arome_grib_Z500/arome_grib_Z500-'+lst_analyse[iech]+'00_0000_decembre2009.nc','r',format='NETCDF3_CLASSIC')
        z500 = fichier.variables['Z'][:]
        fichier.close()
        zz = z500[0,ijr,:,:]/10
        z0[ijr]=zz.min()
        z1[ijr]=zz.max()
        zz_vec = reshape(zz,S)
        outz_arome, outx_arome, outy_arome  = ffgrid2.ffgrid(lon_vec, lat_vec, zz_vec, dx, dy, x0, x1, y0, y1, z0[ijr], z1[ijr])
        #trace.draw(zz_arome[indice_arome,0:11,0:9], outx_arome, outy_arome, 'D:/data_out/figures/safran_maille_11_9/zz500_'+echeance+'_'+date+'.png', 'z500 (*10) (en m)', z0[ijr], z1[ijr], 10, cm.winter)
        zz_arome[indice_arome,0:11,0:9]=outz_arome[0:11,0:9]
        indice_arome = indice_arome + 1
        indice_arome

        
jour_anal = arange(0,124,1)

#---------------------------------------------------------------------------------------
# Adaptation au maillage SAFRAN 11*9 et creation de la matrice z500_arome
#---------------------------------------------------------------------------------------


rootgrp = Dataset('D:/data/arome_grib_Z500/Z500_arome_maille_11_9.nc', 'w', format='NETCDF3_CLASSIC')
rootgrp.createDimension('longitude', len(outx_arome))
rootgrp.createDimension('latitude', len(outy_arome))
rootgrp.createDimension('ligne', 124)
nc_lon = rootgrp.createVariable('longitude', 'f', ('longitude',))
nc_lat = rootgrp.createVariable('latitude', 'f', ('latitude',))
nc_ligne = rootgrp.createVariable('ligne', 'f', ('ligne',))
nc_z500 = rootgrp.createVariable('Z500', 'f', ('ligne','latitude', 'longitude'))
nc_lon[:] = outx_arome
nc_lat[:] = outy_arome
nc_ligne[:] = jour_anal
nc_z500[:] = zz_arome
rootgrp.close()
