#! /usr/bin/env python
# -*- coding: utf-8 -*-


#################################
# Appel des modules necessaires #
#################################
import numpy as np
import matplotlib as mpl
import matplotlib.pyplot as plt
import string
from mpl_toolkits.basemap import Basemap
import matplotlib.path as mpath
from netCDF4 import Dataset
cd D:/python/safran_maille_11_9
import ffgrid2
import trace
import types_temps_etalon


####################################
# Lecture du fichier txt data z500 #
####################################
fichier = open ('D:/data/Z500/z500_arpege', 'r')
numlines = 0
for line in fichier: numlines += 1


fichier.close()
fichier = open ('D:/data/arpege_Z500/z500_arpege', 'r')
iligne = 0
analyse = np.zeros([numlines],float)
jour = np.zeros([numlines],float)
type_tps = np.zeros([numlines],float)
z500_arpege = np.zeros([numlines,99],float)
while (iligne < numlines) :
    line = fichier.readline()
    # exemple : line = "0.22 2.3 5.0 6"
    liste = line.split()
    # exemple : listeCoord ['0.22', '2.3', '5.0', '6'] (liste de chaine de caractères)
    analyse[iligne] = float(liste[3])
    jour[iligne] = float(liste[2])
    type_tps[iligne] = float(liste[4])
    for jj in range(0,99):
        z500_arpege[iligne,jj] = float(liste[jj+5])
    iligne = iligne+1


fichier.close()


############################################
# Creation de la matrice 11*9 de data z500 #
############################################
zz_arpege = np.zeros([numlines,11,9],float)
for iligne in range(0,numlines):
    indice_arpege=0
    for axlon in range (0,9):
        for axlat in range (0,11):
            zz_arpege[iligne,axlat,axlon] = z500_arpege[iligne,indice_arpege]
            indice_arpege = indice_arpege + 1
            indice_arpege


lon_arpege = arange(4.5,9,0.5)
lat_arpege = arange(46.875,42.75,-0.375)
lignes = arange(0,124,1)


################################
# Creation d un fichier netcdf #
################################
rootgrp = Dataset('D:/data/arpege_Z500/Z500_arpege.nc', 'w', format='NETCDF3_CLASSIC')
rootgrp.createDimension('longitude', len(lon_arpege))
rootgrp.createDimension('latitude', len(lat_arpege))
rootgrp.createDimension('ligne', 124)
nclon = rootgrp.createVariable('longitude', 'f', ('longitude',))
nclat = rootgrp.createVariable('latitude', 'f', ('latitude',))
ncligne = rootgrp.createVariable('ligne', 'f', ('ligne',))
ncz500 = rootgrp.createVariable('Z500', 'f', ('ligne','latitude', 'longitude'))
nclon[:] = lon_arpege
nclat[:] = lat_arpege
ncligne[:] = lignes
ncz500[:] = zz_arpege
rootgrp.close()
