#! /usr/bin/env python
# -*- coding: utf-8 -*-
cd D:/python/safran_maille_11_9 #se placer dans le répertoire permettant de lire la routine qui defini la fonction 'types_temps'
#################################
# Appel des modules necessaires #
#################################
import numpy as np
import matplotlib as mpl
import matplotlib.pyplot as plt
import string
from mpl_toolkits.basemap import Basemap
import matplotlib.path as mpath
from netCDF4 import Dataset
cd D:/python/safran_maille_11_9
import ffgrid2
import trace
import types_temps_etalon


###################################
# lecture de z500 AROME et ARPEGE #
###################################

    #########
    # AROME #
    #########
fichier_netcdf_arome = 'D:/data/Z500/arome_Z500/Z500_arome_maille_11_9.nc'
arome = Dataset(fichier_netcdf_arome, 'r', format='NETCDF3_CLASSIC')
nc_lon = arome.variables['longitude']
nc_lat = arome.variables['latitude']
nc_ligne = arome.variables['ligne']
nc_z500 = arome.variables['Z500']
lon_arome = nc_lon[:]
lat_arome = nc_lat[:]
jour_anal = nc_ligne[:]
zz_arome = nc_z500[:]
arome.close()

    ##########
    # ARPEGE #
    ##########
fichier_netcdf = 'D:/data/Z500/arpege_Z500/Z500_arpege.nc'
arpege = Dataset(fichier_netcdf, 'r', format='NETCDF3_CLASSIC')
nclon = arpege.variables['longitude']
nclat = arpege.variables['latitude']
ncligne = arpege.variables['ligne']
ncz500 = arpege.variables['Z500']
lon_arpege = nclon[:]
lat_arpege = nclat[:]
jour_anal = ncligne[:]
zz_arpege = ncz500[:]
arpege.close()


######################
# stats AROME/ARPEGE #
######################

    #########################################
    # Calcul du biais entre AROME et ARPEGE #
    #########################################
biais_zz = np.zeros([124,11,9],float)
for m in range (100,124):
    figure()
    no_jr_ana = m
    biais_zz[m,:,:] = -(zz_arome[m,:,:] - zz_arpege[m,:,:])
    ax,ay = (lon_arome,lat_arome)
    plt.contourf(ax,ay,biais_zz[m,:,:])
    cbar = colorbar()
    cbar.set_label('biais ARPEGE-AROME')
    plt.savefig('D:/data_out/figures/safran_maille_11_9/stats_AROME_ARPEGE/stats_AROME_ARPEGE_'+str(no_jr_ana)+'.png')
    plt.close()

    ##################################################
    # Calcul de la correlation entre AROME et ARPEGE #
    ##################################################
lst_00h = arange(0,124,4) # tous les points analyse 00h
lst_06h = arange(1,124,4) # tous les points analyse 06h
lst_12h = arange(2,124,4) # tous les points analyse 12h
lst_18h = arange(3,124,4) # tous les points analyse 18h
correl_0h = np.zeros([124],float)
correl_6h = np.zeros([124],float)
correl_12h = np.zeros([124],float)
correl_18h = np.zeros([124],float)
for i0h in lst_00h: #boucle sur tous les points a l analyse 00h
    a=reshape(zz_arome[i0h,:,:],99)
    b=reshape(zz_arpege[i0h,:,:],99)
    correl_0h[i0h] = corrcoef(a,b)[0,1]

bb0 = 0
bb0 = nonzero(correl_0h != 0)
for i6h in lst_06h: #boucle sur tous les points a l analyse 06h
    correl_6h[i6h] = corrcoef(reshape(zz_arome[i6h,:,:],99),reshape(zz_arpege[i6h,:,:],99))[0,1]

bb6 = 0
bb6 = nonzero(correl_6h != 0)
for i12h in lst_12h: #boucle sur tous les points a l analyse 12h
    correl_12h[i12h] = corrcoef(reshape(zz_arome[i12h,:,:],99),reshape(zz_arpege[i12h,:,:],99))[0,1]

bb12 = 0
bb12 = nonzero(correl_12h != 0)
for i18h in lst_18h: #boucle sur tous les points a l analyse 18h
    correl_18h[i18h] = corrcoef(reshape(zz_arome[i18h,:,:],99),reshape(zz_arpege[i18h,:,:],99))[0,1]

bb18 = 0
bb18 = nonzero(correl_18h != 0)

correl_moy = correl_18h[:].mean() #correlation moyenne sur une analyse choisie parmi les 4
print 'correlation moyenne:',correl_moy

        ###############################################
        # Plot des correlations entre AROME et ARPEGE #
        ###############################################
plt.plot(lst_00h,correl_0h[bb0],'b^',label='echeance 00h')
plt.plot(lst_06h,correl_6h[bb6],'r^',label='echeance 06h')
plt.plot(lst_12h,correl_12h[bb12],'g^',label='echeance 12h')
plt.plot(lst_18h,correl_18h[bb18],'y^',label='echeance 18h')
legend(loc='best')
grid()
plt.xlim(0,124)
#plt.annotate('13/12/2009 - analyse 06h', xy=(49,0.568594),  xycoords='data',
                #xytext=(-50, 30), textcoords='offset points',
                #bbox=dict(boxstyle="round", fc="0.8"),
                #arrowprops=dict(arrowstyle="->"),
                #)
#plt.annotate('10/12/2009 - analyse 06h', xy=(37,0.87),  xycoords='data',
                #xytext=(-50, 30), textcoords='offset points',
                #bbox=dict(boxstyle="round", fc="0.8"),
                #arrowprops=dict(arrowstyle="->"),
                #)
plt.xlabel('indice de jour et analyse')
plt.ylabel('correlation AROME/ARPEGE')
plt.savefig('D:/data_out/figures/safran_maille_11_9/stats_AROME_ARPEGE/correlation_par_analyse.png')

    ###################################################
    # Calcul des stats globales entre AROME et ARPEGE #
    ###################################################
def m_stats(x): #Fonction de calcul du biais 
  n = 0
  S = 0.0
  m = 0.0
  for x_i in x:
    n = n + 1
    m_prev = m
    m = m + (x_i - m) / n
    S = S + (x_i - m) * (x_i - m_prev)
    #return {'mean': m, 'variance': S/n}
  return m

def s_stats(x): #Fonction de calcul de l ECT  
  n = 0
  S = 0.0
  m = 0.0
  for x_i in x:
    n = n + 1
    m_prev = m
    m = m + (x_i - m) / n
    S = S + (x_i - m) * (x_i - m_prev)
    #'variance': S/n == ecart-type2
  return S/n


rmse = np.zeros([99],float)
std_type = np.zeros([99],float)
correl = np.zeros([99],float)

#matrices 2D de z500 geolocalisees pour chaque jour et analyse:
zz_arome_geoloc = reshape(zz_arome,(124,99))
zz_arpege_geoloc = reshape(zz_arpege,(124,99))

diff_zz = zz_arome_geoloc - zz_arpege_geoloc
biais = m_stats(diff_zz) #moyenne en un point pour tous le mois (124 points) : vecteur de 99 valeurs
std_type2 = s_stats(diff_zz) #ecart type au carre, idem
for ll in range(0,99):
        correl[ll]=corrcoef(zz_arome_geoloc[:,ll], zz_arpege_geoloc[:,ll])[0,1]
        rmse[ll]=sqrt((biais[ll]*biais[ll])+std_type2[ll])
        std_type[ll]=sqrt(std_type2[ll])

# matrices 2D pour cartographier les stats:
stat_biais=reshape(biais,(11,9))
stat_std=reshape(std_type,(11,9))
std_rms=reshape(rmse,(11,9))
stat_corr=reshape(correl,(11,9))

xn = arange(4.5,9,0.5) 
yn = arange(46.875,42.75,-0.375)
x,y=(xn,yn)

        #########################################################
        # Cartographie des stats globales entre AROME et ARPEGE #
        #########################################################
figure()
m = Basemap(llcrnrlon=4.5,urcrnrlon=8.5,llcrnrlat=43.125,urcrnrlat=46.875,projection='cyl',resolution='i',fix_aspect=True)   
m.drawcoastlines(linewidth=1)
m.drawparallels(np.arange(-90.,90.,1.), color='#909090', linewidth=1.0, zorder=None, dashes=[1, 1], labels=[1,0,0,0])
m.drawlsmask(land_color='white',ocean_color='white', lakes=True)
m.drawmeridians(np.arange(-180.,180.,1.), labels=[0,0,0,1])
            #########
            # BIAIS #
            #########
#mi1 = stat_biais.min()
#ma1 = stat_biais.max()
#clevs = arange(mi1,ma1,0.1)
plt.contourf(x,y,stat_biais)
cbar = colorbar()
cbar.set_label('biais mensuel [AROME-ARPEGE] (m)')
#plt.savefig('D:/data_out/figures/safran_maille_11_9/stats_AROME_ARPEGE/biais_mensuel')
            #######
            # ECT #
            #######
figure()
plt.contourf(x,y,stat_std)
cbar = colorbar()
cbar.set_label('ecart type mensuel [AROME-ARPEGE] (m)')
#plt.savefig('D:/data_out/figures/safran_maille_11_9/stats_AROME_ARPEGE/ect_mensuel')
            #######
            # RMS #
            #######
figure()
#mi1 = std_rms.min()
#ma1 = std_rms.max()
#clevs = arange(mi1,ma1,0.1)
plt.contourf(x,y,std_rms)
cbar = colorbar()
cbar.set_label('RMS mensuel [AROME-ARPEGE] (m)')
#plt.savefig('D:/data_out/figures/safran_maille_11_9/stats_AROME_ARPEGE/rms_mensuel')
            ################################
            # Superposition des 24 massifs #
            ################################
figure()
Path = mpath.Path
for imass in range (0,nbmassifs):
    # initialisation
    init = [
        (Path.MOVETO, (lons_massif[imass,0], lats_massif[imass,0])),
        (Path.CURVE4, (lons_massif[imass,1], lats_massif[imass,1])),
        (Path.LINETO, (lons_massif[imass,2], lats_massif[imass,2])),
                ]
    # points intermediaires
    for ii in range (3,points_massif[imass]):
        init.append((Path.CURVE4, (lons_massif[imass,ii], lats_massif[imass,ii])),)
        # relier au premier point
        fin = [(Path.CLOSEPOLY, (lons_massif[imass,0], lats_massif[imass,0])),]
    # polygone final
    pathmassif = init + fin
    codes, verts = zip(*pathmassif)
    path = mpath.Path(verts, codes)
    x_mass, y_mass = zip(*path.vertices)
    line, = plt.plot(x_mass, y_mass, 'r-')
