#! /usr/bin/env python
# -*- coding: utf-8 -*-

#################################
# Appel des modules necessaires #
#################################
import numpy as np
import matplotlib as mpl
import matplotlib.pyplot as plt
import string
from mpl_toolkits.basemap import Basemap
import matplotlib.path as mpath
from netCDF4 import Dataset


###########################
# Lecture analyses SAFRAN #
###########################
cd D:/python/assimilation_donnees/assimilation_1D
import funct_analyses_safran
N,DN,A,DA,I,DI = funct_analyses_safran.analyses_safran()
lst_mass = (['01','02','03','04','05','06','07','08','09','10','11','12','13','14','15','16','17','18','19','31','25','29','30','51'])


############################
# Lecture des noms massifs #
############################
nbmassifs=24
fichier = open ('D:\data\safran\listeml_massifs.dat', 'r')
iligne = 0
nom_massif=np.zeros([nbmassifs],object)
while (iligne < nbmassifs) :
    line=fichier.readline()
    liste = line.split(',')
    nom_massif[iligne] = str(liste[1])
    iligne=iligne+1
         

fichier.close()


#####################
# Lecture des dates #
#####################
name_month = (['Dec2009','Jan2010','Feb2010','Mar2010','Apr2010','May2010','Jun2010','Jul2010'])
annee = (['09','10'])
list_mois = arange(1,9,1)
list_jour1 = arange(1,32,1)
list_jour2 = arange(1,32,1)
list_jour3 = arange(1,29,1)
list_jour4 = arange(1,32,1)
list_jour5 = arange(1,31,1)
list_jour6 = arange(1,32,1)
list_jour7 = arange(1,31,1)
list_jour8 = arange(1,32,1)
LST_JR = ([list_jour1,list_jour2,list_jour3,list_jour4,list_jour5,list_jour6,list_jour7,list_jour8])
lst_month = np.array([0,31,31+31,31+31+28,31+31+28+31,31+31+28+31+30,31+31+28+31+30+31,31+31+28+31+30+31+30,31+31+28+31+30+31+30+31])
    ####################################
    #initialisation (mois de decembre) #
    ####################################
jour_an = []
imo = 0
for ijr in range (0,len(LST_JR[imo])):
    nom_mois = '12'
    if (LST_JR[imo][ijr] <= 9):
        nom_jour = '0' + str(LST_JR[imo][ijr])
    else:
        nom_jour = str(LST_JR[imo][ijr])
    jour_an.append(annee[0] + nom_mois + nom_jour)

    #############################
    # mois de janvier a juillet #
    #############################
for imo in range (1,8):
    nom_mois = '0' + str(list_mois[imo]-1)
    for ijr in range (0,len(LST_JR[imo])):
        if (LST_JR[imo][ijr] <= 9):
            nom_jour = '0' + str(LST_JR[imo][ijr])
        else:
            nom_jour = str(LST_JR[imo][ijr])
        jour_an.append(annee[1] + nom_mois + nom_jour)

jour_an = np.array(jour_an)



col1=([0,0,0,'r','r--','r-.'])
label1=([0,0,0,'1D-Var-1500m','1D-Var-1800m','1D-Var-2100m'])
col2=([0,0,0,'k','k--','k-.'])
label2=([0,0,0,'SAFRAN-1500m','SAFRAN-1800m','SAFRAN-2100m'])
haut_saf = np.zeros([24,12,242],float) #hauteurs de neige SAFRAN
haut_1D = np.zeros([24,12,242],float) #hauteurs de neige 1D-Var
biais_m = np.zeros([24,12],float)
ect_m = np.zeros([24,12],float)
rms_m = np.zeros([24,12],float)
for imass in range (6,7):
    htn_saf = np.zeros([12,242],float)
    htn_1D = np.zeros([12,242],float)
    biais = np.zeros([12],float)
    ect = np.zeros([12],float)
    rms = np.zeros([12],float)
    for iniv in range (3,6): #boucle sur les niveau d altitude
        ##############################################################
        # Lecture des hauteurs de neige simulees par Crocus (1D-Var) #
        ##############################################################
        fichier = open ('D:/data/sorties_crocus/REFXX'+lst_mass[imass]+DN[imass][iniv]+'0_20_Laura_trans', 'r')
        numlines = 0
        for line in fichier: numlines += 1
        fichier.close()
        nbtotal=numlines
        fichier = open ('D:/data/sorties_crocus/REFXX'+lst_mass[imass]+DN[imass][iniv]+'0_20_Laura_trans', 'r')
        iligne = 0
        date = np.zeros([nbtotal],object) #jour
        htn = np.zeros([nbtotal],object) #hauteur de neige (cm)
        swe = np.zeros([nbtotal],object) #equivalent en eau (cm)
        ecoul = np.zeros([nbtotal],object) #??
        while (iligne < nbtotal) :
            line = fichier.readline()
            date[iligne] = str(line[0:6])
            htn[iligne] = str(line[6:10])
            swe[iligne] = str(line[10:14])
            ecoul[iligne] = str(line[14:18])
            iligne=iligne+1
        fichier.close()
        ##############################################################
        # Lecture des hauteurs de neige simulees par Crocus (SAFRAN) #
        ##############################################################
        fichier1 = open ('D:/data/sorties_crocus/REFXX'+lst_mass[imass]+DN[imass][iniv]+'0_20', 'r')
        numlines = 0
        for line in fichier1: numlines += 1
        fichier1.close()
        nbtotal1=numlines
        fichier1 = open ('D:/data/sorties_crocus/REFXX'+lst_mass[imass]+DN[imass][iniv]+'0_20', 'r')
        iligne = 0
        date1 = np.zeros([nbtotal1],object)
        htn1 = np.zeros([nbtotal1],object)
        swe1 = np.zeros([nbtotal1],object)
        ecoul1 = np.zeros([nbtotal1],object)
        while (iligne < nbtotal1) :
            line = fichier1.readline()
            date1[iligne] = str(line[0:6])
            htn1[iligne] = str(line[6:10])
            swe1[iligne] = str(line[10:14])
            ecoul1[iligne] = str(line[14:18])
            iligne=iligne+1
        fichier1.close()
        di = nonzero((date == jour_an[0]) & (date1 == jour_an[0])) #jour: 01/12/2009
        df = nonzero((date == jour_an[242]) & (date1 == jour_an[242])) #jour: 31/07/2010 
        HTN_1DVar = htn[di[0][0]:df[0][0]]
        HTN_SAFRAN = htn1[di[0][0]:df[0][0]]
        ############
        # Plot HTN #
        ############
        #figure()
        plot(arange(0,242,1),HTN_1DVar,col1[iniv],label=label1[iniv])
        plot(arange(0,242,1),HTN_SAFRAN,col2[iniv],label=label2[iniv])
        legend(loc='best')
        tick_locs = lst_month[0:8]
        tick_lbls = ['Dec2009','janv2010','fev2010','mar2010','avr2010','mai2010','juin2010','juil2010']
        plt.xticks(tick_locs, tick_lbls,rotation = 30)
        xlim(0,242)
        grid()
        ylabel('hauteur de neige (cm)')
        #savefig('D:/output_Vfinale/impact_neige/eval_crocus_1DVar_SAFRAN/Comp_htn_dec2009-juill2010_tous-niv/SAFRAN_1D-Var_massif_'+nom_massif[imass]+'_niv-'+str(DA[imass][iniv])+'.jpg')
        htn_SAFRAN = np.zeros([len(HTN_SAFRAN)],float)
        htn_1DVar = np.zeros([len(HTN_1DVar)],float)
        ####################################
        # Calcul des scores stats mensuels #
        ####################################
        for ii in range (0,len(HTN_SAFRAN)):
            htn_SAFRAN[ii] = float(HTN_SAFRAN[ii])
            htn_1DVar[ii] = float(HTN_1DVar[ii])
        htn_saf[iniv,0:len(HTN_SAFRAN)] = htn_SAFRAN[:]
        htn_1D[iniv,0:len(HTN_SAFRAN)] = htn_1DVar[:]
        biais[iniv]  = (htn_SAFRAN - htn_1DVar).mean()
        ect[iniv]  = (htn_SAFRAN - htn_1DVar).std()
        rms[iniv]  = sqrt(biais[iniv]*biais[iniv] + ect[iniv]*ect[iniv])
    haut_saf[imass,0:len(DN[imass]),0:len(HTN_SAFRAN)] = htn_saf[0:len(DN[imass]),0:len(HTN_SAFRAN)]
    haut_1D[imass,0:len(DN[imass]),0:len(HTN_SAFRAN)] = htn_1D[0:len(DN[imass]),0:len(HTN_SAFRAN)]
    biais_m[imass,0:len(DN[imass])] = biais[0:len(DN[imass])]
    ect_m[imass,0:len(DN[imass])] = ect[0:len(DN[imass])]
    rms_m[imass,0:len(DN[imass])] = rms[0:len(DN[imass])]


##############################################
# Biais par massif - tous niveaux d altitude #
##############################################
alt_moy_mass = np.array([1126.6,1206.2,1952.8,1526.5,2191.5,1976.9,1558.1,2397.5,930.5,744.2,1040.6,1280.1,
                         2134.4,1889.5,1975.3,2264.6,1752.6,1350.6,2120.9,1878.5,2024.5,1761.0,1985.0,1532.9])
biais_mass = np.zeros([24],float)
ect_mass = np.zeros([24],float)
rms_mass = np.zeros([24],float)
for imass in range (0,24):
    z = nonzero((biais_m[imass,:] != 0.) & (ect_m[imass,:] != 0.) & (rms_m[imass,:] != 0.))
    biais_mass[imass] = mean(biais_m[imass,:][z])
    ect_mass[imass] = mean(ect_m[imass,:][z])
    rms_mass[imass] = mean(rms_m[imass,:][z])

figure()
scatter(alt_moy_mass,biais_mass,c='b',label='BIAIS')
scatter(alt_moy_mass,ect_mass,c='c',label='ECT')
scatter(alt_moy_mass,rms_mass,c='r',label='RMS')
xlabel('altitude moyenne AROME de chaque massif (m)')
ylabel('Score statistique (cm) [HTN_SAFRAN - HTN_1DVar]')
legend(loc='best')
annotate('Oisans',xy=(1889.49,34.1626),xytext=(1915.32,37.5),arrowprops=dict(arrowstyle="->",
                                                                               connectionstyle="arc3"))
annotate('Alpes-Azur',xy=(1760.83,23.7467),xytext=(1765.,27.3438),arrowprops=dict(arrowstyle="->",
                                                                               connectionstyle="arc3"))
annotate('Chartreuse',xy=(744.106,19.0507),xytext=(746.774,22.9688),arrowprops=dict(arrowstyle="->",
                                                                               connectionstyle="arc3"))
annotate('Vercors',xy=(1040.,18.4375),xytext=(1045.23,21.875),arrowprops=dict(arrowstyle="->",
                                                                               connectionstyle="arc3"))
plot(arange(500,3600,100),np.zeros([31],float),'r')
xlim(500,2500)
tick_locs = arange(500,2500,100)
plt.xticks(tick_locs,tick_locs,rotation = 30)
grid()


##############################################
# Biais tous massif - par niveaux d altitude #
##############################################
niv_tot = ([600.,900.,1200.,1500.,1800.,2100.,2400.,2700.,3000.,3300.,3600.])
biais_niv = np.zeros([11,24],float)
bmoy = np.zeros([11],float)
emoy = np.zeros([11],float)
rmoy = np.zeros([11],float)
for ii in range (0,11):
    BIAIS_m = np.zeros([24],float)
    ECT_m = np.zeros([24],float)
    RMS_m = np.zeros([24],float)
    for imass in range (0,24):
        print nom_massif[imass]
        for iniv in range (0,len(DA[imass])):
            if DA[imass][iniv] == niv_tot[ii]:
                #HAUT_saf[imass,0:242] = haut_saf[imass,iniv,:]
                #HAUT_1D[imass,0:242] = haut_1D[imass,iniv,:]
                BIAIS_m[imass] = biais_m[imass,iniv]
                ECT_m[imass] = ect_m[imass,iniv]
                RMS_m[imass] = rms_m[imass,iniv]
    #htnsaf_moy[ii] = HAUT_saf[:,ii].mean()
    #htn1D_moy[ii] = HAUT_1D[:,ii].mean()
    bmoy[ii] = BIAIS_m.mean()
    emoy[ii] = ECT_m.mean()
    rmoy[ii] = RMS_m.mean()
    biais_niv[ii,0:24] = BIAIS_m[:]

figure()
plot(niv_tot,bmoy,label='BIAIS')
plot(niv_tot,emoy,label='ECT')
plot(niv_tot,rmoy,label='RMS')
legend(loc='best')
xticks(niv_tot,niv_tot,rotation=30)
xlabel('altitude (m)')
ylabel('Score statistique (cm) [HTN SAFRAN - HTN 1D-Var]')
xlim(600,3600)
grid()







biais_alt = np.zeros([24],float)
for imass in range (0,24):
    q = nonzero(biais_niv[:,imass] != 0.)
    biais_alt[imass] = biais_niv[:,imass][q].mean()
    figure()
    plot(DA[imass],biais_niv[:,imass][q])
    xticks(DA[imass],DA[imass])
    xlabel('altitude (m)')
    ylabel('biais (cm) [HTN SAFRAN - HTN 1D-Var]')
    grid()
    savefig('D:/output_Vfinale/impact_neige/Biais_htn_dec2009-juill2010_tous-niv/SAFRAN_1D-Var_massif_'+nom_massif[imass]+'.jpg')




