#! /usr/bin/env python
# -*- coding: utf-8 -*-

#################################
# Appel des modules necessaires #
#################################
import numpy as np
import matplotlib as mpl
import matplotlib.pyplot as plt
import string
from numpy import *
from mpl_toolkits.basemap import Basemap
from netCDF4 import Dataset
import scipy.optimize
from scipy.sparse import bsr_matrix
from mpl_toolkits.axes_grid1 import host_subplot


#####################
# Lecture des dates #
#####################
name_month = (['Dec2009','Jan2010','Feb2010','Mar2010','Apr2010','May2010','Jun2010','Jul2010'])
annee = (['09','10'])
list_mois = arange(1,9,1)
list_jour1 = arange(1,32,1)
list_jour2 = arange(1,32,1)
list_jour3 = arange(1,29,1)
list_jour4 = arange(1,32,1)
list_jour5 = arange(1,31,1)
list_jour6 = arange(1,32,1)
list_jour7 = arange(1,31,1)
list_jour8 = arange(1,32,1)
LST_JR = ([list_jour1,list_jour2,list_jour3,list_jour4,list_jour5,list_jour6,list_jour7,list_jour8])
lst_month = np.array([0,31,31+31,31+31+28,31+31+28+31,31+31+28+31+30,31+31+28+31+30+31,31+31+28+31+30+31+30,31+31+28+31+30+31+30+31])
        ####################################
        #initialisation (mois de decembre) #
        ####################################
jour_an = []
imo = 0
for ijr in range (0,len(LST_JR[imo])):
    nom_mois = '12'
    if (LST_JR[imo][ijr] <= 9):
        nom_jour = '0' + str(LST_JR[imo][ijr])
    else:
        nom_jour = str(LST_JR[imo][ijr])
    jour_an.append(annee[0] + nom_mois + nom_jour)

        #############################
        # mois de janvier a juillet #
        #############################
for imo in range (1,8):
    nom_mois = '0' + str(list_mois[imo]-1)
    for ijr in range (0,len(LST_JR[imo])):
        if (LST_JR[imo][ijr] <= 9):
            nom_jour = '0' + str(LST_JR[imo][ijr])
        else:
            nom_jour = str(LST_JR[imo][ijr])
        jour_an.append(annee[1] + nom_mois + nom_jour)

jour_an = np.array(jour_an)


############################
# Lecture des noms massifs #
############################
nbmassifs=24
fichier = open ('D:\data\safran\listeml_massifs.dat', 'r')
iligne = 0
nom_massif=np.zeros([nbmassifs],object)
while (iligne < nbmassifs) :
    line=fichier.readline()
    liste = line.split(',')
    nom_massif[iligne] = str(liste[1])
    iligne=iligne+1

         
fichier.close()


##############################
# Lecture des obs assimilees #
##############################
#imass = 6 # massif: maurienne
imass = 18 # massif: queyras
RAIN = np.zeros([8,31],float)
for imo in range (0,8):
    print 'mois:', name_month[imo]
    fichier_obs = open ('D:/output_Vfinale/data_for_1DVar/Dec2009-Juill2010/data_OBS_in_massif/data_obs_in_massif_'+nom_massif[imass]+'_'+name_month[imo]+'.txt', 'r')
    lines_obs = 0
    for line in fichier_obs: lines_obs += 1
    fichier_obs.close()
    no = lines_obs
    fichier_obs = open ('D:/output_Vfinale/data_for_1DVar/Dec2009-Juill2010/data_OBS_in_massif/data_obs_in_massif_'+nom_massif[imass]+'_'+name_month[imo]+'.txt', 'r')
    iligne = 0
    date_obs = np.zeros([no],object)
    massif_obs = np.zeros([no],object)
    indic_obs = np.zeros([no],object)
    lon_obs = np.zeros([no],float)
    lat_obs = np.zeros([no],float)
    alt_obs = np.zeros([no],float)
    rr_obs = np.zeros([no],float)
    while (iligne < no) :
        line = fichier_obs.readline()
        liste = line.split()
        date_obs[iligne] = str(liste[0])
        massif_obs[iligne] = str(liste[1])
        indic_obs[iligne] = str(liste[2])
        lon_obs[iligne] = float(liste[3])
        lat_obs[iligne] = float(liste[4])
        alt_obs[iligne] = float(liste[5])
        rr_obs[iligne] = float(liste[6])
        iligne = iligne+1     
    fichier_obs.close()
    rain = np.zeros([len(LST_JR[imo])],float)
    for ijr in range (0,len(LST_JR[imo])):
        print 'date:', jour_an[lst_month[imo]:lst_month[imo+1]][ijr]
        r = nonzero(date_obs == jour_an[lst_month[imo]:lst_month[imo+1]][ijr])
        z = nonzero((alt_obs[r] >= 1760.0) & (alt_obs[r] <= 1960.0))
        if shape(z)[1] == 0:
            print 'NOT IN FILE'
        else:
            print 'alti dans cette zone:', alt_obs[r][z]
            print 'pluie dans cette zone:', rr_obs[r][z]
        if shape(z)[1] == 1:
            print 'pluie dans cette zone:', rr_obs[r][z]
        else:
            if shape(z)[1] == 2:
                print 'pluie dans cette zone:', rr_obs[r][z]
            else:
                if shape(z)[1] == 3:
                    print 'pluie dans cette zone:', rr_obs[r][z]
