#!/usr/bin/env python
# -*- coding: utf-8 -*-
import string
import matplotlib.pyplot as pyplot #used to build contour and wind barbs plots
from numpy import *
import string
import numpy as np
import netCDF4
#from mpl_toolkits.basemap import shiftgrid, cm
from netCDF4 import Dataset
from pylab import *
from mpl_toolkits.basemap import Basemap
from mpl_toolkits.basemap import shiftgrid, cm
import ffgrid2
import trace

# ici je boucle sur les dates
list_anne=arange(2010,2011,1)
list_mois=arange(8,9,1)
list_jour=arange(1,32,1)

pluie_arome=np.zeros([31,421,661],float)
pluie_antilope=np.zeros([31,840,1248],float)

indice=0
mean_pluie=np.zeros([421,661],float)
mean_pluie0=np.zeros([421,661],float)

mean_pluie_anti=np.zeros([840,1248],float)
mean_pluie_anti0=np.zeros([840,1248],float)

newdim_arome=278281
newdim_antilope=1048320


for ian in range(0,1):
	for imo in range(0,1):
		for ijr in range(0,31):
                        if (list_mois[imo] <= 9):
                                nom_mois='0'+ str(list_mois[imo])
			else:
                                nom_mois= str(list_mois[imo])
				
			if (list_jour[ijr] <= 9):
                                nom_jour='0'+ str(list_jour[ijr])
			else:
                                nom_jour= str(list_jour[ijr])
			
			jour_an=str(list_anne[ian])+nom_mois+nom_jour
			print jour_an
			# lecture fichier arome
			fichier_netcdf='z:/arome/arome_grib_'+jour_an+'.nc'
			arome=Dataset(fichier_netcdf, 'r', format='NETCDF3_CLASSIC')
			nc_surf1= arome.variables['prevision6h humidite relative 2m']
			nc_surf2= arome.variables['prevision6h temperature 2m']
			nc_surf3= arome.variables['prevision6h nebul']
			nc_surf4= arome.variables['prevision30h nebul']
			nc_surf5= arome.variables['prevision6h TCWV']
			nc_surf6= arome.variables['prevision6h flux net solaire D']
			nc_surf7= arome.variables['prevision6h flux net thermique D']
			nc_surf8= arome.variables['analyse pression au sol']
			nc_surf9= arome.variables['prevision6h pression au sol']
			nc_surf10= arome.variables['analyse altitude']
			nc_surf11= arome.variables['prevision6h neige']
			nc_surf12= arome.variables['prevision30h neige']
			nc_surf13= arome.variables['prevision6h eau']
			nc_surf14= arome.variables['prevision30h eau']
			nc_surf15= arome.variables['prevision6h graupel']
			nc_surf16= arome.variables['prevision30h graupel']
			nc_surf17= arome.variables['prevision6h Vvent 10m']
			nc_surf18= arome.variables['prevision6h Uvent 10m']
			eau6h = nc_surf13[:]
			eau30h = nc_surf14[:]
			eau24h = eau30h - eau6h
			neige6h = nc_surf11[:]
			neige30h = nc_surf12[:]
			neige24h = neige30h - neige6h
			graupel6h = nc_surf15[:]
			graupel30h = nc_surf16[:]
			graupel24h = graupel30h - graupel6h
			rain = eau24h + graupel24h + neige24h
			lat=arome.variables['latitude'][:]
			lon=arome.variables['longitude'][:]
			arome.close()
                        # lecture du fichier antilope
                        anti_netcdf='z:/antilopeJ1/antilope_grib_'+jour_an+'.nc'
			antilope=Dataset(anti_netcdf, 'r', format='NETCDF3_CLASSIC')
			nc_surf1= antilope.variables['Quantite totale de precipitations (kg m**-2)']
			rain_anti = nc_surf1[:]
			lat_anti=antilope.variables['latitude'][:]
			lon_anti=antilope.variables['longitude'][:]
			antilope.close()
			#fin lecture fichier antilope
			pluie_arome[ijr,:,:]=rain[:,:]
			pluie_antilope[ijr,:,:]=rain_anti[:,:]
			if (ijr == 0):
                                mean_pluie[:,:] = rain[:,:]
                                mean_pluie_anti[:,:] = rain_anti[:,:]
                        else:
                                mean_pluie[:,:] = mean_pluie[:,:] + rain[:,:]
                                mean_pluie_anti[:,:] = mean_pluie_anti[:,:] + rain_anti[:,:]
                                indice=indice+1
                                


total_jours=indice
mean_pluie=mean_pluie/total_jours
mean_pluie_anti=mean_pluie_anti/total_jours

figure(2)
m = Basemap(llcrnrlon=-7,urcrnrlon=11,llcrnrlat=40,urcrnrlat=52,projection='cyl',resolution='h',fix_aspect=True)   
xii, yii = m(*np.meshgrid(lon,lat))
ax = plt.gca()
#clevs=arange(0,0.8,0.005)
clevs=arange(1,30,1)
m.drawcoastlines(linewidth=0.5)
m.drawlsmask(ocean_color='#F4EAF1', lakes=False)
cs=m.contourf(xii,yii,pluie_arome[0,:,:], clevs, cmap=cm.s3pcpn_l_r) # emissivity
cbar =colorbar(cs)
cbar.set_label('Precips 24h Aout 2010')
plt.show()
plt.savefig('pluie24h_antilope_aout2010.png')
close()


# calcul de correlations entre arome et antilope

data_arome = reshape(pluie_arome[0,:,:],(newdim_arome,1))[:,0]
xii, yii = np.meshgrid(lon,lat)
lon_arome = reshape(xii,(newdim_arome,1))[:,0]
lat_arome = reshape(yii,(newdim_arome,1))[:,0]

xii, yii = np.meshgrid(lon_anti,lat_anti)
data_antilope = reshape(pluie_antilope[0,:,:],(newdim_antilope,1))[:,0] 
lon_antilope = reshape(xii,(newdim_antilope,1))[:,0]
lat_antilope = reshape(yii,(newdim_antilope,1))[:,0]
                        
x0, x1 = -7, 11
y0, y1 = 40, 52
z0=0
z1=30
dx=1
dy=1

outz_arome, outx_arome, outy_arome = ffgrid2.ffgrid(lon_arome, lat_arome, data_arome, dx, dy, x0,x1,y0,y1,z0, z1)
outz_antilope, outx_antilope, outy_antilope = ffgrid2.ffgrid(lon_antilope, lat_antilope, data_antilope, dx, dy, x0,x1,y0,y1,z0, z1)

trace.draw(outz_arome, outx_arome, outy_arome, 'test.png', 'RAIN (mm)', 0,30,1,cm.StepSeq)

tempo_arome= reshape(outz_arome[:,:],(247,1))[:,0]
tempo_antilope= reshape(outz_antilope[:,:],(247,1))[:,0]
			

